#ifndef _COMHEAD_H
#define _COMHEAD_H
// (C) 1993,1994 by Heiko Damerow MPG AG "Roentgenbeugung"
// File comhead.h
#include <cstring.h>
#include <windowsx.h>
#include <mmsystem.h>
#include <ctl3d.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <dos.h>
#include <time.h>
#include <dir.h>
#include <new.h>
#include <_defs.h>
#include <typeinfo.h>
#include <commdlg.h>

#define MaxString 80
#define MBINFO    (MB_OK | MB_ICONINFORMATION)
#define MBASK     (MB_YESNO | MB_ICONQUESTION)
#define MBFAILURE (MB_OK | MB_ICONHAND)
#define MBSTOP    (MB_OK | MB_ICONSTOP)
#define YES        TRUE
#define NO         FALSE
#define ON         TRUE
#define OFF        FALSE

#define O_Common     0x0004
#define O_PaintPoint 0x0020
#define O_Flush      0x0040

#define thekey 1335

// Identifikation der Timer
#define DeviceTimerIdStart   100
#define MotorTimerIdStart    200
#define GenericTimerIdStart  300
#define   TimerIdSteering    398
#define   TimerIdInformation 399


typedef enum
{ 
  StandardScan = 1, Omega2ThetaScan, ContinuousScan, PsdEnergyScan, 
      PsdPositionScan, Omega2ThetaScanList, ScanList
} TxScanType;

typedef enum
{
  CounterDevice = 1, PsdDevice, MonitorDevice, EncoderDevice, GenericDevice
} TDeviceType;

typedef enum
{
  X = 1, Y, Z, Omega, Theta, Phi, Psi, Encoder, Absorber, Tilt, Collimator, 
      Rotation, Monochromator, DC, DF
} TAxisType;

// TScanType
// TAreaScanType

typedef enum
{ 
  FinalRead = 1, FirstRead, AccumulationRead, IntermediateRead
} THowReadOutPsd;

typedef enum
{ 
  PsdEnergyData = 3000, PsdPositionData
} TPsdDataType;

typedef enum
{ 
  NothingHW = 2000, RadiconHW, BraunHW, GenericPsdHW, Am9513HW, StoeHW, 
      MatroxHW, EncoderHW
} THardware;

typedef enum
{ 
  HRM = 1, RTK, ScanTable, PDI_Diffractometer, Diff2, Diff3, Expert
} TWorkPlace;

typedef enum
{
  InquireCCDLine = 1, LineStepScan, LineContinuousScan, NoTask,
      StartCCDLineAgain
} TScannerTask;

typedef enum
{
  ThisPosition = 1, OldPosition, WaitExecution, NoWait
} TMParameter;

typedef enum
{
  Si = 1, Ge, GaAs, SiGe, InP
} TBulkType;

typedef enum
{
  MonitorIntensity = 1, AbsorberPosition, PeakPosition, IntegralIntensity, 
      MeasurementTime
} TNotifyValue;

typedef enum
{
  Logarithmic = 1, Linear, User
} TScaleType;

typedef enum
{
  Grad = 1, Minuten, Sekunden, Millimeter, Mikrometer, Channel, None
} TUnitType;

typedef enum
{
  Distance = 1, Width, Speed, MinDistance, MaxDistance
} TValueType;

typedef enum
{
  StandardFile = 1, ShiftedStandard, Tripel, Tupel, Bitmap, ShiftedBitmap,
      Tiff8, Tiff12, RAW8, RAW12
} TSaveFormat;

typedef struct
{
  float MinX;
  float MaxX;
  float MinY;
  float MaxY;
  int   XPoints;
  int   YPoints;
} TFrameDimension;

typedef struct
{
  int   h, k, l;
} THKL;

typedef struct
{
  int     xo, yo, dx, dy;
  int     xBorder, yBorder;
  float   xMin, xMax, yMin, yMax;
  char    xUnit[15], yUnit[15];
} TFrameParam;

typedef struct
{
  RECT  place;
  float zMin, zMax;
  char  zUnit[15];
  float ColorMap[16];
  int   nColorRange;
} TColorTable;

typedef struct
{
  BOOL  bLogarithmicY;
  float fMinX, fMaxX, fMinY, fMaxY;
} TKSProperties;

typedef struct
{
  float x, y;
  int   Ord;
} TKSystem[4];

#define RET      '\r'
#define EOL      "\r\n"
#define ETX      '\3'
#define P_X      0
#define P_Y      1
#define P_Z      2
#define P_I      3
#define P_H      4

//*** Return-Codes
#define  R_Stopped         200
#define  R_Started         201
#define  R_Failure         202
#define  R_NoWindow        203
#define  R_InvalidFile     204
#define  R_MeasInProcess   205
#define  R_MeasOk          206
#define  R_MeasStop        207
#define  R_NoCommunication 208
#define  R_NoMemory        209
#define  R_NoMfSelected    210
#define  R_Restarted       211
#define  R_Interrupted     212
#define  R_DataValid       213
#define  R_TimeOut         214
#define  R_UnknownCmd      215
#define  R_SoftOverflow    216
#define  R_HardOverflow    217
#define  R_Overflow        218
#define  R_EndOfFile       219

#define  R_OK              999
#include "comclass.h"
#include "dlg_tpl.h"
#include "m_curve.h"
#include "l_layer.h"

void GetHKL( THKL& refl, LPSTR info );
void SetHKL( THKL& refl, LPCSTR info );

#if defined(__FLAT__)
 typedef char*  HPSTR;
 typedef BYTE*  HPBYTE;
 typedef float* HPFLOAT;
 typedef WORD*  HPWORD;
#else
 typedef char  _huge * HPSTR;
 typedef BYTE  _huge * HPBYTE;
 typedef float _huge * HPFLOAT;
 typedef WORD  _huge * HPWORD;
#endif
#endif
// __LastLine__
