#ifndef _DLG_TPL_H
#define _DLG_TPL_H
// (C) Copyright 1993 by Heiko Damerow MPG AG "Roentgenbeugung"
// File comclass.h

extern "C" {
BOOL CALLBACK _export DialogProc( HWND, UINT, WPARAM, LPARAM );
BOOL CALLBACK _export ModelessProc( HWND, UINT, WPARAM, LPARAM );
}

class TModalDlg;
class TModeless;

class __rtti TModalDlg
{
  friend BOOL CALLBACK DialogProc( HWND, UINT, WPARAM, LPARAM );
 public:
               TModalDlg( char* DlgName );
  HWND         GetHandle( void )
      { return hWindow; };
  virtual      ~TModalDlg( void );
  virtual int  ExecuteDialog( HWND );
 protected:
  virtual BOOL Dlg_OnInit( HWND, HWND, LPARAM );
  virtual void Dlg_OnCommand( HWND, int, HWND, UINT );
  virtual void Dlg_OnHScrollBar( HWND, HWND, UINT, int )
      {};
  virtual void Dlg_OnVScrollBar( HWND, HWND, UINT, int )
      {};
  virtual void Dlg_OnTimer( HWND, UINT )
      {};
  private:
  virtual BOOL CanClose( void );
  virtual void Interrupt( void )
      {};
  virtual BOOL LeaveDialog( void )
      { return TRUE; };
  HWND         hWindow;
  HINSTANCE    hInstance;
  FARPROC      dialogFunc;
  char         RC_Name[MaxString];
  TModalDlg*   dlgInstance;
  BOOL         bCallUp;
  BOOL         bCanOpen;
};

class __rtti TModelessDlg
{
  friend BOOL CALLBACK ModelessProc( HWND, UINT, WPARAM, LPARAM );
 public:      
               TModelessDlg( char* DlgName );
  virtual      ~TModelessDlg( void );
  HWND         GetHandle( void )
      { return hWindow; };
  BOOL         Initialize( void );
 protected:
  virtual BOOL Dlg_OnInit( HWND, HWND, LPARAM );
  virtual void Dlg_OnCommand( HWND, int, HWND, UINT );
  virtual void Dlg_OnSetFocus( HWND, HWND )
      {};
  virtual void Dlg_OnKillFocus( HWND, HWND )
      {};
  virtual void Dlg_OnMouseActivate( HWND, int, HWND, UINT )
      {};
  virtual void Dlg_OnMouseMove( HWND, int, HWND, UINT )
      {};
  virtual void Dlg_OnHScrollBar( HWND, HWND, UINT, int )
      {};
  virtual void Dlg_OnVScrollBar( HWND, HWND, UINT, int )
      {};
  virtual void Dlg_OnTimer( HWND, UINT )
      {};
  virtual void Dlg_OnLButtonUp( HWND, int, int, UINT )
      {};
  virtual int  Dlg_OnMouseActivate( HWND, HWND, UINT, UINT )
      { return 1; }
  virtual BOOL CanClose( void );
  BOOL         bCanOpen;
 private:
  virtual void Interrupt( void )
      {};
  virtual BOOL LeaveDialog( void )
      { return TRUE; };
  HWND         hWindow;
  DLGPROC      dialogFunc;
  char         RC_Name[MaxString];
  TModelessDlg* dlgInstance;
  BOOL         bCallUp;
};
#endif
// __LastLine__

