#include	"comhead.h"
#include	"rc_def.h"
#pragma hdrstop

#include    "m_devcom.h"
#include		"m_devhw.h"
#include		"c_layer.h"
#include		"m_layer.h"
#include 		"dfkisl.h"

//hpp***************************************************************************
#include <time.h>
//pph***************************************************************************

//hpp***************************************************************************
FILE *trace;
time_t *zidx;
//pph***************************************************************************

extern  "C" 	  WINAPI __0040h(void);
#ifndef __WIN32__
LPSTR 				  pTime = (LPSTR)MK_FP(FP_OFF(__0040h),0x006c);
#else
LPSTR 				  pTime;
#endif

HINSTANCE   hModuleInstance;
static  char        dlVersion[] = "V 1.52 ("__DATE__")";

const   int         nMaxDeviceAllowed = 3;
static  int 				bModulLoaded = FALSE;
extern  LPDList     lpDList;
static  HINSTANCE   hMotorDll;

static 	int       retval;
				int   		Failure;
extern	LPDList   lpDList;

//******** SCS *****************************************************************
int 					  FakeDevice = 0;
int 					  FakeData;
static  int		  rdd,rcc;
static  HWND    hControlWnd;
static  float	  Intensity_SCS;
static  DWORD	  expcounts;
static  UINT    nEvent;
static  int     Cycle;

//********* Code ***************************************************************

#pragma argused
int WINAPI LibMain(HINSTANCE inst,WORD,WORD,LPSTR)
	{
//hpp***************************************************************************
trace = fopen("trace.ctr","w");
setbuf(trace,(char*)NULL);
//pph***************************************************************************
//hpp***************************************************************************
fprintf(trace,"%u		c_layer.cpp		LibMain(HINSTANCE inst,WORD,WORD,LPSTR)\n",time(zidx));
//pph***************************************************************************
	bModulLoaded = FALSE;
	hModuleInstance = inst;
	lpDList = (LPDList)new TDList(nMaxDeviceAllowed,inst);
	hMotorDll = GetModuleHandle("motors.dll");
	return -1;
	};

int CALLBACK WEP(int)
	{
//hpp***************************************************************************
fprintf(trace,"%u		c_layer.cpp		WEP(int)\n",time(zidx));
//pph***************************************************************************
	bModulLoaded = FALSE;
	return 1;
	};


LPCSTR  _export WINAPI dlGetVersion(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		c_layer.cpp		dlGetVersion(void)\n",time(zidx));
//pph***************************************************************************
	return (LPCSTR)dlVersion;
	};

HINSTANCE _export WINAPI dlGetInstance(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		c_layer.cpp		dlGetInstance(void)\n",time(zidx));
//pph***************************************************************************
	return hModuleInstance;
	};

BOOL _export WINAPI InitializeCountersDLL(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		c_layer.cpp		InitializeCountersDLL(void)\n",time(zidx));
//pph***************************************************************************
	bModulLoaded = TRUE;
	return lpDList->InitializeModule();
	};

LPDList _export WINAPI GetCounterListPtr(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		c_layer.cpp		GetCounterListPtr(void)\n",time(zidx));
//pph***************************************************************************
	if(!bModulLoaded) return NULL;
	return (LPDList)lpDList;
	};

BOOL _export WINAPI dlSetDevice(int device)
	{
//hpp***************************************************************************
fprintf(trace,"%u		c_layer.cpp		dlSetDevice(int device)\n",time(zidx));
//pph***************************************************************************
	if(lpDList->SetDevice(device))
		return TRUE;
	lpDList->SetDevice(0);
	return FALSE;
	};

int _export WINAPI dMeasureStart(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		c_layer.cpp		dMeasureStart(void)\n",time(zidx));
//pph***************************************************************************
	return lpDList->DP()->MeasureStart();
	};

int _export WINAPI dMeasureStop(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		c_layer.cpp		dMeasureStop(void)\n",time(zidx));
//pph***************************************************************************
	return lpDList->DP()->MeasureStop();
	};

BOOL _export WINAPI dSetExposureValues(float ftime,DWORD counts,float fl)
	{
//hpp***************************************************************************
fprintf(trace,"%u		c_layer.cpp		dSetExposureValues(float time,DWORD counts,float fl)\n",time(zidx));
//pph***************************************************************************
	return lpDList->DP()->SetExposureValues(ftime,counts,fl);
	};

BOOL _export WINAPI dGetExposureValues(float& ftime,DWORD& counts,float& fl)
	{
//hpp***************************************************************************
fprintf(trace,"%u		c_layer.cpp		dGetExposureValues(float& time,DWORD& counts,float& fl)\n",time(zidx));
//pph***************************************************************************
	lpDList->DP()->GetExposureValues(ftime,counts,fl);
  return TRUE;
	};

int _export WINAPI dlGetDevice(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		c_layer.cpp		dlGetDevice(void)\n",time(zidx));
//pph***************************************************************************
	return lpDList->GetDevice();
	};


int TDList::GetIdByName(TDeviceType at)
	{
//hpp***************************************************************************
fprintf(trace,"%u		c_layer.cpp		TDList::GetIdByName(TDeviceType at)\n",time(zidx));
//pph***************************************************************************
	int id = -1;

	switch(at) {
		case CounterDevice: id = lpDList->MD_Counter;		break;
		case MonitorDevice: id = lpDList->MD_Monitor;  	break;
		case PsdDevice:     id = lpDList->MD_Psd; 			break;
		case GenericDevice:	id = lpDList->MD_Generic; 	break;
		case EncoderDevice:	id = lpDList->MD_Encoder; 	break;
		}
	return id;
	};

int _export WINAPI dlGetIdByName(TDeviceType at)
	{
//hpp***************************************************************************
fprintf(trace,"%u		c_layer.cpp		dlGetIdByName(TDeviceType at)\n",time(zidx));
//pph***************************************************************************
	return lpDList->GetIdByName(at);
	};

TDeviceType _export WINAPI dlParsingDevice(LPSTR devicename)
	{
//hpp***************************************************************************
fprintf(trace,"%u		c_layer.cpp		dlParsingDevice(LPSTR devicename)\n",time(zidx));
//pph***************************************************************************
	return lpDList->ParsingAxis(devicename);
	};

BOOL TDList::IsDeviceValid(TDeviceType type)
	{
//hpp***************************************************************************
fprintf(trace,"%u		c_layer.cpp		TDList::IsDeviceValid(TDeviceType type)\n",time(zidx));
//pph***************************************************************************
	switch(type) {
		case CounterDevice:	return (lpDList->MD_Counter > -1);
		case PsdDevice:     return (lpDList->MD_Psd > -1);
		case MonitorDevice: return (lpDList->MD_Monitor > -1);
		case EncoderDevice: return (lpDList->MD_Encoder > -1);
		default:						return FALSE;
		}
	};

BOOL _export WINAPI	dlIsDeviceValid(TDeviceType type)
	{
//hpp***************************************************************************
fprintf(trace,"%u		c_layer.cpp		dlIsDeviceValid(TDeviceType type)\n",time(zidx));
//pph***************************************************************************
	return lpDList->IsDeviceValid(type);
	};
//******************************************************************************
TDeviceType TDList::ParsingAxis(LPSTR devicename)
	{
//hpp***************************************************************************
fprintf(trace,"%u		c_layer.cpp		TDList::ParsingAxis(LPSTR devicename)\n",time(zidx));
//pph***************************************************************************
	if(	!strcmp(devicename,"Counter") || !strcmp(devicename,"Zhler"))
		return CounterDevice;
	if(	!strcmp(devicename,"Monitor"))
		return MonitorDevice;
	if(	!strcmp(devicename,"Psd") || !strcmp(devicename,"PSD"))
		return PsdDevice;
	if(	!strcmp(devicename,"Encoder"))
		return EncoderDevice;
	return (TDeviceType)GenericDevice;
	};

void TDList::SetParametersDlg(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		c_layer.cpp		TDList::SetParametersDlg(void)\n",time(zidx));
//pph***************************************************************************
	TModalDlg* dlg;

	dlg = (TCommonDevParam *)new TCommonDevParam(lpDList->GetDevice());
	dlg->ExecuteDialog(GetFrameHandle());
	delete dlg;
	};

void CALLBACK _export InquireIntensity_SCS(UINT nEvent,UINT,DWORD,DWORD,DWORD)
	{
//hpp***************************************************************************
fprintf(trace,"%u		c_layer.cpp		InquireIntensity_SCS(UINT nEvent,UINT,DWORD,DWORD,DWORD)\n",time(zidx));
//pph***************************************************************************
	double		time = 1;
	DWORD			counts = 1000;

	timeKillEvent(nEvent);
	retval = getinf(11,rdd,rcc,&time,&counts);
	if((retval != -4) && (retval != 0))
		return;
	retval = begwrk(5,rdd,rcc);
	if(time != 0.0)
		lpDList->DP()->fIntensity = (expcounts-counts) / time;
		else
		lpDList->DP()->fIntensity = 0.0;
	if(hControlWnd != NULL)
		// Daten-Empfnger benachrichtigen
		PostMessage(hControlWnd,WM_COMMAND,cm_CounterSet,77);
	};

float	WINAPI _export GetIntensity_SCS(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		c_layer.cpp		GetIntensity_SCS(void)\n",time(zidx));
//pph***************************************************************************
	return Intensity_SCS;
	};

//******** TDC *****************************************************************
static float	Intensity_TDC;

void CALLBACK _export InquireIntensity_TDC(UINT nEvent,UINT,DWORD,DWORD,DWORD)
	{
//hpp***************************************************************************
fprintf(trace,"%u		c_layer.cpp		InquireIntensity_TDC(UINT nEvent,UINT,DWORD,DWORD,DWORD)\n",time(zidx));
//pph***************************************************************************
	double    	angx,angy=0,angz=0;

	if(!Cycle--)
		{
		timeKillEvent(nEvent);
		PostMessage(hControlWnd,WM_COMMAND,cm_SteeringReady,77);
		return;
		}
	Intensity_TDC = 0.0;

	if(mGetDistance(angx))
		{
		angx = angx * angx / 11.3;
		Intensity_TDC = 1/(1 + 1.8 * pow(angx,2) + 0.001 * pow(angy,2) + \
											 0.001 * pow(angz,2));
		Intensity_TDC *= 32000;
		Intensity_TDC += (rand() % 80) + 270;
		}
	// Daten-Empfnger benachrichtigen
	PostMessage(hControlWnd,WM_COMMAND,cm_CounterSet,77);
	};

BOOL	WINAPI _export InitializeTDC_Event(float ftime,HWND contolwnd)
	{
//hpp***************************************************************************
fprintf(trace,"%u		c_layer.cpp		InitializeTDC_Event(float time,HWND contolwnd)\n",time(zidx));
//pph***************************************************************************
	UINT  tic = (UINT)(ftime*1000);

	hControlWnd = contolwnd;
	Cycle = 100;
	timeBeginPeriod(1);
	if(tic < 1) tic = 1;
	nEvent = timeSetEvent(tic,1,(LPTIMECALLBACK)InquireIntensity_TDC,0,TIME_PERIODIC);
	return TRUE;
	};

float	WINAPI _export GetIntensity_TDC(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		c_layer.cpp		GetIntensity_TDC(void)\n",time(zidx));
//pph***************************************************************************
	return Intensity_TDC;
	};

//******** A913 ****************************************************************
static float	Intensity_A913;

void CALLBACK _export InquireIntensity_A913(UINT nEvent,UINT,DWORD,DWORD,DWORD)
	{
//hpp***************************************************************************
fprintf(trace,"%u		c_layer.cpp		InquireIntensity_A913(UINT nEvent,UINT,DWORD,DWORD,DWORD)\n",time(zidx));
//pph***************************************************************************
	//! double		time = 1;
	//! DWORD			counts = 1000;

	timeKillEvent(nEvent);
	Intensity_A913 = 1.0;
	if(hControlWnd != NULL)
		// Daten-Empfnger benachrichtigen
		PostMessage(hControlWnd,WM_COMMAND,cm_CounterSet,77);
	};

float	WINAPI _export GetIntensity_A913(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		c_layer.cpp		GetIntensity_A913(void)\n",time(zidx));
//pph***************************************************************************
	return Intensity_A913;
	};

//******************************************************************************
// __LastLine__

