#include    "rc_def.h"
#include    "comhead.h"
#pragma hdrstop

//hpp***************************************************************************
#include <time.h>
//pph***************************************************************************

//hpp***************************************************************************
extern FILE *trace;
extern time_t *zidx;
//pph***************************************************************************

// counters.cpp
// (C) 1993,1994 by Radicon Ltd.
// (C) 1993, 1995 by Heiko Damerow MPG AG "Rntgenbeugung"
#include    "m_devcom.h"
#include    "m_devhw.h"
#include		"c_layer.h"
#include		"m_layer.h"

#include <iostream.h>
#include <string.h>
#include <typeinfo.h>


#define IoWaitStoe 42

const   int 		Tx = 0;
				LPDList lpDList;
				int 		TDevice::nMaxId 			= -1;

// time event handling
static 	int 		nEventCalls;
static 	int			nEvent;
static 	int			nCalledEvents;
static	float   fEventIntensity;
static	float   fEventSigma;
static	HWND   	hEventControlWnd;
static	BOOL		bEventDataValid;
static	BOOL		bEventDeviceActive;

//******** Radicon *************************************************************
static  int			MaxHighVoltage = 900;
static	int 		retval;
				int 		TRadicon::Rdd = 0x100;
				int 		TRadicon::Rcc	= 0x101;

//******************************************************************************
//########### Methoden zum Verwalten der Gerte ################################
//******************************************************************************
TDList::TDList(int maxn,HINSTANCE inst)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TDList::TDList(int maxn,HINSTANCE inst)\n",time(zidx));
//pph***************************************************************************
	MD_Generic			= -1;
	MD_Counter			= -1;
	MD_Psd					= -1;
	MD_Monitor			= -1;
	MD_Encoder			= -1;
	nActiveDevice		= -1;
	nLastDevice			= -1;
	nMaxNumber 			= maxn;
	hDInstance      = inst;
	aDevice = new TDevice* [nMaxNumber];
	};

TDList::~TDList(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TDList::~TDList(void)\n",time(zidx));
//pph***************************************************************************
	if(nLastDevice < 0) return;
	do
		{
		switch(aDevice[nLastDevice]->GetHardware()) {
			case EncoderHW:
			delete (TEncoder*)aDevice[nLastDevice];
			break;

			case RadiconHW:
			delete (TRadicon*)aDevice[nLastDevice];
			break;

			case BraunHW:
			delete (TBraun_Psd*)aDevice[nLastDevice];
			break;

			case GenericPsdHW:
			delete (TPsd*)aDevice[nLastDevice];
			break;

			case StoeHW:
			delete (TStoe_Psd*)aDevice[nLastDevice];
			break;

			case Am9513HW:
			delete (TGenericDevice*)aDevice[nLastDevice];
			break;

			case NothingHW:
			delete aDevice[nLastDevice];
			break;
			}
		}
		while(nLastDevice--);
	delete[] aDevice;
	};

BOOL TDList::DeleteDevices(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TDList::DeleteDevices(void)\n",time(zidx));
//pph***************************************************************************
	return TRUE;
	};

BOOL TDList::InitializeModule(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TDList::InitializeModule(void)\n",time(zidx));
//pph***************************************************************************
	int 		id;
	BOOL		bNoFailure = TRUE;
	char  	Ident[MaxString],buf[MaxString];

	nActiveDevice = 0;
	//*** build of device list
	id = 0;
	do
		{
		sprintf(Ident,"Device%d",id);
		GetPrivateProfileString(Ident,"Type","",buf,MaxString,GetCFile());
		if(strlen(buf) < 2) break;
		if(strstr(strupr(buf),"GENERIC"))
			{
			aDevice[id] = (TGenericDevice*)new TGenericDevice(); goto EntryFound;
			}
		if(strstr(strupr(buf),"STOE-PSD"))
			{
			aDevice[id] = (TStoe_Psd*)new TStoe_Psd(); goto EntryFound;
			}
		if(strstr(strupr(buf),"RADICON"))
			{
			aDevice[id] = (TRadicon*)new TRadicon(); goto EntryFound;
			}
#ifdef	CCD_Extension
		if(strstr(strupr(buf),"MATROX"))
			{
			aDevice[id] = (TMatrox*)new TMatrox(); goto EntryFound;
			}
#endif
		if(strstr(strupr(buf),"BRAUN-PSD"))
			{
			aDevice[id] = (TBraun_Psd*)new TBraun_Psd(); goto EntryFound;
			}
		if(strstr(strupr(buf),"PSD"))
			{
			aDevice[id] = (TPsd*)new TPsd(); goto EntryFound;
			}
		if(strstr(strupr(buf),"ENCODER"))
			{
			aDevice[id] = (TEncoder*)new TEncoder(); goto EntryFound;
			}
		aDevice[id] = new TDevice();
EntryFound:
		aDevice[id]->hWndFrame = GetFrameHandle();
		nLastDevice = id++;
		}
	while(id < nMaxNumber);
	if(nLastDevice > -1)
		nActiveDevice = 0;
	//************* Initialisierung der Me-Einheiten*** ***********************
	for(id = 0;id <= LastId();id++)
		{
		sprintf(buf,"Initialisieren von %s",DP(id)->Characteristic);
		SetInfo(buf);
		if(R_OK != DP(id)->Initialize())
			{
			sprintf(buf,"Einheit %s defekt oder nicht vorhanden. ", \
							DP(id)->Characteristic);
			MessageBox(GetFocus(),buf,"Device-Fehler",MBSTOP);
			// prevents all accesses to the failureable device
			delete aDevice[id];
			aDevice[id] = new TDevice();
			DP(id)->Initialize();
			bNoFailure = FALSE;
			continue;
			}
		}
	// Namen vergeben
	for(id = 0;id <= LastId();id++)
		{
		switch(ParsingAxis(DP(id)->Characteristic)) {
			case PsdDevice: 		MD_Psd = id; 			break;
			case EncoderDevice: MD_Encoder = id; 	break;
			case CounterDevice: MD_Counter = id; 	break;
			case MonitorDevice: MD_Monitor = id; 	break;
			case GenericDevice: default:
			if(-1 != MD_Generic)
				MD_Generic = id;
			break;
			}
		}
	return bNoFailure;
	};

TDevice *TDList::DP(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		*TDList::DP(void)\n",time(zidx));
//pph***************************************************************************
	return aDevice[nActiveDevice];
	};

TDevice *TDList::DP(int n)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		*TDList::DP(int n)\n",time(zidx));
//pph***************************************************************************
	if((n >= 0) && (n <= nLastDevice))
		return aDevice[n];
	return aDevice[nActiveDevice];
	};

BOOL TDList::SetDevice(int n)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TDList::SetDevice(int n)\n",time(zidx));
//pph***************************************************************************
	if((n >= 0) && (n <= nLastDevice))
		{
		nActiveDevice = n;
		return TRUE;
		}
		else
		{
		nActiveDevice = 0;
		return FALSE;
		}
	};

//******************************************************************************
TDevice::TDevice()
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TDevice::TDevice()\n",time(zidx));
//pph***************************************************************************
	char    Ident[MaxString];
	char    buf[MaxString];

	nDevId                   = ++TDevice::nMaxId;
	bDeviceOk                = TRUE; // any changes to FALSE detects an error
	fExposureTime            = 0.7; // Sekunden
	dwExposureCounts         = 20000l;
	fFailure                 = 0.05;
	fLowerTimeBound          = 0.1; // Sekunden
	fUpperTimeBound          = 500.0;
	dwLowerCountBound        = 1;
	dwUpperCountBound        = 300000l;
	nPeakWindow              = 15;  // Prozent
	nPeakLevel               = 13;  // Prozent
	fIntensity               = 1.0;
	fSigma                   = 0.1;
	bSound                   = ON;
	bDataValid							 = FALSE;
	nFunctionId              = D_ImpulseCounting;
	bAnalysator              = TRUE;
	bDiskriminator           = !bAnalysator;
	bDeviceActive            = FALSE;
	bDeviceOpen              = FALSE;
	bStaticFailure           = FALSE;
	hWndFrame								 = GetFrameHandle();
	hControlWnd              = NULL;
	hDisplayWnd              = NULL;
	uAskTime 								 = 300;
	wpJumpTo                 = cm_CounterSet;
	sprintf(Ident,"Device%d",nDevId);
	GetPrivateProfileString(Ident,"Name","Counter",Characteristic,MaxString,GetCFile());
	if(CreateDefaults())
		WritePrivateProfileString(Ident,"Name",Characteristic,GetCFile());
	GetPrivateProfileString(Ident,"Sound","1",buf,MaxString,GetCFile());
	bSound = atoi(buf);
	};

TDevice::~TDevice()
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TDevice::~TDevice()\n",time(zidx));
//pph***************************************************************************
	char    Ident[MaxString];
	char		buf[MaxString];

	sprintf(Ident,"Device%d",nDevId);
	sprintf(buf,"%.2f",fExposureTime);
	WritePrivateProfileString(Ident,"ExposureTime",buf,GetCFile());
	sprintf(buf,"%ld",dwExposureCounts);
	WritePrivateProfileString(Ident,"ExposureCounts",buf,GetCFile());
	sprintf(buf,"%d",bSound);
	WritePrivateProfileString(Ident,"Sound",buf,GetCFile());
	bSound = FALSE;
	SetSound();
	TDevice::nMaxId--;
	};

int TDevice::SetExposureValues(float et,DWORD ec,float ef)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TDevice::SetExposureValues(float et,DWORD ec,float ef)\n",time(zidx));
//pph***************************************************************************
	BOOL	bWasActive = IsActive();
	fExposureTime = et;
	dwExposureCounts = ec;
	fFailure = ef;
	MeasureStop();
	if(R_OK != SetParameters())
		return 0;
	if(bWasActive)
		MeasureStart();
	return 1;
	};

void TDevice::GetExposureValues(float& et,DWORD& ec,float& ef)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TDevice::GetExposureValues(float& et,DWORD& ec,float& ef)\n",time(zidx));
//pph***************************************************************************
	et = fExposureTime;
	ec = dwExposureCounts;
	ef = fFailure;
	};

double TDevice::CalcTime(DWORD mssum)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TDevice::CalcTime(DWORD mssum)\n",time(zidx));
//pph***************************************************************************
	long   sec,ms;

	sec     = mssum / 1000l;
	ms      = mssum % 1000l;
	return ((double)sec + ms / 1000.0);
	};

int TDevice::Initialize(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TDevice::Initialize(void)\n",time(zidx));
//pph***************************************************************************
	char    Ident[MaxString];
	char		buf[MaxString];

	sprintf(Ident,"Device%d",nDevId);
	GetPrivateProfileString(Ident,"Debug","0",buf,MaxString,GetCFile());
	bDebug = atoi(buf);
	if(CreateDefaults())
		WritePrivateProfileString(Ident,"Debug",buf,GetCFile());
	GetPrivateProfileString(Ident,"ExposureTime","4.0",buf,MaxString,GetCFile());
	fExposureTime = atof(buf);
	if(CreateDefaults())
		WritePrivateProfileString(Ident,"ExposureTime",buf,GetCFile());
	GetPrivateProfileString(Ident,"ExposureCounts","10000",buf,MaxString,GetCFile());
	dwExposureCounts = atol(buf);
	if(CreateDefaults())
		WritePrivateProfileString(Ident,"ExposureCounts",buf,GetCFile());
	eHardware = NothingHW;
	PushSettings();
	return R_OK;
	};

CALLBACK TDevice::EventHandler(UINT,UINT,DWORD,DWORD,DWORD)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TDevice::EventHandler(UINT,UINT,DWORD,DWORD,DWORD)\n",time(zidx));
//pph***************************************************************************
	double  angx;

	nCalledEvents++;
	// mlGetDistance(angx);
	angx = (nCalledEvents - nEventCalls / 2) * 0.246;
	angx = angx * angx / 11.3;
	fEventIntensity = 1 /(1 + 1.8 * pow(angx,2));
	fEventIntensity *= 32000;
	fEventIntensity += (rand() % 80) + 270;
	if(fEventIntensity == 0.0)
		fEventSigma = 1.0;
		else
		fEventSigma = sqrt(fEventIntensity) * 0.9 / fEventIntensity;
	if(nCalledEvents == nEventCalls)
		{
		timeKillEvent(nEvent);
		PostMessage(hEventControlWnd,WM_COMMAND,cm_SteeringReady,0l);
		bEventDataValid = FALSE;
		}
		else
		PostMessage(hEventControlWnd,WM_COMMAND,cm_CounterSet,nCalledEvents);
	return R_OK;
	};

BOOL TDevice::InitializeEvent(HWND hwnd,int ec)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TDevice::InitializeEvent(HWND hwnd,int ec)\n",time(zidx));
//pph***************************************************************************
	int			EventTime = 1000.0 * fExposureTime;

	hControlWnd 	= hwnd;
	nCalledEvents = 0;
	nEventCalls 	= ec;
	// check calltime
	if(EventTime <= 100)
		{
		MessageBox(GetFocus(),"Mezeit wurde zu klein gewhlt !","InitializeEvent",MBINFO);
		return FALSE;
		}
	if(NULL != hControlWnd)
		nEvent = timeSetEvent(EventTime,1,(LPTIMECALLBACK)TDevice::EventHandler,0,TIME_PERIODIC);
	bDataValid = FALSE;
	return TRUE;
	};


void TDevice::UpdateDisplay(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TDevice::UpdateDisplay(void)\n",time(zidx));
//pph***************************************************************************
	if(NULL != hDisplayWnd)
		FORWARD_WM_COMMAND(hDisplayWnd,cm_CounterSet,0,0,SendMessage);
	};

int TDevice::GetData(float &data)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TDevice::GetData(float &data)\n",time(zidx));
//pph***************************************************************************
	data = 0.0;
	if(!bDataValid)
		return R_Failure;
	data = fIntensity;
	if(fIntensity == 0.0 )
		fSigma = 1.0;
		else
		fSigma = sqrt(fIntensity) / (fIntensity);
	return R_OK;
	};

int  TDevice::MeasureStart(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TDevice::MeasureStart(void)\n",time(zidx));
//pph***************************************************************************
	MeasureStop();
	if(bDebug)
		SetInfo("MStart");
	if(!hControlWnd && !hDisplayWnd)
		{
		// MessageBox(GetFocus(),"Kein Host.","Startfehler",MBSTOP);
		return R_Failure;
		}
	uAskTime = (UINT)(fExposureTime * 1100);
	SetTimer(hWndFrame,DeviceTimerIdStart + GetId(),min(uAskTime,(UINT)7000),NULL);
	bDataValid = FALSE;
	bDeviceActive = TRUE;
	return R_MeasOk;
	};

int  TDevice::MeasureStop(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TDevice::MeasureStop(void)\n",time(zidx));
//pph***************************************************************************
	if(!bDeviceActive)
		return R_MeasOk;
	KillTimer(hWndFrame,DeviceTimerIdStart + GetId());
	if(bDebug && bDeviceActive)
		SetInfo("MStop");
	bDeviceActive = FALSE;
	return R_MeasOk;
	};

int  TDevice::PollDevice(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TDevice::PollDevice(void)\n",time(zidx));
//pph***************************************************************************
	double      	angx,angy,angz = 0.0;
	//! static int		driftcnt = 1;     //im auskomm. Teil
	//! static BOOL		dir = TRUE;    //im auskomm. Teil

	if(!bDeviceActive)
		return R_Failure;
	KillTimer(hWndFrame,DeviceTimerIdStart + GetId());
	if(bDebug)
		SetInfo("MPoll");
	if(mlIsAxisValid(Omega))
		{
		mlGetDistance(mlGetIdByName(Omega),angx);
		/*
		// Driftsimulation
		angx -= (driftcnt * 0.01104121);
		if((driftcnt == 30) || (driftcnt == 0))
			dir = !dir;
		if(dir)
			driftcnt++;
			else
			driftcnt--;
		*/
		}
		else
		angx = 0.0;
	if(mlIsAxisValid(Psi))
		{
		mlGetDistance(mlGetIdByName(Psi),angy);
		angy += angx * 0.7 - 20.0;
		}
		else
		angy = 0.0;
	angx = angx * angx / 11.3;
	angy = angy * angy / 19.1;
	angz = angz * angz / 23.5;
	/*
	if(fabs(ang) > 1e5) ang = 10;
	// 0. Reflex
	fIntensity = 3.2 * 1/(1+pow(ang-2.0,2)*0.02);
	// 1. Reflex
	fIntensity += 3.2 * exp(-pow(ang-70,2)*0.03);
	// 2. Reflex
	// fIntensity += 1.0 * exp(-pow(ang+139,2)*0.007);
	*/
	fIntensity = 1/(1 + 1.8 * pow(angx,2) + 0.001 * pow(angy,2) + \
										 0.001 * pow(angz,2));
	fIntensity *= 32000;
	fIntensity += (rand() % 80) + 270;
	bDeviceActive = FALSE;
	if(fIntensity == 0.0)
		fSigma = 1.0;
		else
		fSigma = sqrt(fIntensity) * 0.9 / fIntensity;
	bDataValid = TRUE;
	if(hControlWnd)
		PostMessage(hControlWnd,WM_COMMAND,wpJumpTo,GetId());
		else
		if(hDisplayWnd)
			PostMessage(hDisplayWnd,WM_COMMAND,wpJumpTo,GetId());
	return R_MeasOk;
	};

TDevice::PushSettings(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TDevice::PushSettings(void)\n",time(zidx));
//pph***************************************************************************
	Settings.fExposureTime    = fExposureTime;
	Settings.fFailure         = fFailure;
	Settings.dwExposureCounts = dwExposureCounts;
	Settings.bStaticFailure  	= bStaticFailure;
	Settings.nFunctionId      = nFunctionId;
	return TRUE;
	};

TDevice::PopSettings(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TDevice::PopSettings(void)\n",time(zidx));
//pph***************************************************************************
	fExposureTime     = Settings.fExposureTime;
	fFailure          = Settings.fFailure;
	dwExposureCounts  = Settings.dwExposureCounts;
	bStaticFailure    = Settings.bStaticFailure;
	nFunctionId       = Settings.nFunctionId;
	// In einigen Fllen mu der Detektor vorher gestoppt werden
	if(bDeviceActive)
		{
		MeasureStop();
		SetParameters();
		MeasureStart();
		}
		else
		SetParameters();
	return TRUE;
	};

//##############################################################################
//******** methods for a generic counter device ********************************
//##############################################################################
TGenericDevice::TGenericDevice() : TDevice(),TAm9513a()
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TDevice(),TAm9513a()\n",time(zidx));
//pph***************************************************************************
	char	buf[MaxString];

	sprintf(buf,"Device%d",GetId());
	TAm9513a::LoockUp(buf);
	uAskTime = 70;
	};

int	TGenericDevice::Initialize(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TGenericDevice::Initialize(void)\n",time(zidx));
//pph***************************************************************************
	DWORD	param;

	fLowerTimeBound = 0.01; // Sekunden
	fUpperTimeBound = 500.0;
	if(!TDevice::Initialize()) return R_Failure;
	if(!TAm9513a::Init()) return R_Failure;
	SetExposureValues(fExposureTime,dwExposureCounts,fFailure);
	param = 250;
	IOCTL(iocConfigureAcustic,param);
	SetSound();
	eHardware = Am9513HW;
	return R_OK;
	};

int	TGenericDevice::SetParameters(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TGenericDevice::SetParameters(void)\n",time(zidx));
//pph***************************************************************************
	DWORD value;

	value = fExposureTime * (DWORD)GetTicksPerSecond();
	IOCTL(iocSetTimeTicks,value);
	fExposureTime = (float)value / GetTicksPerSecond();
	IOCTL(iocSetCounts,dwExposureCounts);
	return 1;
	};

int TGenericDevice::MeasureStart(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TGenericDevice::MeasureStart(void)\n",time(zidx));
//pph***************************************************************************
	MeasureStop();
	if(!hControlWnd && !hDisplayWnd)
		{
		// MessageBox(GetFocus(),"Kein Host.","Startfehler",MBSTOP);
		return R_Failure;
		}
	// Messung starten
	IOCTL(iocStartCounting);
	bDeviceActive = TRUE;
	SetTimer(hWndFrame,DeviceTimerIdStart + GetId(),uAskTime,NULL);
	return R_MeasOk;
	};

int TGenericDevice::MeasureStop(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TGenericDevice::MeasureStop(void)\n",time(zidx));
//pph***************************************************************************
	if(bDeviceActive)
		{
		KillTimer(hWndFrame,DeviceTimerIdStart + GetId());
		IOCTL(iocStopCounting);
		}
	bDataValid = FALSE;
	bDeviceActive = FALSE;
	return R_MeasOk;
	};

int	TGenericDevice::PollDevice(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TGenericDevice::PollDevice(void)\n",time(zidx));
//pph***************************************************************************
	float	  	time;
	DWORD 	  counts,ticks;

	KillTimer(hWndFrame,DeviceTimerIdStart + GetId());
	if(!bDeviceActive) return R_Failure;
	switch(IOCTL(iocIsCountingReady)) {
		case 0:
		SetTimer(hWndFrame,DeviceTimerIdStart + GetId(),uAskTime,NULL);
		return R_MeasInProcess;

		case 1:  // time counter ready
		IOCTL(iocReadCounts,counts);
		IOCTL(iocReadTicks,ticks);
		time = (float)ticks / GetTicksPerSecond();
		if(ticks != 0)
			time = fExposureTime + time;
		break;

		case 2:  // impulse counter ready
		IOCTL(iocReadCounts,counts);
		IOCTL(iocReadTicks,ticks);
		time = (float)ticks / GetTicksPerSecond();
		if(counts != 0)
			counts = dwExposureCounts + counts;
		break;

		case 3:	// both ready
		counts = dwExposureCounts;
		time = fExposureTime;
		SetStatus("BothReady");
		}
	if(time != 0.0 )
		fIntensity = counts / time;
		else
		{
		if(IDYES == MessageBox(GetFocus(),"Time = 0.0 \n Neustart ?","Generic Device",MBASK))
			return R_Failure;
			else
			return 0;
		}
	bDeviceActive = FALSE;
	bDataValid = TRUE;
	if(hControlWnd != NULL)
		// Daten-Empfnger benachrichtigen
		PostMessage(hControlWnd,WM_COMMAND,wpJumpTo,GetId());
		else
		// Display benachrichtigen
		if(hDisplayWnd != NULL)
			PostMessage(hDisplayWnd,WM_COMMAND,wpJumpTo,GetId());
	return R_MeasOk;
	};

BOOL TGenericDevice::InitializeEvent(HWND,int)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TGenericDevice::InitializeEvent(HWND,int)\n",time(zidx));
//pph***************************************************************************
	return R_MeasOk;
	};

CALLBACK TGenericDevice::EventHandler(UINT,UINT,DWORD,DWORD,DWORD)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TGenericDevice::EventHandler(UINT,UINT,DWORD,DWORD,DWORD)\n",time(zidx));
//pph***************************************************************************
	return R_MeasOk;
	};

BOOL TGenericDevice::SetSound(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TGenericDevice::SetSound(void)\n",time(zidx));
//pph***************************************************************************
	if(bSound)
		DigitalOut(0x01);
		else
		DigitalOut(0x00);
	return TRUE;
	};

//******************************************************************************
//******** Hardware-Schnittstelle **********************************************
TEncoder::TEncoder(void) : TDevice()
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TDevice()\n",time(zidx));
//pph***************************************************************************
	};

TEncoder::~TEncoder(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TEncoder::~TEncoder(void)\n",time(zidx));
//pph***************************************************************************
	};

int TEncoder::Initialize(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TEncoder::Initialize(void)\n",time(zidx));
//pph***************************************************************************
	TDevice::Initialize();
	bDeviceOk = TRUE;
	fExposureTime = 0.2;
	eHardware = EncoderHW;
	if(bDeviceOk)
		return R_OK;
		else
		return R_Failure;
	};

int TEncoder::GetData(float &data)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TEncoder::GetData(float &data)\n",time(zidx));
//pph***************************************************************************
	data = 0.0;
	if(!bDataValid)
		return R_Failure;
	data = fIntensity;
	return R_OK;
	}

int TEncoder::PollDevice(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TEncoder::PollDevice(void)\n",time(zidx));
//pph***************************************************************************
	double  dist = 0.0;

	if(!bDeviceActive) return R_Failure;
	KillTimer(hWndFrame,DeviceTimerIdStart + GetId());
	if(mlIsAxisValid(Encoder))
		mlGetDistance(mlGetIdByName(Encoder),dist);
		else
		MessageBox(GetFocus(),"Encoder fehlt","Fehler",MBINFO);
	fIntensity = dist;
	bDeviceActive = FALSE;
	bDataValid = TRUE;
	if(hControlWnd)
		PostMessage(hControlWnd,WM_COMMAND,wpJumpTo,GetId());
		else
		if(hDisplayWnd)
			PostMessage(hDisplayWnd,WM_COMMAND,wpJumpTo,GetId());
	return R_MeasOk;
	};

//##############################################################################
//******** Methoden fr einen Stoe - PSD ***************************************
//##############################################################################
TPsd::TPsd(void) :TDevice()
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		:TDevice()\n",time(zidx));
//pph***************************************************************************
	bSoftOverflow	= bHardOverflow = FALSE;
	bSignalGrowUp = FALSE;
	bHVRegelung = FALSE;
	};

TPsd::~TPsd()
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TPsd::~TPsd()\n",time(zidx));
//pph***************************************************************************
	char  aBuf[MaxString];
	char  Ident[MaxString];

	sprintf(Ident,"Device%d",GetId());
	sprintf(aBuf,"%d",bHVRegelung);
	WritePrivateProfileString(Ident,"HVRegelung",aBuf,GetCFile());
	sprintf(aBuf,"%d",nMinChannel);
	WritePrivateProfileString(Ident,"FirstChannel",aBuf,GetCFile());
	sprintf(aBuf,"%d",nMaxChannel);
	WritePrivateProfileString(Ident,"LastChannel",aBuf,GetCFile());
	sprintf(aBuf,"%d",nAddedChannels);
	WritePrivateProfileString(Ident,"AddedChannels",aBuf,GetCFile());
	};

int TPsd::Initialize(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TPsd::Initialize(void)\n",time(zidx));
//pph***************************************************************************
	char        buf[MaxString];
	char        Ident[MaxString];

	TDevice::Initialize();
	sprintf(Ident,"Device%d",GetId());
	GetPrivateProfileString(Ident,"OverflowIntensity","50000.0",buf,MaxString,GetCFile());
	OverflowIntensity = atof(buf);
	if(CreateDefaults())
		WritePrivateProfileString(Ident,"OverflowIntensity",buf,GetCFile());

	GetPrivateProfileString(Ident,"BaseAddr","0x300",buf,MaxString,GetCFile());
	sscanf(buf,"%x",&nBaseAddr);
	if(CreateDefaults())
		WritePrivateProfileString(Ident,"BaseAddr",buf,GetCFile());

	GetPrivateProfileString(Ident,"SignalGrowUp","1",buf,MaxString,GetCFile());
	bSignalGrowUp = atoi(buf);
	WritePrivateProfileString(Ident,"SignalGrowUp",buf,GetCFile());

	GetPrivateProfileString(Ident,"HVRegelung","0",buf,MaxString,GetCFile());
	bHVRegelung = (0 < atoi(buf));
	WritePrivateProfileString(Ident,"HVRegelung",buf,GetCFile());

	GetPrivateProfileString(Ident,"ReadLeftFirst","1",buf,MaxString,GetCFile());
	sscanf(buf,"%d",&bReadLeftFirst);
	WritePrivateProfileString(Ident,"ReadLeftFirst",buf,GetCFile());

	// do not change the order in this section
	GetPrivateProfileString(Ident,"AngleStep","1.0",buf,MaxString,GetCFile());
	fAngleStep = atof(buf);
	if(CreateDefaults())
		WritePrivateProfileString(Ident,"AngleStep",buf,GetCFile());
	GetPrivateProfileString(Ident,"Unit","Sekunden",buf,MaxString,GetCFile());
	strcpy(szUnit,buf);
	if(CreateDefaults())
		WritePrivateProfileString(Ident,"Unit",buf,GetCFile());
	eUnit = UnitEnum(szUnit);
	GetPrivateProfileString(Ident,"AddedChannels","4",buf,MaxString,GetCFile());
	SetAddedChannels(atoi(buf));
	if(CreateDefaults())
		WritePrivateProfileString(Ident,"AddedChannels",buf,GetCFile());
	// end section

	if(fAngleWidth == 0.0)
		{
		MessageBox(GetFocus(),"Psd ist nicht kalibriert !","Meldung",
																	MB_OK | MB_ICONHAND);
		fAngleStep = 1.0;
		SetAddedChannels(4);
		}
	GetPrivateProfileString(Ident,"FirstChannel","0",buf,MaxString,GetCFile());
	nMinChannel = atoi(buf);
	if(CreateDefaults())
		WritePrivateProfileString(Ident,"FirstChannel",buf,GetCFile());

	GetPrivateProfileString(Ident,"LastChannel","4095",buf,MaxString,GetCFile());
	nMaxChannel = atoi(buf);
	if(CreateDefaults())
		WritePrivateProfileString(Ident,"LastChannel",buf,GetCFile());
	if(nMinChannel >= nMaxChannel)
		{
		nMinChannel = 0;
		nMaxChannel = 4095;
		}
	nChannelNumber = nMaxChannel - nMinChannel;
	// allocate memory
	hCountBuf 	 = GlobalAlloc(GHND,GetBufferSize() * sizeof(DWORD));
	// initial hardware check
	PsdInit();
	eHardware = GenericPsdHW;
	PushSettings();
	if(bDeviceOk)
		return R_OK;
		else
		return R_Failure;
	};

void TPsd::SetSpezificParametersDlg(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TPsd::SetSpezificParametersDlg(void)\n",time(zidx));
//pph***************************************************************************
	};

float	TPsd::GetWidth(TUnitType unit)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TPsd::GetWidth(TUnitType unit)\n",time(zidx));
//pph***************************************************************************
	switch(unit) {
		case Grad: return (nAddedChannels * (fAngleStep / 3600.0));
		case Minuten: return (nAddedChannels * (fAngleStep / 60.0));
		default: return (nAddedChannels * fAngleStep);
		}
	};

void TPsd::SetAddedChannels(int ach)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TPsd::SetAddedChannels(int ach)\n",time(zidx));
//pph***************************************************************************
	nAddedChannels = max(ach,1);
	switch(eUnit) {
		case Grad:
		fAngleWidth = nAddedChannels * (fAngleStep / 3600.0);
		break;
		case Minuten:
		fAngleWidth = nAddedChannels * (fAngleStep / 60.0);
		break;
		default:
		fAngleWidth = nAddedChannels * fAngleStep;
		}
	};

UINT TPsd::GetMaximumChannel(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TPsd::GetMaximumChannel(void)\n",time(zidx));
//pph***************************************************************************
	if(bReadLeftFirst)
		return uMaximumChannel;
	return (GetChannelNumber() - uMaximumChannel);
	};

int TPsd::GetData(TCurve &curve)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TPsd::GetData(TCurve &curve)\n",time(zidx));
//pph***************************************************************************
	int       idx,i,anzch;
	double    dAngle,Angle,intens;
	LPDWORD		lpdwData;
	float     y,x = 0.0,z;

	if(bHardOverflow)
		return R_HardOverflow;
	anzch = GetChannelNumber() - nAddedChannels;
	dAngle = GetWidth();
	Angle = 0.0;
	// Einheit des Psd sind arcsec
	// Kanal 0 entspricht 0.0 arcsec bzw. 2Theta
	fIntensity = 0.0;
	lpdwData = (LPDWORD)GlobalLock(hCountBuf);
	if(dRealTime == 0.0)
		return R_Failure;
	curve.New();
	curve.FastOpen();
	if(20 == bDebug)
		dRealTime = 1.0;
	if(bReadLeftFirst)
		{
		for(idx = 0;idx < anzch;idx += nAddedChannels)
			{
			intens = 0.0;
			for(i = 0;i < nAddedChannels;i++)
				intens += (double)lpdwData[idx+i];
			y = intens / dRealTime;
			z = idx;
			x = Angle;
			curve.FastPAdd(x,y,z);
			Angle += dAngle;
			}
		}
		else
		{
		for(idx = 0;idx < anzch;idx += nAddedChannels)
			{
			intens = 0.0;
			for(i = 0;i < nAddedChannels;i++)
				intens += (double)lpdwData[anzch - idx - i];
			y = intens / dRealTime;
			z = idx;
			x = Angle;
			curve.FastPAdd(x,y,z);
			Angle += dAngle;
			}
		}
	curve.FastClose();
	GlobalUnlock(hCountBuf);
	fIntensity = dwIntegratedCounts / dRealTime;
	if(fIntensity == 0.0)
		fSigma = 1.0;
		else
		fSigma = sqrt(fIntensity) / (fIntensity);
	// Ist ein "weicher" Overflow aufgetreten ?
	if(fIntensity >= OverflowIntensity)
		{
		bSoftOverflow = TRUE;
		return R_SoftOverflow;
		}
	return R_OK;
	};

int TPsd::GetData(float &integral)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TPsd::GetData(float &integral)\n",time(zidx));
//pph***************************************************************************
	integral = 0.0;
	if(bHardOverflow)
		return R_HardOverflow;
	if(dRealTime == 0.0)
		return R_Failure;
	fIntensity = dwIntegratedCounts / dRealTime;
	integral = fIntensity;
	if(fIntensity == 0.0)
		fSigma = 1.0;
		else
		fSigma = sqrt(fIntensity) / (fIntensity);
	// Ist ein "weicher" Overflow aufgetreten ?
	if(fIntensity >= OverflowIntensity)
		{
		bSoftOverflow = TRUE;
		return R_SoftOverflow;
		}
	integral = fIntensity;
	return R_OK;
	};

int TPsd::MeasureStart(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TPsd::MeasureStart(void)\n",time(zidx));
//pph***************************************************************************
	MeasureStop();
	if(!hControlWnd && !hDisplayWnd)
		{
		// MessageBox(GetFocus(),"Kein Host.","Startfehler",MBSTOP);
		return R_Failure;
		}
	bSoftOverflow = FALSE;
	bHardOverflow = FALSE;
	bFirstReadOut = TRUE;
	// Start-Zeit erfassen
	if(R_Failure == PsdStart())
		return R_Failure;
	uAskTime = (UINT)min((long)(fExposureTime * 1020),4000l);
	uAskTime = max((UINT)500,uAskTime);
	dwStartTime = timeGetTime();
	SetTimer(hWndFrame,DeviceTimerIdStart + GetId(),uAskTime,NULL);
	bDeviceActive = TRUE;
	bDataValid = FALSE;
	return R_MeasOk;
	};

int TPsd::MeasureStop(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TPsd::MeasureStop(void)\n",time(zidx));
//pph***************************************************************************
	if(!bDeviceActive) return R_MeasOk;
	KillTimer(hWndFrame,DeviceTimerIdStart + GetId());
	bDataValid = FALSE;
	PsdStop();
	bDeviceActive = FALSE;
	return R_MeasOk;
	};

int TPsd::MeasureStopExternal(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TPsd::MeasureStopExternal(void)\n",time(zidx));
//pph***************************************************************************
	dwElapsedTime = timeGetTime() - dwStartTime;
	fExposureTime = CalcTime(dwElapsedTime);
  return 1;
	};

int TPsd::PollDevice(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TPsd::PollDevice(void)\n",time(zidx));
//pph***************************************************************************
	char    buf[MaxString];
	int     retval = R_MeasOk;

	if(!bDeviceOk)
		return R_Failure;
	KillTimer(hWndFrame,DeviceTimerIdStart + GetId());
	if(!bDeviceActive)
		return R_Failure;
	bDeviceActive = FALSE;
	dwElapsedTime = timeGetTime() - dwStartTime;
	if(CalcTime(dwElapsedTime) < fExposureTime)
		{
		retval = R_MeasInProcess;
		bDeviceActive = TRUE;
		if(!bSignalGrowUp)
			{
			//*** Kein stufenweiser Signalaufbau
			SetTimer(hWndFrame,DeviceTimerIdStart + GetId(),uAskTime,NULL);
			return R_MeasInProcess;
			}
		//*** Stufenweiser Signalaufbau
		retval = PsdReadOut(IntermediateRead);
		if(retval == R_Failure)
			return retval;
		dRealTime = CalcTime(dwElapsedTime);
		bFirstReadOut = FALSE;
		lWaitTime  = (long)(fExposureTime * 1020) - dwElapsedTime;
		uAskTime = (UINT)min(lWaitTime,6000l);
		uAskTime = max((UINT)500,uAskTime);
		SetTimer(hWndFrame,DeviceTimerIdStart + GetId(),uAskTime,NULL);
		goto SendNotify;
		}
	//*** Messung ist beendet ***
	bDataValid = TRUE;
	retval = PsdStop();
	if(R_Failure == retval)
		return R_Failure;
	dRealTime = CalcTime(dwElapsedTime);
	retval = PsdReadOut(FinalRead);
	if(R_Failure == retval)
		return R_Failure;
	bDataValid = TRUE;
SendNotify: //*** Benachrichtigen der entsprechenden Fenster ***
	if(dRealTime == 0.0)
		{
		SetInfo("dRealTime == 0.0 Fehler Psd");
		DelayTime(300);
		dRealTime = 1.0;
		PsdStop();
		bDataValid = FALSE;
		return R_Failure;
		}
	if(bHardOverflow)
		{
		strcpy(buf,"berlauf Psd  ( Hochspannung ? )");
		MessageBeep(0);
		retval = R_HardOverflow;
		}
	if(hControlWnd)
		PostMessage(hControlWnd,WM_COMMAND,wpJumpTo,GetId());
		else
		if(hDisplayWnd)
			PostMessage(hDisplayWnd,WM_COMMAND,wpJumpTo,GetId());
	return retval;
	};

int TPsd::SetParameters(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TPsd::SetParameters(void)\n",time(zidx));
//pph***************************************************************************
	return TRUE;
	};

float TPsd::GetAngleRange(TUnitType eunit)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TPsd::GetAngleRange(TUnitType eunit)\n",time(zidx));
//pph***************************************************************************
	switch(eunit) {
		case Grad:
		return (fAngleStep / 3600.0) * GetChannelNumber();

		case Minuten:
		return (fAngleStep / 60.0) * GetChannelNumber();

		default:
		return fAngleStep * GetChannelNumber();
		}
	};

float TPsd::GetAngleRange(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TPsd::GetAngleRange(void)\n",time(zidx));
//pph***************************************************************************
	return GetAngleRange(eUnit);
	};

void TPsd::SetAngleRange(float)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TPsd::SetAngleRange(float)\n",time(zidx));
//pph***************************************************************************
	return;
	};

BOOL TPsd::PushSettings(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TPsd::PushSettings(void)\n",time(zidx));
//pph***************************************************************************
	TDevice::PushSettings();
	Settings.nAddedChannels = nAddedChannels;
	return TRUE;
	};

BOOL TPsd::PopSettings(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TPsd::PopSettings(void)\n",time(zidx));
//pph***************************************************************************
	TDevice::PopSettings();
	nAddedChannels = Settings.nAddedChannels;
	return TRUE;
	};

int TPsd::PsdReadOut(THowReadOutPsd)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TPsd::PsdReadOut(THowReadOutPsd)\n",time(zidx));
//pph***************************************************************************
	LPDWORD 			lpdwCountBuf;
	DWORD					counts;
   //! nNumber nie benutzt
	int 					idx /* ,nNumber = GetChannelNumber()*/;
	double 				argum;

	lpdwCountBuf = (LPDWORD)GlobalLock(hCountBuf);
	uMaximumChannel = 0; dwMaxCounts = 0; dwIntegratedCounts = 0;
	mlGetDistance(mlGetIdByName(Theta),argum);
	argum = argum / GetAngleStep();
	for(idx = 0;idx < GetChannelNumber();idx++)
		{
		argum = idx - (GetChannelNumber() / 2) + argum;
		argum = 1.0 / (1.0 + 7.2752e-3 * argum * argum);
		counts = (DWORD)(argum * 300.0 + (rand() % 7));
		*lpdwCountBuf = counts;
		dwIntegratedCounts += counts;
		if(dwMaxCounts < counts)
			{
			uMaximumChannel = idx;
			dwMaxCounts = counts;
			}
		lpdwCountBuf++;
		}
	GlobalUnlock(hCountBuf);
	return R_OK;
	};

//************* Hardware-spezifischer Teil *************************************
TStoe_Psd::TStoe_Psd(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TStoe_Psd::TStoe_Psd(void)\n",time(zidx));
//pph***************************************************************************
	bLong     = FALSE;
	hReadBuf	= NULL;
	eHardware	= StoeHW;
	};

TStoe_Psd::~TStoe_Psd(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TStoe_Psd::~TStoe_Psd(void)\n",time(zidx));
//pph***************************************************************************
	if(hReadBuf)
		GlobalFree(hReadBuf);
	};

int TStoe_Psd::Initialize(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TStoe_Psd::Initialize(void)\n",time(zidx));
//pph***************************************************************************
	if(R_OK != TPsd::Initialize())
		return R_Failure;
	hReadBuf = GlobalAlloc(GHND,(GetChannelNumber()+1)*sizeof(WORD));
	eHardware = StoeHW;
	return R_OK;
	};

int TStoe_Psd::PollDevice(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TStoe_Psd::PollDevice(void)\n",time(zidx));
//pph***************************************************************************
	char    buf[MaxString];
	int     retval = R_MeasOk;

	if(!bDeviceOk) return R_Failure;
	KillTimer(hWndFrame,DeviceTimerIdStart + GetId());
	bDataValid = FALSE;
	if(!bDeviceActive) return R_Failure;
	bDeviceActive = FALSE;
	dwElapsedTime = timeGetTime() - dwStartTime;
	if(CalcTime(dwElapsedTime) < fExposureTime)
		{
		retval = R_MeasInProcess;
		bDeviceActive = TRUE;
		if(!bSignalGrowUp)
			{
			//*** Kein stufenweiser Signalaufbau
			SetTimer(hWndFrame,DeviceTimerIdStart + GetId(),uAskTime,NULL);
			return R_MeasInProcess;
			}
		//*** Stufenweiser Signalaufbau
		dwElapsedTime = timeGetTime() - dwStartTime;
		PsdStop();
		dRealTime = CalcTime(dwElapsedTime);
		if(bFirstReadOut)
			{
			PsdReadOut(FirstRead);
			bFirstReadOut = FALSE;
			}
			else
			PsdReadOut(AccumulationRead);
		PsdStart();
		lWaitTime  = (timeGetTime() - dwStartTime) - dwElapsedTime;
		dwStartTime += lWaitTime;
		SetTimer(hWndFrame,DeviceTimerIdStart + GetId(),uAskTime,NULL);
		goto SendNotify;
		}
	//*** Messung ist beendet ***
	bDataValid = TRUE;
	PsdStop();
	dRealTime = CalcTime(dwElapsedTime);
	PsdReadOut(AccumulationRead);
SendNotify: //*** Benachrichtigen der entsprechenden Fenster ***
	if(bHardOverflow)
		{
		strcpy(buf,"berlauf Psd  ( Hochspannung ? )");
		MessageBeep(0);
		retval = R_HardOverflow;
		}
	if(dRealTime == 0.0)
		{
		SetInfo("dRealTime == 0.0 Fehler Psd");
		DelayTime(300);
		dRealTime = 1.0;
		PsdStop();
		return R_Failure;
		}
	if(hControlWnd)
		PostMessage(hControlWnd,WM_COMMAND,wpJumpTo,GetId());
		else
		if(hDisplayWnd)
			PostMessage(hDisplayWnd,WM_COMMAND,wpJumpTo,GetId());
	return retval;
	};

int TStoe_Psd::PsdReadOut(THowReadOutPsd eReadType)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TStoe_Psd::PsdReadOut(THowReadOutPsd eReadType)\n",time(zidx));
//pph***************************************************************************
	int					retval = R_OK;
	int   			idx,nChannelNumber;
	LPDWORD 		lpdwCountBuf;
	LPWORD 			lpwReadBuf;

	lpdwCountBuf = (LPDWORD)GlobalLock(hCountBuf);
	lpwReadBuf = (LPWORD)GlobalLock(hReadBuf);

	switch(eReadType) {
		case AccumulationRead:
		retval = PsdRead(nMinChannel,nMaxChannel,bLong,lpwReadBuf);
		if(R_OK != retval) break;
		uMaximumChannel = 0; dwMaxCounts	= 0; dwIntegratedCounts = 0;
		nChannelNumber = GetChannelNumber();
		for(idx=0;idx<nChannelNumber;idx++)
			{
			lpdwCountBuf[idx]	+= lpwReadBuf[nChannelNumber-idx-1];
			dwIntegratedCounts 	+= lpdwCountBuf[idx];
			if(dwMaxCounts < lpdwCountBuf[idx])
				{
				uMaximumChannel = idx;
				dwMaxCounts = lpdwCountBuf[idx];
				}
			}
		break;

		case FirstRead:
		retval = PsdRead(nMinChannel,nMaxChannel,bLong,lpwReadBuf);
		if(R_OK != retval) break;
		uMaximumChannel = 0; dwMaxCounts = 0; dwIntegratedCounts = 0;
		nChannelNumber = GetChannelNumber();
		for(idx=0;idx<nChannelNumber;idx++)
			{
			lpdwCountBuf[idx]  = lpwReadBuf[nChannelNumber-idx-1];
			dwIntegratedCounts 	+= lpdwCountBuf[idx];
			if(dwMaxCounts < lpdwCountBuf[idx])
				{
				uMaximumChannel = idx;
				dwMaxCounts = lpdwCountBuf[idx];
				}
			}
		break;
		}
	GlobalUnlock(hCountBuf);
	GlobalUnlock(hReadBuf);
	return retval;
	};

int TStoe_Psd::PsdInit(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TStoe_Psd::PsdInit(void)\n",time(zidx));
//pph***************************************************************************
	/*----------------------------------------------------------------------------
	Subroutine PioInit ()
	Initialize the PIO to operate with the PSD interface.
	write control word to PIO_CTRL

	high byte :
	Bit15:    mode set flag: active
	Bit14/13: mode A group: 0
	Bit12:    port A: output (high byte)
	Bit11:    port C upper: input
	Bit10:    mode B group: 0
	Bit9:     port B: input (high byte)
	Bit8:     port C lower: input
	low byte :
	Bit7:     mode set flag: active
	Bit6/5:   mode A group: 0
	Bit4:     port A: output (low byte)
	Bit3:     port C upper: output
	Bit2:     mode B group: 0
	Bit1:     port B: input (low byte)
	Bit0:     port C lower: output
	----------------------------------------------------------------------------*/
	// stop PSD interface
	int base = nBaseAddr;
	bReadyForRead = FALSE;
	Delay(IoWaitStoe);
#ifndef __WIN32__
	_asm {
		mov  dx,base
		add  dx,6
		mov  ax,0x8B82
		out  dx,ax
		}
#endif
	Delay(IoWaitStoe);
#ifndef __WIN32__
	_asm {
		mov  dx,base
		add  dx,4
		mov  ax,PSD_STOP
		out  dx,ax
		}
#endif
	return R_OK;
	};

int TStoe_Psd::PsdStart(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TStoe_Psd::PsdStart(void)\n",time(zidx));
//pph***************************************************************************
	/*----------------------------------------------------------------------------
	Subroutine PsdStart()
	Starts the PSD interface to collect data:
	Set INIT bit to initialize the PSD interface.
	Then clear INIT bit and set CSR0 and CSR1 to start the
	PSD interface ( memory is always cleared ).
	----------------------------------------------------------------------------*/
	int base = nBaseAddr;

	bReadyForRead = FALSE;
	Delay(IoWaitStoe);
#ifndef __WIN32__
	_asm {
		// init PSD interface
		mov  dx,base
		add  dx,4
		mov  ax,PSD_INIT
		out  dx,ax
		}
#endif
	Delay(IoWaitStoe);
#ifndef __WIN32__
	_asm {
		// start PSD interface with clearing memory
		mov  dx,base
		add  dx,4
		mov  ax,PSD_CSR0
		or   ax,PSD_CSR1
		out  dx,ax
		}
#endif
	return R_OK;
	};

int TStoe_Psd::PsdStop(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TStoe_Psd::PsdStop(void)\n",time(zidx));
//pph***************************************************************************
	/*----------------------------------------------------------------------------
	Integer*2 Function PsdStop ()
	Stops the PSD interface to collect data
	Clear bits CSR0 and CSR1 to stop the PSD interface.
	Returns:  0  -  no overflow
					 -1  -  overflow in PSD memory has occured
	----------------------------------------------------------------------------*/
	int base = nBaseAddr;

	bReadyForRead = TRUE;
	Delay(IoWaitStoe);
	if(bDebug)
		return R_OK;
#ifndef __WIN32__
	_asm {
		// stop PSD interface
		mov  dx,base
		add  dx,4
		mov  ax,PSD_STOP
		out  dx,ax
		}
#endif
	Delay(IoWaitStoe);
#ifndef __WIN32__
	_asm {
		// start PSD interface with clearing memory
		mov  dx,base
		add  dx,4
		mov  ax,0
		in   ax,dx
		}
#endif
	if(_AX & PSD_OVF)
		{
		bHardOverflow = TRUE;
		return R_HardOverflow;
		}
	return R_OK;
	};

#ifndef __WIN32__
int TStoe_Psd::PsdRead(int FirstCh,int LastCh,int bIsLong, LPWORD buf)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TStoe_Psd::PsdRead(int FirstCh,int LastCh,int bIsLong, LPWORD buf)\n",time(zidx));
//pph***************************************************************************
	/*----------------------------------------------------------------------------
	Integer*2 Function PsdRead ( FirstChannel, LastChannel,Long, BufPtr )
	Reads collected data from PSD interface.
	integer*2 FirstChannel [ value ]   ; [bp+14]
	integer*2 LastChannel  [ value ]   ; [bp+12]
	logical*2 Long         [ value ]   ; [bp+10]
	integer*4 BufPtr       [ value ]   ; [bp+6]
	Data transfer is initiated by setting the bits PSD_DTRNS and
	PSD_NDRDY, then the specified channels are read out and stored.
	'BufPtr' is a far pointer to the buffer used.
	'Long' = .false. : data are stored as integer*2
				 = .true.  : data are stored as integer*4
	Channel numbers range from 0 to 4095 !
	The sequence to read one data word is :
	- set bits PSD_DTRNS ( data transition ),
						 PSD_NDRDY ( new data ready ),
						 PSD_CSR1
	- output inverted channel address to PORTA
	- clear bit PSD_NDRDY ( new data ready )
	- wait until bit PSD_DVAL ( data valid ) is set
	- read data word from PORTB and store it in Buffer
	- clear bit PSD_DTRNS ( data transition )
	When the data have been read the PSD interface is stopped.
		 Returns: = 0  -  no error
							> 0  -  'data valid' timeout
											returns current channel number + 1
	----------------------------------------------------------------------------*/
	// Symbolische Sprungmarken mit BC 3.1 nicht verfgbar
	int		val1,val2;
	Delay(IoWaitStoe);
	// Altes Signal kann eventuell zur Bestimmung der Overflow-
	// Position genutzt werden
	if(bHardOverflow) return R_HardOverflow;
	// Sichern, da je Zyklus nur einmal ausgelesen wird
	if(!bReadyForRead) return 0;
	bReadyForRead = FALSE;
	_asm {
		// si,di retten
		push  di
		push  si
		// initiate data transfer
		mov   dx,0x304        // PC
		mov   ax,PSD_DTRNS OR PSD_NDRDY
		out   dx,ax
		mov   bx,FirstCh
		mov   cx,LastCh
		sub   cx,bx
		inc   cx
		mov   si,bIsLong
		les   di,buf
	next:
		xor   ax,ax
		jcxz  ready
		mov   dx,0x304        //PC
		mov   ax,PSD_DTRNS OR PSD_NDRDY OR PSD_CSR1
		out   dx,ax
//    jmp   0
		mov   dx,0x300        // PA
		mov   ax,bx
		not   ax
		and   ax,0x0FFF
		out   dx,ax
		// clear PSD_NDRDY
		mov   dx,0x304        //PC
		mov   ax,PSD_DTRNS OR PSD_CSR1
		out   dx,ax
		mov   val1,0xFFFF
		mov   val2,15
	read1:
		mov   dx,0x304        //PC
		in    ax,dx
		test  ax,PSD_DVAL
		jnz   read2
		dec   val1
		jnz   read1
		dec   val2
		jnz   read1

		mov   ax,bx
		inc   ax
		jmp   short ready
	read2:
		mov   dx,0x302        // PB
		in    ax,dx
		stosw
		or    si,si
		jz    read3
		xor   ax,ax
		stosw
	read3:
		mov   dx,0x304        //PC
		mov   ax,PSD_NDRDY OR PSD_CSR1  // delete PSD_DTRNS
		out   dx,ax
		dec   cx
		inc   bx
		jmp   short next
	ready:
		push  ax
		mov   dx,0x304        // PC
		mov   ax,PSD_STOP
		out   dx,ax
		pop   ax
		pop   si
		pop   di
		}
	return R_OK;
	};
#else

int TStoe_Psd::PsdRead(int,int,int,LPWORD)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TStoe_Psd::PsdRead(int,int,int,LPWORD)\n",time(zidx));
//pph***************************************************************************
	return R_OK;
	}

#endif

//******************************************************************************
//******** Radicon-Zhler Bauart II ********************************************
//******************************************************************************
TRadicon::TRadicon(void) : TDevice()
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TDevice()\n",time(zidx));
//pph***************************************************************************
	char    Ident[MaxString],buf[MaxString];

	sprintf(Ident,"Device%d",GetId());
	GetPrivateProfileString(Ident,"IOAddr","0x100",buf,MaxString,GetCFile());
	if(CreateDefaults())
		WritePrivateProfileString(Ident,"IOAddr",buf,GetCFile());
	sscanf(buf,"%x",&Rdd);
	Rcc = Rdd + 1;
	GetPrivateProfileString(Ident,"UpperThresh","950",buf,MaxString,GetCFile());
	if(CreateDefaults())
		WritePrivateProfileString(Ident,"UpperThresh",buf,GetCFile());
	wDacUpperThresh = atoi(buf);
	if(wDacUpperThresh < 1)
		wDacUpperThresh = 1023;
	GetPrivateProfileString(Ident,"LowerThresh","150",buf,MaxString,GetCFile());
	if(CreateDefaults())
		WritePrivateProfileString(Ident,"LowerThresh",buf,GetCFile());
	wDacLowerThresh = atoi(buf);
	if(wDacLowerThresh < 1)
		wDacLowerThresh = 150;
	if(wDacLowerThresh >= wDacUpperThresh)
		{
		wDacLowerThresh = 300;
		wDacUpperThresh = 1023;
		}
	fUpperTimeBound  = 500.0;
	fLowerTimeBound  = 0.1;
	bAnnounceActiv   = FALSE;
	GetPrivateProfileString(Ident,"HighVoltage","640",buf,MaxString,GetCFile());
	if(CreateDefaults())
		WritePrivateProfileString(Ident,"HighVoltage",buf,GetCFile());
	wHighVoltage = atoi(buf);
	if((wHighVoltage < 1) || (wHighVoltage > MaxHighVoltage))
		wHighVoltage = 400;
	GetPrivateProfileString(Ident,"Sound","0",buf,MaxString,GetCFile());
	bSound = atoi(buf);
	};

TRadicon::~TRadicon(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TRadicon::~TRadicon(void)\n",time(zidx));
//pph***************************************************************************
	char    Ident[MaxString],buf[MaxString];

	sprintf(Ident,"Device%d",GetId());
	sprintf(buf,"%d",wDacUpperThresh);
	WritePrivateProfileString(Ident,"UpperThresh",buf,GetCFile());
	sprintf(buf,"%d",wDacLowerThresh);
	WritePrivateProfileString(Ident,"LowerThresh",buf,GetCFile());
	sprintf(buf,"%d",wHighVoltage);
	WritePrivateProfileString(Ident,"HighVoltage",buf,GetCFile());
	sprintf(buf,"%d",bSound);
	WritePrivateProfileString(Ident,"Sound",buf,GetCFile());
	};

int TRadicon::Initialize(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TRadicon::Initialize(void)\n",time(zidx));
//pph***************************************************************************
	char    buf[MaxString];
	FILE* 	hFile;
	LONG 		FileSize;

	TDevice::Initialize();
	// Loading microprocessor program
	hFile = fopen ("scs.prg","rb");
	if(!hFile)
		{
		strcpy(buf,"Kann File <scs.prg> nicht ffnen !");
		SetInfo(buf);
		DelayTime(200);
		return R_Failure;
		}
		else
		{
		fseek(hFile,0,2);
		FileSize = ftell(hFile);
		if(FileSize != LNGPRG)
			{
			strcpy(buf,"File nicht korrekt !");
			SetInfo(buf);
			DelayTime(200);
			fclose(hFile);
			return R_Failure;
			}
			else
			{
			fseek(hFile,0,0);
			PBYTE pBuf = (PBYTE) LocalAlloc (LMEM_FIXED,(UINT) FileSize);
			if(pBuf == NULL)
				{
				strcpy(buf,"Kein Speicher !");
				SetInfo(buf);
				DelayTime(200);
				fclose(hFile);
				return R_Failure;
				}
				else
				{
				retval = fread(pBuf,1,(UINT)FileSize,hFile);
				switch(retval) {
					case LNGPRG:
					retval = init_b(pBuf,(UINT)FileSize,Rdd,Rcc);
					LocalFree ((HLOCAL) pBuf);
					break;

					default:
					strcpy(buf,"Gelesene Bytes nicht korrekt !");
					SetInfo(buf);
					DelayTime(200);
					LocalFree ((HLOCAL) pBuf);
					return R_Failure;
					}
				}
			}
		fclose (hFile);
		}
	if(!SetParameters())
	 return R_Failure;
	bDeviceOk = TRUE;
	bDeviceActive = FALSE;
	eHardware = RadiconHW;
	return R_OK;
	};

void TRadicon::SetSpezificParametersDlg(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TRadicon::SetSpezificParametersDlg(void)\n",time(zidx));
//pph***************************************************************************
	TModalDlg   *dlg;
	dlg = (TScsParameters *)new TScsParameters();
	dlg->ExecuteDialog(GetFrameHandle());
	delete dlg;
	};

int TRadicon::MeasureStart(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TRadicon::MeasureStart(void)\n",time(zidx));
//pph***************************************************************************
	int 		cnt;
	DWORD   counts;
	double	time;

	MeasureStop();
	if(!hControlWnd && !hDisplayWnd)
		{
		// MessageBox(GetFocus(),"Kein Host.","Startfehler",MBSTOP);
		return R_Failure;
		}
	// Intensimeter-Mode
	// retval = begwrk(3,Rdd,Rcc);
	// Time-Count Mode
	retval = begwrk(2,Rdd,Rcc);
	dwStartTime = timeGetTime();
	if(retval)
		return FailureOccured(2,retval);
	if(fExposureTime <= 0.5)
		{
		cnt = 40;
		while(1) {
			if(!cnt--) return R_Failure;
			DelayTime(20);
			switch(getinf(9,Rdd,Rcc,&time,&counts)) {
				case -4: // Zeit-Bedingung
				dwElapsedTime = timeGetTime() - dwStartTime;
				retval = getinf(11,Rdd,Rcc,&time,&counts);
				dRealTime = CalcTime(dwElapsedTime);
				if(fExposureTime > time)
					continue;
				retval = begwrk(5,Rdd,Rcc);
				if(time == 0.0) continue;
				fIntensity = (dwExposureCounts-counts) / time;
				goto ExitShortMeasure;

				case 0: //*** Impulse-Bedingung
				if(time == 0.0) continue;
				fIntensity = dwExposureCounts / time;
				goto ExitShortMeasure;

				default:
				return FailureOccured(9,retval);
				}
			}
ExitShortMeasure:
		bDataValid = TRUE;
		bDeviceActive = FALSE;
		return R_MeasOk;
		}
	uAskTime = 300;
	bDataValid = FALSE;
	bDeviceActive = TRUE;
	if(bDebug)
		SetInfo("MStart");
	SetTimer(GetFrameHandle(),DeviceTimerIdStart + GetId(),uAskTime,NULL);
	return R_MeasOk;
	};

int TRadicon::MeasureStop(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TRadicon::MeasureStop(void)\n",time(zidx));
//pph***************************************************************************
	if(!bDeviceActive) return R_MeasOk;
	KillTimer(GetFrameHandle(),DeviceTimerIdStart + GetId());
	if(bDebug)
		SetInfo("MStop");
	retval = begwrk(5,Rdd,Rcc);
	if(retval)
		return FailureOccured(5,retval);
	bDeviceActive = FALSE;
	bDataValid = FALSE;
	DelayTime(10);
	return R_MeasOk;
	};

int	TRadicon::PollDevice(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TRadicon::PollDevice(void)\n",time(zidx));
//pph***************************************************************************
	DWORD   counts;
	double	time;

	KillTimer(GetFrameHandle(),DeviceTimerIdStart + GetId());
	bDeviceActive = FALSE;
	if(bDebug)
		SetInfo("MPoll");
	// get mesured time and counts
	if(bDebug)
		DelayTime(10);
	switch(getinf(9,Rdd,Rcc,&time,&counts)) {
		case -4:
		// Zeit-Bedingung
		DelayTime(2);
		dwElapsedTime = timeGetTime() - dwStartTime;
		retval = getinf(11,Rdd,Rcc,&time,&counts);
		dRealTime = CalcTime(dwElapsedTime);
		if(bDebug)
			SetInfo("getinf11");
		if(fExposureTime > time)
			{
			bDeviceActive = TRUE;
			SetTimer(GetFrameHandle(),DeviceTimerIdStart + GetId(),uAskTime,NULL);
			return R_MeasInProcess;
			}
		retval = begwrk(5,Rdd,Rcc);
		if(bDebug)
			SetInfo("begwrk5");
		if(time == 0.0)
			{
			if(bDebug)
				SetInfo("time==0");
			return R_Failure;
			}
		fIntensity = (dwExposureCounts-counts) / time;
		break;

		case 0:
		// Impulse-Bedingung
		if(time == 0.0)
			{
			if(bDebug)
				SetInfo("time==0");
			return R_Failure;
			}
		fIntensity = dwExposureCounts / time;
		break;

		default:
		return FailureOccured(9,retval);
		}
	//*** measurement ready
	bDataValid = TRUE;
	bDeviceActive = FALSE;
	if(hControlWnd != NULL)
		// Daten-Empfnger benachrichtigen
		PostMessage(hControlWnd,WM_COMMAND,wpJumpTo,GetId());
		else
		// Display benachrichtigen
		if(hDisplayWnd != NULL)
			PostMessage(hDisplayWnd,WM_COMMAND,wpJumpTo,GetId());
	return R_MeasOk;
	};

BOOL TRadicon::SetParameters(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TRadicon::SetParameters(void)\n",time(zidx));
//pph***************************************************************************
	double		time = fExposureTime;
	DWORD			counts = dwExposureCounts;
	WORD			lowthresh,highthresh,voltage = wHighVoltage;

	wDacLowerThresh = min((WORD)1022,max(wDacLowerThresh,(WORD)0));
	wDacUpperThresh = max((WORD)1,min(wDacUpperThresh,(WORD)1023));
	if(wDacUpperThresh <= wDacLowerThresh)
		wDacLowerThresh = wDacUpperThresh-1;
	lowthresh 	= wDacLowerThresh;
	highthresh 	= wDacUpperThresh;
	retval = setprm(Rdd,Rcc,highthresh,lowthresh,voltage,time,counts,1,bSound?7:8,0);
	if(retval)
	 {
	 FailureOccured(2,retval);
	 return FALSE;
	 }
	DelayTime(5);
	return TRUE;
	};

void CALLBACK TRadicon::EventHandler(UINT,UINT,DWORD,DWORD,DWORD)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TRadicon::EventHandler(UINT,UINT,DWORD,DWORD,DWORD)\n",time(zidx));
//pph***************************************************************************
	DWORD   counts;
	double	time;

	nCalledEvents++;
	retval = getinf(9,Rdd,Rcc,&time,&counts);
	if((retval != -4) && (retval != 0))
		{
		;
		}
		else
		if(time != 0.0)
			fEventIntensity = counts / time;
	if(fEventIntensity == 0.0)
		fEventSigma = 1.0;
		else
		fEventSigma = sqrt(fEventIntensity) * 0.9 / fEventIntensity;
	if(nCalledEvents == nEventCalls)
		{
		timeKillEvent(nEvent);
		retval = begwrk(5,Rdd,Rcc);
		bEventDeviceActive = FALSE;
		bEventDataValid = FALSE;
		PostMessage(hEventControlWnd,WM_COMMAND,cm_SteeringReady,0l);
		}
		else
		PostMessage(hEventControlWnd,WM_COMMAND,cm_CounterSet,nCalledEvents);
	};

BOOL TRadicon::InitializeEvent(HWND hwnd,int ec)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TRadicon::InitializeEvent(HWND hwnd,int ec)\n",time(zidx));
//pph***************************************************************************
	int			EventTime = 1000.0 * fExposureTime;

	hControlWnd 	= hwnd;
	nCalledEvents = 0;
	nEventCalls 	= ec;
	// check calltime
	if(EventTime <= 100)
		{
		MessageBox(GetFocus(),"Mezeit wurde zu klein gewhlt !","InitializeEvent",MBINFO);
		return FALSE;
		}
	bDataValid = FALSE;
	if(bDeviceActive)
		{
		bDeviceActive = FALSE;
		retval = begwrk(5,Rdd,Rcc);
		if(retval)
			return FailureOccured(5,retval);
		}
	// Intensimeter-Mode
	retval = begwrk(3,Rdd,Rcc);
	// Time-Count Mode
	// retval = begwrk(2,Rdd,Rcc);
	if(retval)
		return FailureOccured(3,retval);
	bDeviceActive = TRUE;
	bDataValid = TRUE;
	if(NULL != hControlWnd)
		nEvent = timeSetEvent(EventTime,1,(LPTIMECALLBACK)TRadicon::EventHandler,0,TIME_PERIODIC);
	return TRUE;
	};

BOOL TRadicon::SetSound(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TRadicon::SetSound(void)\n",time(zidx));
//pph***************************************************************************
	return SetParameters();
	};

BOOL TRadicon::FailureOccured(int func, int retv)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TRadicon::FailureOccured(int func, int retv)\n",time(zidx));
//pph***************************************************************************
	char          buf[MaxString];

	switch(func){
		case 1: sprintf(buf,"Init: %d",retv); 			break;
		case 2: sprintf(buf,"SetParam: %d",retv);   break;
		case 3: sprintf(buf,"BegWrk : %d",retv);    break;
		case 4: sprintf(buf,"GetInf: %d",retv);     break;
		case 9: sprintf(buf,"GetInf 9: %d",retv);   break;
		case 5: sprintf(buf,"BegWrk 5: %d",retv);   break;
		};
	MessageBox(GetFocus(),buf,"Gerte-Fehler",MBINFO);
	return R_Failure;
	};

//******************************************************************************
void TDList::CalibrateDlg(TCurve&)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TDList::CalibrateDlg(TCurve&)\n",time(zidx));
//pph***************************************************************************
	};

//********** Parameter-Dialog **************************************************
TScsParameters::TScsParameters(void) : TModalDlg("ScsParameter")
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TModalDlg(ScsParameter)\n",time(zidx));
//pph***************************************************************************
	int id = lpDList->LastId() + 1;
	while(id--)
		{
		if(RadiconHW == lpDList->DP(id)->GetHardware())
			{
			Device = (TRadicon *)lpDList->DP(id);
			break;
			}
		}
	if(0 > id)
		MessageBox(GetFocus(),"Kein scs !","Fehler",MBSTOP);
	};

#pragma argsused
BOOL TScsParameters::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TScsParameters::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)\n",time(zidx));
//pph***************************************************************************
	// Initialisieren der Parameterfenster
	FORWARD_WM_COMMAND(hwnd,cm_ParamSet,hwndCtl,0,SendMessage);
	SetFocus(GetDlgItem(GetHandle(),id_AngleRange));
	return TRUE;
	};

void TScsParameters::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TScsParameters::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)\n",time(zidx));
//pph***************************************************************************
	char   buf[MaxString];

	switch(id)
		{
		case cm_ParamSet:
		sprintf(buf,"%d",Device->wDacLowerThresh);
		SetDlgItemText(GetHandle(),id_LowerLevel,(LPSTR)buf);
		sprintf(buf,"%d",Device->wDacUpperThresh);
		SetDlgItemText(GetHandle(),id_UpperLevel,(LPSTR)buf);
		sprintf(buf,"%d",Device->wHighVoltage);
		SetDlgItemText(GetHandle(),id_HighVoltage,(LPSTR)buf);
		return;

		default:
		TModalDlg::Dlg_OnCommand(hwnd,id,hwndCtl,codeNotify);
		}
	};

BOOL TScsParameters::CanClose(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TScsParameters::CanClose(void)\n",time(zidx));
//pph***************************************************************************
	char  buf[MaxString];
	int   value,store;
	BOOL  bFailure = FALSE;

	GetDlgItemText(GetHandle(),id_UpperLevel,(LPSTR)buf,10);
	value = store = atoi(buf);
	value = min(1023,value);
	value = max(0,value);
	if(store != value)
		bFailure = TRUE;
	Device->wDacUpperThresh = value;

	GetDlgItemText(GetHandle(),id_LowerLevel,(LPSTR)buf,10);
	value = store = atoi(buf);
	value = min(1023,value);
	value = max(0,value);
	if(store != value)
		bFailure = TRUE;
	Device->wDacLowerThresh = value;

	if(Device->wDacLowerThresh >= Device->wDacUpperThresh)
		{
		bFailure = TRUE;
		Device->wDacLowerThresh = Device->wDacUpperThresh;
		}

	GetDlgItemText(GetHandle(),id_HighVoltage,(LPSTR)buf,10);
	value = store = atoi(buf);
	value = min(MaxHighVoltage,value);
	value = max(0,value);
	if(store != value)
		bFailure = TRUE;
	Device->wHighVoltage = value;

	if(bFailure)
		{
		PostMessage(GetHandle(),WM_COMMAND,cm_ParamSet,0);
		MessageBeep(0);
		return FALSE;
		}
	return TRUE;
	};

BOOL TScsParameters::LeaveDialog(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TScsParameters::LeaveDialog(void)\n",time(zidx));
//pph***************************************************************************
	return TRUE;
	};

//***** Dialog fr die allgemeinen Einstellungen der Me-Einheiten *************
TCommonDevParam::TCommonDevParam(const int sensid) : TModalDlg("CommonDevParam")
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TModalDlg(CommonDevParam)\n",time(zidx));
//pph***************************************************************************
	Device = lpDList->DP(sensid);
	};

#pragma argsused
BOOL TCommonDevParam::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TCommonDevParam::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)\n",time(zidx));
//pph***************************************************************************
	int   cnt;

	hDeviceList = GetDlgItem(hwnd,id_ChooseDevice);
	// Initialisieren der Parameterfenster
	SetFocus(GetDlgItem(hwnd,id_Level));
	cnt = 0;
	while(cnt <= lpDList->LastId())
		ComboBox_AddString(hDeviceList,lpDList->DP(cnt++)->Characteristic);
	FORWARD_WM_COMMAND(hwnd,cm_ParamSet,hwndCtl,0,SendMessage);
	FORWARD_WM_COMMAND(hwnd,cm_Initialization,hwndCtl,0,SendMessage);
	return TRUE;
	};

void TCommonDevParam::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TCommonDevParam::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)\n",time(zidx));
//pph***************************************************************************
	char    buf[MaxString];
	int     idx;

	switch(id)
		{
		case cm_ParamSet:
		ComboBox_SelectString(hDeviceList, 0,Device->Characteristic);
		CheckDlgButton(GetHandle(),id_Analysator,Device->bAnalysator);
		CheckDlgButton(GetHandle(),id_SoundSwitch,Device->bSound);
		CheckDlgButton(GetHandle(),id_ShowCounter,Device->bDeviceOpen);
		sprintf(buf,"%.1f",Device->fFailure*100.0);
		SetDlgItemText(GetHandle(),id_Failure,(LPSTR)buf);
		CheckDlgButton(GetHandle(),id_StaticFailure,Device->bStaticFailure);
		if(Device->bStaticFailure)
			EnableWindow(GetDlgItem(GetHandle(),id_Failure),TRUE);
			else
			EnableWindow(GetDlgItem(GetHandle(),id_Failure),FALSE);
		sprintf(buf,"%.2f",Device->fExposureTime);
		SetDlgItemText(GetHandle(),id_ExposureTime,(LPSTR)buf);
		sprintf(buf,"%lu",Device->dwExposureCounts);
		SetDlgItemText(GetHandle(),id_ExposureCounts,(LPSTR)buf);
		CheckDlgButton(GetHandle(),id_ShowCounter,Device->bDeviceOpen);
		return;

		case id_ShowCounter:
		if(!TCommonDevParam::CanClose())
			{
			PostMessage(GetHandle(),WM_COMMAND,cm_ParamSet,0);
			break;
			}
		if(!Device->bDeviceOpen)
			FORWARD_WM_COMMAND(GetFrameHandle(),cm_CallExecuteCounter,0,Device->GetId(),SendMessage);
			else
			FORWARD_WM_MDIDESTROY(GetClientHandle(),Device->hDisplayWnd,SendMessage);
		FORWARD_WM_COMMAND(hwnd,cm_ParamSet,0,0,SendMessage);
		break;

		case cm_ActivateChanges:
		Device->bSound = IsDlgButtonChecked(GetHandle(),id_SoundSwitch);
		if(Device->IsActive())
			{
			Device->MeasureStop();
			Device->SetSound();
			Device->SetParameters();
			Device->MeasureStart();
			}
		break;

		case id_SoundSwitch:
		FORWARD_WM_COMMAND(GetHandle(),cm_ActivateChanges,0,0,PostMessage);
		break;

		case cm_SpecificParameters:
		// spezifische Parameter fr einen Device setzen
		Device->SetSpezificParametersDlg();
		FORWARD_WM_COMMAND(GetHandle(),cm_ActivateChanges,0,0,PostMessage);
		break;

		case id_StaticFailure:
		Device->bStaticFailure = IsDlgButtonChecked(GetHandle(),id_StaticFailure);
		EnableWindow(GetDlgItem(hwnd,id_Failure),Device->bStaticFailure);
		break;

		case id_ChooseDevice:
		switch(codeNotify)
			{
			case CBN_SELCHANGE:
			idx = ComboBox_GetCurSel(hDeviceList);
			if((Device != lpDList->DP(idx)) && (idx != CB_ERR))
				{
				Device = lpDList->DP(idx);
				FORWARD_WM_COMMAND(hwnd,cm_ParamSet,0,0,SendMessage);
				}
			}
		break;

		case cm_RotateDevice:
		if(!CanClose())
			break;
		lpDList->SetDevice(Device->GetId()+1);
		Device = lpDList->DP();
		FORWARD_WM_COMMAND(hwnd,cm_ParamSet,0,0,SendMessage);
		break;

		default:
		TModalDlg::Dlg_OnCommand(hwnd,id,hwndCtl,codeNotify);
		}
	};

BOOL TCommonDevParam::CanClose(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TCommonDevParam::CanClose(void)\n",time(zidx));
//pph***************************************************************************
	char     buf[MaxString];
	float    fvalue;

	Device->bStaticFailure = IsDlgButtonChecked(GetHandle(),id_StaticFailure);
	Device->bSound = IsDlgButtonChecked(GetHandle(),id_SoundSwitch);
	GetDlgItemText(GetHandle(),id_Failure,(LPSTR)buf,10);
	fvalue = atof(buf);
	if((0.0 != fvalue))
		{
		Device->fFailure = fvalue/100.0;
		Device->fFailure = min(Device->fFailure,(float)1.0);
		Device->fFailure = max(Device->fFailure,(float)0.001);
		}
		else return FALSE;
	GetDlgItemText(GetHandle(),id_ExposureCounts,(LPSTR)buf,10);
	fvalue = atof(buf);
	if((0.0 != fvalue))
		{
		Device->dwExposureCounts = fvalue;
		if(fvalue > Device->dwUpperCountBound)
			Device->dwExposureCounts = Device->dwUpperCountBound;
		if(fvalue < Device->dwLowerCountBound)
			Device->dwExposureCounts = Device->dwLowerCountBound;
		}
		else return FALSE;

	GetDlgItemText(GetHandle(),id_ExposureTime,(LPSTR)buf,10);
	fvalue = atof(buf);
	if((0.0 != fvalue))
		{
		Device->fExposureTime = fvalue;
		Device->fExposureTime = min(Device->fExposureTime,Device->fUpperTimeBound);
		Device->fExposureTime = max(Device->fExposureTime,Device->fLowerTimeBound);
		}
		else return FALSE;
	Device->PushSettings();
	return TRUE;
	};

BOOL TCommonDevParam::LeaveDialog(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		counters.cpp		TCommonDevParam::LeaveDialog(void)\n",time(zidx));
//pph***************************************************************************
	if(Device->IsActive())
		{
		Device->MeasureStop();
		Device->SetSound();
		Device->SetParameters();
		Device->MeasureStart();
		}
		else
		{
		Device->SetSound();
		Device->SetParameters();
		}
	return TRUE;
	};
// __LastLine__





