#include    "rc_def.h"
#include    "comhead.h"
#pragma hdrstop

//hpp***************************************************************************
#include <time.h>
//pph***************************************************************************

//hpp***************************************************************************
extern FILE *trace;
extern time_t *zidx;
//pph***************************************************************************

// m_data.cpp
// (C) 1993,1994 by Heiko Damerow MPG AG "Roentgenbeugung"
// modul for the data representation
// const char	VersionStamp[] = "xx1.13xx";
#include		"m_devcom.h"
#include 		"m_steerg.h"
#include    "m_data.h"

extern  TMain       Main;
extern  LPDataBase	lpDBase;

// for data aquisition
extern	float				PointX[2],PointY[2];
extern	int					nMouseAction;
#define	XBNorm	40
#define YBNorm	20

static 	int         xBorder = XBNorm;
static 	int         yBorder = YBNorm;
static	int					retval;
static	POINT				RLArea[41];
static	HGDIOBJ	    gdiobj;
static	HBITMAP			hBitmap = NULL;
static	HCURSOR			hCursor,hOldCursor;
static	WORD 				RLdx = 350;
static	WORD 				RLdy = 500;
static  BOOL				bIncreasePP = FALSE;
static	double			clogval;
static  double			clinval;
static	BOOL				bAltCoorSystem = FALSE;

// Bezeichner korrespondieren mit den entsprechenden Enum-Typen
const	char 	aOutputType[6][15] 	= {	"RL-Bitmap","Raw Matrix",
																		"Curve","Number","BarGraph","Histogram"};

const	char 	aScaleType[3][15] 	= {	"Logarithmic","Linear","User"};

// #define Debug
//******************************************************************************
TBitmapSource::TBitmapSource(TPlotData *plotwnd)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TBitmapSource::TBitmapSource(TPlotData *plotwnd)\n",time(zidx));
//pph***************************************************************************
	char      tcol[10];
	char      Ident[] = "AreaScan";
	char      buf[MaxString];
	int       cnt;

	DataWnd = (TPlotData *)plotwnd;
	DataWnd->BSource = this;
	xBorder			= 40;
	yBorder			= 26;
	switch(DataWnd->eOutputType)
		{
		case ReciprokeLatticeBitmap: case MatrixBitmap:
		break;
		default:
		DataWnd->eOutputType = ReciprokeLatticeBitmap;
		}
	BMCoorSys = &DataWnd->AltCoorSys;
	*BMCoorSys = DataWnd->CoorSys;
	bAltCoorSystem = TRUE;
	BMCoorSys->zST = Logarithmic;
	BMCoorSys->yST = BMCoorSys->xST = Linear;
	hDIBInfo  	= NULL;
	hDIBData  	= NULL;
	hMemPal   	= NULL;
	RLArea[0].x = RLArea[0].y = 0;
	RLArea[1] 	= RLArea[2] = RLArea[3] = RLArea[4] = RLArea[0];
	GetPrivateProfileString(Ident,"LevelNumber","7",buf,MaxString,GetCFile());
	ColorTable.nColorRange = atoi(buf);
	for(cnt = 0; cnt < ColorTable.nColorRange; cnt++)
		{
		sprintf(tcol,"level%d",cnt);
		GetPrivateProfileString(Ident,tcol,"0.0",buf,MaxString,GetCFile());
		ColorTable.ColorMap[cnt] = atof(buf);
		if(ColorTable.ColorMap[cnt] == 0.0)
			ColorTable.ColorMap[cnt] = 0.5 + (0.1 * cnt);
		if(CreateDefaults())
			{
			sprintf(buf,"%.2f",ColorTable.ColorMap[cnt]);
			WritePrivateProfileString(Ident,tcol,buf,GetCFile());
			}
		}
	bGrayScalePalette = GetPrivateProfileInt(Ident,"swPalette",0,GetCFile());
	};

TBitmapSource::~TBitmapSource()
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TBitmapSource::~TBitmapSource()\n",time(zidx));
//pph***************************************************************************
	if(hDIBData != NULL)
		GlobalFree(hDIBData);
	if(hDIBInfo != NULL)
		GlobalFree(hDIBInfo);
	if(hMemPal != NULL)
		GlobalFree(hMemPal);
	if(::hBitmap)
		DeleteObject(::hBitmap);
	::hBitmap = NULL;
	bAltCoorSystem = FALSE;
	xBorder		= XBNorm;
	yBorder		= YBNorm;
	};

void TBitmapSource::New(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TBitmapSource::New(void)\n",time(zidx));
//pph***************************************************************************
	if(hDIBData != NULL)
		GlobalFree(hDIBData);
	hDIBData = NULL;
	if(hDIBInfo != NULL)
		GlobalFree(hDIBInfo);
	hDIBInfo = NULL;
	};

TOutputType TBitmapSource::GetType(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TBitmapSource::GetType(void)\n",time(zidx));
//pph***************************************************************************
	return DataWnd->eOutputType;
	};

/* DIB-Datei lesen */
BOOL TBitmapSource::ProcessBitmapFile(HFILE hStream)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TBitmapSource::ProcessBitmapFile(HFILE hStream)\n",time(zidx));
//pph***************************************************************************
	BITMAPINFOHEADER    bmInfoHeader;
	LPBITMAPINFO      	lpBMPInfo;
	int                 nColors;
	DWORD               memsize;
	HPBYTE							hpData;
  TScreen&            Screen = DataWnd->Screen;

	// File-Header lesen
	_lread(hStream,&BMPFileHdr,sizeof(BMPFileHdr));
	if(BMPFileHdr.bfType != *(UINT*)"BM")
		return FALSE; // Ausstieg bei falschem Marker
	// BITMAPINFOHEADER Struktur einlesen
	_lread(hStream,&bmInfoHeader,sizeof(bmInfoHeader));
	if(bmInfoHeader.biSize!=sizeof(BITMAPINFOHEADER))
		return FALSE; // Ausstieg bei falscher Gre
	// Wenn Anzahl benutzter Farben im Header stehen ...
	if(bmInfoHeader.biClrUsed!=0)
		nColors = (int)bmInfoHeader.biClrUsed; // ...verwenden...
		else
		{ // .. sonst einfach aus Bittiefe erechnen
		if(bmInfoHeader.biBitCount != 24)
			nColors = 1 << bmInfoHeader.biBitCount;
			else nColors = 0;
		bmInfoHeader.biClrUsed = nColors;
		}
	// ggf. biSizeImage nachtragen
	GetImageSize();
	// Speicher fuer Bitmapinfo + Farbpalette anfordern
	memsize = sizeof(BITMAPINFO) + (nColors-1)*sizeof(RGBQUAD);
	if(hDIBInfo)
		hDIBInfo = GlobalReAlloc(hDIBInfo,memsize,GMEM_MOVEABLE);
		else
		hDIBInfo = GlobalAlloc(GMEM_MOVEABLE,memsize);
	if(!hDIBInfo)
		return FALSE;
	lpBMPInfo = (LPBITMAPINFO)GlobalLock(hDIBInfo);
	// Header kopieren
	lpBMPInfo->bmiHeader = bmInfoHeader;
	// Farbtabelle lesen
	_lread(hStream,lpBMPInfo->bmiColors,sizeof(RGBQUAD)*nColors);
	// Speicher fuer die eigentliche Bitmap anfordern, einlesen
	if(hDIBData)
		hDIBData = GlobalReAlloc(hDIBData,bmInfoHeader.biSizeImage,GMEM_MOVEABLE);
		else
		hDIBData = GlobalAlloc(GMEM_MOVEABLE,bmInfoHeader.biSizeImage);
	Screen.dx = (int)bmInfoHeader.biWidth;
	Screen.dy = (int)bmInfoHeader.biHeight;
	GlobalUnlock(hDIBInfo);
	if(!hDIBData)
		return FALSE;
	hpData  = (HPBYTE)GlobalLock(hDIBData);
	_hread(hStream,hpData,bmInfoHeader.biSizeImage);
	GlobalUnlock(hDIBData);
	DataWnd->eOutputType = MatrixBitmap;
	if(::hBitmap)
		DeleteObject(::hBitmap);
	::hBitmap = NULL;
	return TRUE;
	};

DWORD TBitmapSource::GetImageSize(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TBitmapSource::GetImageSize(void)\n",time(zidx));
//pph***************************************************************************
	DWORD 						 	nBits;
	LPBITMAPINFOHEADER  lpBMPInfoHdr;
	LPBITMAPINFO      	lpBMPInfo;

	if(!hDIBInfo) return 1;
	lpBMPInfo = (LPBITMAPINFO)GlobalLock(hDIBInfo);
	lpBMPInfoHdr = &lpBMPInfo->bmiHeader;
	nBits = ((lpBMPInfoHdr->biWidth * lpBMPInfoHdr->biBitCount + 31)
		/ 32) * 4 ; // Bytes pro Zeile, Aufrunden auf DWords
	nBits *= (DWORD)lpBMPInfoHdr->biHeight;
	lpBMPInfoHdr->biSizeImage = nBits;
	GlobalUnlock(hDIBInfo);
	return nBits;
	};

LOGPALETTE *TBitmapSource::CreateDefaultPalette(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		*TBitmapSource::CreateDefaultPalette(void)\n",time(zidx));
//pph***************************************************************************
	// einigermaen gleichmigverteilte Standardpalette erzeugen
	int           size = sizeof(LOGPALETTE)+(16)*sizeof(PALETTEENTRY);

	LOGPALETTE *pPal=(LOGPALETTE *)new char[size];
	memset(pPal,0,size);
	pPal->palVersion = 0x300;
	pPal->palNumEntries = 16;
	if(bGrayScalePalette)
		{
		// grayscale palette
		char buf[][4] = { {255,255,255,0},     // 0
											{240,240,240,0},     // 1
											{207,207,207,0},     // 2
											{193,193,193,0},     // 3
											{166,166,166,0},     // 4
											{146,146,146,0},     // 5
											{128,128,128,0},     // 6
											{111,111,111,0},     // 7
											{ 71, 71, 71,0},     // 8
											{ 57, 57, 57,0},     // 9
											{ 18, 18, 18,0},     // 10
											{  0,  0,  0,0},     // 11
											{  0,  0,  0,0},     // 12
											{  0,  0,  0,0},     // 13
											{  0,  0,  0,0},     // 14
											{  0,  0,  0,0}      // 15
											};
		memcpy(pPal->palPalEntry,buf,4*16);
		}
		else
		{
		// color palette            RGB
		char buf[][4] = { {255,255,255,0},     // 0   white
											{128,128,128,0},     // 1   dark grey
											{192,192,192,0},     // 2   yellow grey
											{  0,  0,128,0},     // 3   dark blue
											{164,200,240,0},     // 4   yellow blue
											{  0,255,  0,0},     // 5   dark green
											{  0,128,  0,0},     // 6   yellow green
											{192,220,192,0},     // 7   grey green
											{128,  0,128,0},     // 8   dark yellow
											{255,  0,  0,0},     // 9   red
											{255,255,  0,0},     // 10  yellow
											{  0,  0,  0,0},     // 11  black
											{  0,  0,  0,0},     // 12  black
											{  0,  0,  0,0},     // 13
											{  0,  0,  0,0},     // 14
											{  0,  0,  0,0},     // 15
											};
		memcpy(pPal->palPalEntry,buf,4*16);
		}
	return pPal;
	};

LOGPALETTE *TBitmapSource::CreatePaletteFromDIB(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		*TBitmapSource::CreatePaletteFromDIB(void)\n",time(zidx));
//pph***************************************************************************
	// Palette aus DIB erzeugen
	LOGPALETTE    	*pPalette;
	PALETTEENTRY	  *pEntry;
	RGBQUAD       	*pRGB;
	int           	cnt;
	short						nColors;
	LPBITMAPINFO    lpBMPInfo;

	lpBMPInfo = (LPBITMAPINFO)GlobalLock(hDIBInfo);
	if(!lpBMPInfo) return NULL;
	nColors = (short)lpBMPInfo->bmiHeader.biClrUsed;
	if(nColors==0)
		{
		GlobalUnlock(hDIBInfo);
		return CreateDefaultPalette();
		}
	pPalette=(LOGPALETTE *)new char[sizeof(LOGPALETTE)+ (nColors-1)*sizeof(PALETTEENTRY)];
	if(pPalette)
		{
		pPalette->palVersion = 0x300;
		pPalette->palNumEntries = nColors;
		pRGB=lpBMPInfo->bmiColors;
		pEntry=pPalette->palPalEntry;
		for(cnt=0;cnt<nColors;cnt++)
			{
			pEntry->peRed = pRGB->rgbRed;
			pEntry->peGreen = pRGB->rgbGreen;
			pEntry->peBlue = pRGB->rgbBlue;
			pEntry->peFlags = 0;
			pRGB++; pEntry++;
			}
		}
	GlobalUnlock(hDIBInfo);
	return pPalette;
	};

void TBitmapSource::FillBMInfoFromPalette(LOGPALETTE *pPal)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TBitmapSource::FillBMInfoFromPalette(LOGPALETTE *pPal)\n",time(zidx));
//pph***************************************************************************
	PALETTEENTRY    	*pEntry;
	RGBQUAD         	*pRGB;
	int             	nColors,cnt;
	LPBITMAPINFO      lpBMPInfo;

	lpBMPInfo = (LPBITMAPINFO)GlobalLock(hDIBInfo);
	pRGB = lpBMPInfo->bmiColors;
	pEntry = pPal->palPalEntry;
	nColors = min((WORD)lpBMPInfo->bmiHeader.biClrUsed,(WORD)pPal->palNumEntries);
	for(cnt=0;cnt<nColors;cnt++)
		{
		pRGB->rgbRed   = pEntry->peRed;
		pRGB->rgbGreen = pEntry->peGreen;
		pRGB->rgbBlue  = pEntry->peBlue;
		pRGB++; pEntry++;
		}
	GlobalUnlock(hDIBInfo);
	};

LOGPALETTE * TBitmapSource::GetPalette(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TBitmapSource::GetPalette(void)\n",time(zidx));
//pph***************************************************************************
	LOGPALETTE  *logPal;

	logPal = CreatePaletteFromDIB();
	if(!logPal)
		logPal = CreateDefaultPalette();
	return logPal;
	};

HBITMAP TBitmapSource::CreateGDIObject(HDC hdc)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TBitmapSource::CreateGDIObject(HDC hdc)\n",time(zidx));
//pph***************************************************************************
	HPALETTE    		hPal,hDefPal;
	HPBYTE					hpData;
	LPBITMAPINFO    lpBMPInfo;

	hPal 				= CreatePalette(GetPalette());
	hDefPal 		= SelectPalette(hdc,hPal,FALSE);
	hpData  		= (HPBYTE) GlobalLock(hDIBData);
	lpBMPInfo  	= (LPBITMAPINFO) GlobalLock(hDIBInfo);
	RealizePalette(hdc);
	::hBitmap = CreateDIBitmap(hdc,&lpBMPInfo->bmiHeader,CBM_INIT,hpData,lpBMPInfo,DIB_RGB_COLORS);
	SelectPalette(hdc,hDefPal,FALSE);
	DeleteObject(hPal);
	GlobalUnlock(hDIBInfo);
	GlobalUnlock(hDIBData);
	return ::hBitmap;
	};

int TBitmapSource::GetColor(float intens)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TBitmapSource::GetColor(float intens)\n",time(zidx));
//pph***************************************************************************
	int   	ci;
	float   fval;

	switch(BMCoorSys->zST) {
		case Logarithmic:
		if(intens < BMCoorSys->zMin)
			return 0;
		fval = log10(intens / BMCoorSys->zMin) * clogval;
		if(fval > ColorTable.nColorRange)
			return 15; // the Color 15 should be black always
		return (int)fval;

		case Linear:
		fval = (intens - BMCoorSys->zMin) / clinval;
		if(fval < 0.0)
			return 0;
		if(fval > ColorTable.nColorRange)
			return 15; // the Color 15 should be black always
		return (int)fval;

		case User:
		fval = (intens - BMCoorSys->zMin) / clinval;
		for(ci = 0;ci < ColorTable.nColorRange; ci++)
			{
			if(ColorTable.ColorMap[ci] < fval)
				continue;
			return ci;
			}
		}
	return 15; // the Color 15 should be black always;
	};

void TBitmapSource::DrawBitmap(HDC hdc,int ofsx,int ofsy)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TBitmapSource::DrawBitmap(HDC hdc,int ofsx,int ofsy)\n",time(zidx));
//pph***************************************************************************
	BITMAP        bm;
	HDC           hMemDC;
  TScreen&      Screen = DataWnd->Screen;

	// Bitmap-Handle holen
	if(!::hBitmap)
		::hBitmap = CreateGDIObject(hdc);
	// Bitmap ausgeben
	hMemDC = CreateCompatibleDC(hdc);
	gdiobj = SelectObject(hMemDC,::hBitmap);
	SetMapMode(hMemDC,GetMapMode(hdc));
	GetObject(::hBitmap,sizeof(BITMAP),(LPSTR)&bm);
	BitBlt(hdc,Screen.x0+ofsx,Screen.y0+ofsy,Screen.dx,Screen.dy,hMemDC,0,0,SRCCOPY);
	// GDI aufrumen
	DeleteDC(hMemDC);
	};

void TBitmapSource::DrawBitmapFrame(HDC hdc)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TBitmapSource::DrawBitmapFrame(HDC hdc)\n",time(zidx));
//pph***************************************************************************
  TScreen&         Screen = DataWnd->Screen;

	// Frame zeichnen
	switch(DataWnd->eOutputType) {
		case ReciprokeLatticeBitmap:
		DrawMeasurementArea(hdc);
		break;
		}
	// Struktur CTable fllen
	ColorTable.place.left 	= Screen.x0 + Screen.dx + 20;
	ColorTable.place.right 	= ColorTable.place.left + 50;
	ColorTable.place.bottom	= Screen.y0;
	ColorTable.place.top		= ColorTable.place.bottom + ColorTable.nColorRange * 28;
	ColorTable.zMin         = BMCoorSys->zMin;
	ColorTable.zMax         = BMCoorSys->zMax;
	strcpy(ColorTable.zUnit,"Intensity");
	DrawColorTable(hdc,ColorTable);
	};

void TBitmapSource::SetScreen(HDC hdc,TScreen& screen)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TBitmapSource::SetScreen(HDC hdc,TScreen& screen)\n",time(zidx));
//pph***************************************************************************
	SIZE         	tagS;
	POINT					tagP;
	RECT					rect;
	int						dx,dy;
  TScreen&      Screen = DataWnd->Screen;

	// Bestimmen der Ausdehnung in Pixeln des Zeichen-Fensters
	GetClientRect(DataWnd->hWndChild,(LPRECT)&rect);
	// Daten-Bereich festlegen
	if(!Screen.dx || !Screen.dy)
		{
		Screen.dx = 200;
		Screen.dy = 100;
		MessageBox(GetFocus(),"Screen (1)","Message",MBINFO);
		}
	dx = (rect.right - rect.left);
	dy = (rect.bottom - rect.top);
	screen.x0 = 0;
	screen.x1 = dx;
	screen.y0 = 0;
	screen.y1 = dy;
	SetMapMode(hdc,MM_ANISOTROPIC);
	SetWindowExtEx(hdc,dx + xBorder,dy + yBorder,&tagS);
	SetViewportExtEx(hdc,dx + xBorder,-(dy + yBorder),&tagS);
	SetWindowOrgEx(hdc,0,0,&tagP);
	SetViewportOrgEx(hdc,xBorder,dy-yBorder,&tagP);
	};

void TBitmapSource::DrawColorTable(HDC hdc,TColorTable &ct)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TBitmapSource::DrawColorTable(HDC hdc,TColorTable &ct)\n",time(zidx));
//pph***************************************************************************
	int         	cnt,rs,fs = 14,bs = 9;
	int						xl,yt,xr,yb,red,green,blue;
	float					intens,sf;
	char					buf[30];
	LOGPALETTE  	*pPal;
	LOGFONT       lf;
	PALETTEENTRY	*pPE;
	HBRUSH      	hBrush,hOldBrush;
	HPEN					hPen,hOldPen;
	HFONT					hFont,hOldFont;

	pPal 	= GetPalette();
	pPE 	= pPal->palPalEntry;
	rs    = (ct.place.top - ct.place.bottom) / ct.nColorRange;

	switch(BMCoorSys->zST) {
		case Linear:
		sf = (BMCoorSys->zMax - BMCoorSys->zMin) / (float)ct.nColorRange;
		break;
		case Logarithmic:
		sf =  (float)ct.nColorRange / log10(BMCoorSys->zMax/BMCoorSys->zMin);
		break;
		}

	// Font selektieren
	memset(&lf,0,sizeof(LOGFONT));
	lf.lfHeight = fs;
	lf.lfWidth  = 0;
	lf.lfWeight = 200;
	lf.lfUnderline = FALSE;
	strcpy(lf.lfFaceName,"Times New Roman");
	hFont 		= CreateFontIndirect(&lf);
	hOldFont	= (HFONT)SelectObject(hdc,hFont);
	xl 				= ct.place.left;
	xr 				= ct.place.right;
	hPen			= CreatePen(PS_SOLID,1,RGB(0,0,0));
	hOldPen 	= (HPEN)SelectObject(hdc,hPen);
	for(cnt = 0;cnt <= ct.nColorRange;cnt++)
		{
		red 	= pPE[cnt].peRed;
		green = pPE[cnt].peGreen;
		blue 	= pPE[cnt].peBlue;
		hBrush = CreateSolidBrush(RGB(red,green,blue));
		if(!cnt)
			hOldBrush = (HBRUSH)SelectObject(hdc,hBrush);
			else
			gdiobj = SelectObject(hdc,hBrush);
		switch(BMCoorSys->zST) {
			case Linear:
			intens = BMCoorSys->zMin + (float)cnt * sf;
			break;
			case Logarithmic:
			intens = pow(10,(float)cnt / sf) * BMCoorSys->zMin;
			break;
			}
		if(intens < 10.0)
			sprintf(buf,"I < %.3f",intens);
			else
			if(intens < 100.0)
				sprintf(buf,"I < %.2f",intens);
				else
				if(intens < 1000.0)
					sprintf(buf,"I < %.1f",intens);
					else
					sprintf(buf,"I < %.0f",intens);
		yb = ct.place.bottom + cnt * rs;
		TextOut(hdc,xl,yb-1,(LPSTR)buf,strlen(buf));
		yt = (++yb) + bs;
		Rectangle(hdc,xl,yt,xr,yb);
		hBrush = (HBRUSH)SelectObject(hdc,hOldBrush);
		retval = DeleteObject(hBrush);
		}
	gdiobj = SelectObject(hdc,hOldFont);
	retval = DeleteObject(hFont);
	gdiobj = SelectObject(hdc,hOldPen);
	retval = DeleteObject(hPen);
	};

void TBitmapSource::GenerateAngleSpaceBitmap(
															BOOL bStretch,int nAddedPoints,
															int nEnlargedLines,DWORD nBits )
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		)\n",time(zidx));
//pph***************************************************************************
	TCurve*       Scan		= lpDBase->GetCurve(0);
	//! TCurve*       ScanRep = lpDBase->GetScanReport();
	UINT					nScanNumber   = lpDBase->GetCNumber();
	//! UINT					nPointNumber 	= Scan->GetPNumber();
	TKSystem  		KS_AR;
	LPBYTE        lpBuf;
	HPBYTE				hpData;
	DWORD         addr;
	char					Msg[MaxString];
	int           dlines,cnt,cx,cy,ival;
	float					fIntens,fIs,dd,imin = 1e7,imax = 1e-7;
  TScreen&      Screen = DataWnd->Screen;

	if(DataWnd->eOutputType != MatrixBitmap) return;
	//****************************************************************************
	//**** Bitmap formatieren ****************************************************
	// set waiting cursor
	hCursor = LoadCursor(NULL,IDC_WAIT);
	hOldCursor = SetCursor(hCursor);
	// get pointer to data area
	hpData  = (HPBYTE)GlobalLock(hDIBData);
	if(!hpData)
		{
		MessageBox(GetFocus(),"Cannot create memory object (2)","Message",MBINFO);
		return;
		}
	// inquire intensity range
	if(1 < nScanNumber)
		{
		int cy = nScanNumber;
		while(cy--)
			{
			Scan = lpDBase->GetCurve(cy);
			imin = min(Scan->Min[P_Y],imin);
			imax = max(Scan->Max[P_Y],imax);
			}
		}
		else
		imin = 0.1; imax = 1000.0;
	sprintf(Msg,"Intensity Range [%.3f-->%.3f]   ",imin,imax);
	// compute cacheval for colormap
	switch(BMCoorSys->zST) {
		case Logarithmic:
		clogval = ColorTable.nColorRange / log10(BMCoorSys->zMax / BMCoorSys->zMin);
		break;
		case Linear: case User:
		clinval = (BMCoorSys->zMax - BMCoorSys->zMin);
		}
	// Inquire measurement area
	DataWnd->SetMeasurementArea(KS_AR);
	// sort ranges
	for(cnt = 1,ival = 0;cnt < 4;cnt++)
		if(KS_AR[cnt].y < KS_AR[ival].y) ival = cnt;
	BMCoorSys->yMin = KS_AR[ival].y;
	for(cnt=1,ival = 0;cnt < 4;cnt++)
		if(KS_AR[cnt].y > KS_AR[ival].y) ival = cnt;
	BMCoorSys->yMax = KS_AR[ival].y;
	for(cnt=1,ival = 0;cnt<4;cnt++)
		if(KS_AR[cnt].x < KS_AR[ival].x) ival = cnt;
	BMCoorSys->xMin = KS_AR[ival].x;
	for(cnt=1,ival = 0;cnt<4;cnt++)
		if(KS_AR[cnt].x > KS_AR[ival].x) ival = cnt;
	BMCoorSys->xMax = KS_AR[ival].x;
	// compute scaling factors
	BMCoorSys->xSF = (BMCoorSys->xMax - BMCoorSys->xMin);
	BMCoorSys->ySF = (BMCoorSys->yMax - BMCoorSys->yMin);
	BMCoorSys->xSF = BMCoorSys->xSF / Screen.dx;
	BMCoorSys->ySF = BMCoorSys->ySF / Screen.dy;
	addr = cy = 0;
	lpBuf = (LPBYTE) new BYTE [Screen.dx];
	while(cy < Screen.dy)
		{
		dlines = nEnlargedLines;
		Scan = lpDBase->GetCurve(cy / nEnlargedLines);
		Scan->SetPP(0);
		Scan->FastOpen();
		for(cx = 0;cx < Screen.dx;cx++)
			{
			Scan->FastPGet(dd,fIntens,dd);
			cnt = 1;
			while(cnt++ < nAddedPoints)
				{
				Scan->FastPGet(dd,fIs,dd);
				fIntens += fIs;
				}
			lpBuf[cx] = (char)GetColor(fIntens);
			if(bStretch)
				lpBuf[++cx] = lpBuf[cx-1];
			}
		while(dlines--)
			{
#ifdef __WIN32__
			memcpy((HPBYTE)&(hpData[addr]),(LPBYTE)lpBuf,Screen.dx);
#else
			hmemcpy((HPBYTE)&(hpData[addr]),(LPBYTE)lpBuf,Screen.dx);
#endif
			addr += nBits;
			cy++;
			}
		if(lpDBase->GetCNumber() < ((cy + 2) / nEnlargedLines))
			break;
		Scan->FastClose();
		}
	delete[] lpBuf;
	SetCursor(::hOldCursor);
	SetInfo(Msg);
	GlobalUnlock(hDIBData);
	};

void TBitmapSource::DrawMeasurementArea(HDC hdc)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TBitmapSource::DrawMeasurementArea(HDC hdc)\n",time(zidx));
//pph***************************************************************************
	int 				  dx,dy,cnt,ival;
	float 	 		  dARx,dARy,mf;
	float		 		  fOmega,fTheta;
	TKSystem  	  KS_AR,KS_RL;
	TCoorSystem	  coorsys;
	HPEN          hOldPen,hPenDot;
	float				  factor = M_PI / (0.5 * Main.WaveLength);
	TScreen&      Screen = DataWnd->Screen;

	DataWnd->SetMeasurementArea(KS_AR);
	if(!::hBitmap)
		{
		Screen.dy = ::RLdy = max((WORD)0,min((WORD)700,::RLdy));
		Screen.dx = ((::RLdx + 3) / 4) * 4;
		DataWnd->SetRanges();
		BMCoorSys->zMax = DataWnd->UpperBound;
		BMCoorSys->zMin = DataWnd->LowerBound;
		switch(BMCoorSys->zST) {
			case Logarithmic:
			clogval = ColorTable.nColorRange / log10(BMCoorSys->zMax / BMCoorSys->zMin);
			break;
			case Linear: case User:
			clinval = (BMCoorSys->zMax - BMCoorSys->zMin);
			}
		// compute new Coordinate system ranges
		for(cnt=0;cnt<4;cnt++)
			{
			KS_RL[cnt].x 		= ArToRLx (KS_AR[cnt].y,KS_AR[cnt].x);
			KS_RL[cnt].y 		= ArToRLy (KS_AR[cnt].y,KS_AR[cnt].x);
			KS_RL[cnt].Ord  = -1;
			}
		// sort ranges
		for(cnt=1,ival=0;cnt<4;cnt++)
			if(KS_RL[cnt].y < KS_RL[ival].y) ival = cnt;
		BMCoorSys->yMin = KS_RL[ival].y;
		for(cnt=1,ival=0;cnt<4;cnt++)
			if(KS_RL[cnt].y > KS_RL[ival].y) ival = cnt;
		BMCoorSys->yMax = KS_RL[ival].y;
		for(cnt=1,ival=0;cnt<4;cnt++)
			if(KS_RL[cnt].x < KS_RL[ival].x) ival = cnt;
		BMCoorSys->xMin = KS_RL[ival].x;
		for(cnt=1,ival=0;cnt<4;cnt++)
			if(KS_RL[cnt].x > KS_RL[ival].x) ival = cnt;
		BMCoorSys->xMax = KS_RL[ival].x;
		// compute scaling factors
		BMCoorSys->xSF = (BMCoorSys->xMax - BMCoorSys->xMin);
		BMCoorSys->ySF = (BMCoorSys->yMax - BMCoorSys->yMin);
		BMCoorSys->xSF = BMCoorSys->xSF / Screen.dx;
		BMCoorSys->ySF = BMCoorSys->ySF / Screen.dy;
		//** fix scale relation
		if(!DataWnd->bXY_Scaling)
			{
			if(BMCoorSys->xSF < BMCoorSys->ySF)
				BMCoorSys->xSF = BMCoorSys->ySF;
				else
				BMCoorSys->ySF = BMCoorSys->xSF;
			}
		//** center bitmap
		mf = (BMCoorSys->xMax - BMCoorSys->xMin) / BMCoorSys->xSF;
		mf = (Screen.dx - mf) / 2 * BMCoorSys->xSF;
		BMCoorSys->xMin -= mf;
		BMCoorSys->xMax -= mf;
		mf = (BMCoorSys->yMax - BMCoorSys->yMin) / BMCoorSys->ySF;
		mf = (Screen.dy - mf) / 2 * BMCoorSys->ySF;
		BMCoorSys->yMin -= mf;
		BMCoorSys->yMax -= mf;
		factor = M_PI / (0.5 * Main.WaveLength);
		BMCoorSys->xSF 	*= factor;
		BMCoorSys->ySF	*= factor;
		BMCoorSys->xMin *= factor;
		BMCoorSys->xMax *= factor;
		BMCoorSys->yMin *= factor;
		BMCoorSys->yMax *= factor;
		}
	// access the first coordinate structure to get angle koordinate system
	coorsys = *BMCoorSys;
	factor = (0.5 * Main.WaveLength) / M_PI;
	coorsys.xSF 	*= factor;
	coorsys.ySF		*= factor;
	coorsys.xMin 	*= factor;
	coorsys.xMax 	*= factor;
	coorsys.yMin 	*= factor;
	coorsys.yMax 	*= factor;
	// compute frame
	for(int pp=0;pp<4;pp++)
		{
		dARx = KS_AR[(pp+1) % 4].x - KS_AR[pp].x;
		dARy = KS_AR[(pp+1) % 4].y - KS_AR[pp].y;
		switch(pp) {
			case 0: dx = dy = 1; 			break;
			case 1: dx = 1; dy = -1; 	break;
			case 2: dx = dy = -1; 		break;
			case 3: dx = -1; dy = 1; 	break;
			}
		for(cnt = pp*10;cnt < (pp+1) * 10;cnt++)
			{
			fOmega = KS_AR[pp].y + (cnt % 10) * (dARy / 10.0);
			fTheta = KS_AR[pp].x + (cnt % 10) * (dARx / 10.0);
			RLArea[cnt].x = (ArToRLx (fOmega,fTheta) - coorsys.xMin) / coorsys.xSF;
			RLArea[cnt].y = (ArToRLy (fOmega,fTheta) - coorsys.yMin) / coorsys.ySF;
			RLArea[cnt].x += dx;
			RLArea[cnt].y += dy;
			}
		}
	RLArea[40] = RLArea[0];
	hPenDot   = CreatePen(PS_DOT,1,RGB(255,0,0));
	hOldPen = (HPEN)SelectObject(hdc,hPenDot);
	Polyline(hdc,RLArea,41);
	gdiobj = SelectObject(hdc,hOldPen);
	retval = DeleteObject(hPenDot);
	};

void TBitmapSource::GenerateRLBitmap(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TBitmapSource::GenerateRLBitmap(void)\n",time(zidx));
//pph***************************************************************************
	int       	  cnt,cx,cy,rlx,rly,ival;
	TCurve*    	  Scan		= lpDBase->GetCurve(0);
	TCurve*    	  ScanRep = lpDBase->GetScanReport();
	UINT			 	  nScanNumber   = lpDBase->GetCNumber();
	UINT			 	  nPointNumber 	= Scan->GetPNumber();
	HPBYTE			  hpData;
	DWORD         addr,MaxAddr = GetImageSize();
	char				  Msg[MaxString];
	float				  fOmega,fThetaPsd,fTheta,fIntens,dd,mf;
	TKSystem  	  KS_RL,KS_AR;
	double			  fome,fthe,factor;
	BYTE				  nColor;
	BOOL				  bOutsideData = FALSE;
	TScreen&      Screen = DataWnd->Screen;

	if(DataWnd->eOutputType != ReciprokeLatticeBitmap) return;
	hpData  = (HPBYTE)GlobalLock(hDIBData);
	if(!hpData) return;
	//****************************************************************************
	//**** Bitmap formatieren ****************************************************
	// set waiting cursor
	hCursor = LoadCursor(NULL,IDC_WAIT);
	hOldCursor = SetCursor(hCursor);
	// get pointer to data area
	hpData  = (HPBYTE)GlobalLock(hDIBData);
	if(!hpData)
		{
		MessageBox(GetFocus(),"Cannot create memory object (2)","Message",MBINFO);
		return;
		}
	// inquire intensity range
	float	imin=1e7,imax=1e-7;
	if(1 < nScanNumber)
		{
		int cy = nScanNumber;
		while(cy--)
			{
			Scan = lpDBase->GetCurve(cy);
			imin = min(Scan->Min[P_Y],imin);
			imax = max(Scan->Max[P_Y],imax);
			}
		}
		else
		imin = imax = 0.0;
	sprintf(Msg,"Intensity Range [%.3f-->%.3f]   ",imin,imax);
	// compute cacheval for colormap
	switch(BMCoorSys->zST) {
		case Logarithmic:
		clogval = ColorTable.nColorRange / log10(BMCoorSys->zMax / BMCoorSys->zMin);
		break;
		case Linear: case User:
		clinval = (BMCoorSys->zMax - BMCoorSys->zMin);
		}
	// transformate data
	// KS_AR,ArToRLx (x,y) : "x" means "theta" and "y" means "omega"
	// compute new Coordinate system ranges
	DataWnd->SetMeasurementArea(KS_AR);
	for(cnt=0;cnt<4;cnt++)
		{
		KS_RL[cnt].x 		= ArToRLx (KS_AR[cnt].y,KS_AR[cnt].x);
		KS_RL[cnt].y 		= ArToRLy (KS_AR[cnt].y,KS_AR[cnt].x);
		KS_RL[cnt].Ord  = -1;
		}
	// sort ranges
	for(cnt=1,ival=0;cnt<4;cnt++)
		if(KS_RL[cnt].y < KS_RL[ival].y) ival = cnt;
	BMCoorSys->yMin = KS_RL[ival].y;
	for(cnt=1,ival=0;cnt<4;cnt++)
		if(KS_RL[cnt].y > KS_RL[ival].y) ival = cnt;
	BMCoorSys->yMax = KS_RL[ival].y;
	for(cnt=1,ival=0;cnt<4;cnt++)
		if(KS_RL[cnt].x < KS_RL[ival].x) ival = cnt;
	BMCoorSys->xMin = KS_RL[ival].x;
	for(cnt=1,ival=0;cnt<4;cnt++)
		if(KS_RL[cnt].x > KS_RL[ival].x) ival = cnt;
	BMCoorSys->xMax = KS_RL[ival].x;
	//** compute scaling factors
	BMCoorSys->xSF = (BMCoorSys->xMax - BMCoorSys->xMin);
	BMCoorSys->ySF = (BMCoorSys->yMax - BMCoorSys->yMin);
	BMCoorSys->xSF = (double)BMCoorSys->xSF / Screen.dx;
	BMCoorSys->ySF = (double)BMCoorSys->ySF / Screen.dy;
	if(!DataWnd->bXY_Scaling)
		{
		//** fix scale relation
		if(BMCoorSys->xSF < BMCoorSys->ySF)
			BMCoorSys->xSF = BMCoorSys->ySF;
			else
			BMCoorSys->ySF = BMCoorSys->xSF;
		}
	//** center bitmap
	mf = (BMCoorSys->xMax - BMCoorSys->xMin) / BMCoorSys->xSF;
	mf = (Screen.dx - mf) / 2 * BMCoorSys->xSF;
	BMCoorSys->xMin -= mf;
	BMCoorSys->xMax -= mf;
	mf = (BMCoorSys->yMax - BMCoorSys->yMin) / BMCoorSys->ySF;
	mf = (Screen.dy - mf) / 2 * BMCoorSys->ySF;
	BMCoorSys->yMin -= mf;
	BMCoorSys->yMax -= mf;
	//** draw points in bitmap source
	ScanRep->FastOpen();
	MaxAddr -= Screen.dx + 1;
	for(cy = 0;cy < nScanNumber;cy++)
		{
		Scan = lpDBase->GetCurve(cy);
		Scan->SetPP(0);
		Scan->FastOpen();
		ScanRep->SetPP(cy);
		ScanRep->FastPGet(fOmega,dd,dd);
		fTheta = DataWnd->GetThetaOffset(cy);
		nPointNumber = Scan->GetPNumber();
		if(!(cy % 30))
			{
			sprintf(Msg,"Row %d with %d Columns",cy,nPointNumber);
			SetInfo(Msg);
			}
		for(cx = 0;cx < nPointNumber;cx++)
			{
			Scan->FastPGet(fThetaPsd,fIntens,dd);
			nColor = (short)GetColor(fIntens);
			if(nColor == 0)
				continue;
			// Omega kleiner Null ist nur bei relativer Skalierung
			// sinnvoll
			// if(fOmega < 0.0) continue;
			fome = DegToRad (fOmega);
			fthe = DegToRad (fTheta + fThetaPsd);
			rlx	= (ArToRLx (fome,fthe) - BMCoorSys->xMin) / BMCoorSys->xSF;
			rly	= (ArToRLy (fome,fthe) - BMCoorSys->yMin) / BMCoorSys->ySF;
			addr = rlx + (DWORD)rly * Screen.dx;
			if(addr > MaxAddr)
				{
				bOutsideData = TRUE;
				continue;
				}
			hpData[addr] = nColor;
			if(!::bIncreasePP) continue;
			if(	((addr+1) > MaxAddr) || ((addr+Screen.dx) > MaxAddr) ||
					((addr-1) > MaxAddr) || ((addr-Screen.dx) > MaxAddr) )
				continue;
			hpData[addr-1] = nColor;
			hpData[addr+1] = nColor;
			hpData[addr - Screen.dx] = nColor;
			hpData[addr + Screen.dx] = nColor;
			}
		Scan->FastClose();
		}
	sprintf(Msg,"Intensity Range [%.3f-->%.3f] ",imin,imax);
	if(bOutsideData)
		strcat(Msg,"Bereichsberschreitung !");
	ScanRep->FastClose();
	factor = M_PI / (0.5 * Main.WaveLength);
	BMCoorSys->xSF 	*= factor;
	BMCoorSys->ySF	*= factor;
	BMCoorSys->xMin *= factor;
	BMCoorSys->xMax *= factor;
	BMCoorSys->yMin *= factor;
	BMCoorSys->yMax *= factor;
	SetCursor(::hOldCursor);
	SetInfo(Msg);
	GlobalUnlock(hDIBData);
	};

void TBitmapSource::FormatDBaseToBitmapSource(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TBitmapSource::FormatDBaseToBitmapSource(void)\n",time(zidx));
//pph***************************************************************************
	LPBITMAPINFOHEADER  lpBMPInfoHdr;
	LPBITMAPINFO      	lpBMPInfo;
	LOGPALETTE          *palette;
	DWORD								nBits,dwSize;
	TCurve*             Scan		= lpDBase->GetCurve(0);
	//! TCurve*             ScanRep = lpDBase->GetScanReport();
	UINT								nScanNumber   = lpDBase->GetCNumber();
	UINT								nPointNumber 	= Scan->GetPNumber();
	BOOL								bStretch;
	int                 nAddedPoints,nEnlargedLines;
  TScreen&            Screen = DataWnd->Screen;

	if(::hBitmap)
		DeleteObject(::hBitmap);
	::hBitmap = NULL;
	if((2 > nScanNumber) || (2 > nPointNumber))
		{
		Screen.dx = (Screen.x1 - Screen.x0) * 0.8;
		Screen.dy = (Screen.y1 - Screen.y0) * 0.9;
		DataWnd->SetRanges();
		DataWnd->AltCoorSys = DataWnd->CoorSys;
		// compute scaling factors
		BMCoorSys->xSF = (BMCoorSys->xMax - BMCoorSys->xMin);
		BMCoorSys->ySF = (BMCoorSys->yMax - BMCoorSys->yMin);
		BMCoorSys->xSF = BMCoorSys->xSF / Screen.dx;
		BMCoorSys->ySF = BMCoorSys->ySF / Screen.dx;
		return;
		}
	// inquire measurement Ranges
	DataWnd->SetRanges();
	DataWnd->AltCoorSys = DataWnd->CoorSys;
	BMCoorSys->xST = BMCoorSys->yST = Linear;
	if(BMCoorSys->xMin <= 0.0)
		BMCoorSys->xMin = 0.0001;
	if(BMCoorSys->yMin <= 0.0)
		BMCoorSys->yMin = 0.0001;
	//******** create header for device independend bitmap ***********************
	dwSize = sizeof(BITMAPINFO) + (16)*sizeof(RGBQUAD);
	if(hDIBInfo)
		hDIBInfo = GlobalReAlloc(hDIBInfo,dwSize,GMEM_MOVEABLE);
		else
		hDIBInfo = GlobalAlloc(GMEM_MOVEABLE,dwSize);
	if(!hDIBInfo)
		{
		MessageBox(GetFocus(),"Cannot create memory object (1)","Message",MBINFO);
		return;
		}
	lpBMPInfo     = (LPBITMAPINFO)GlobalLock(hDIBInfo);
	lpBMPInfoHdr  = &lpBMPInfo->bmiHeader;
	lpBMPInfoHdr->biSize          = sizeof(BITMAPINFOHEADER);
	lpBMPInfoHdr->biPlanes        = 1;
	lpBMPInfoHdr->biBitCount      = 8;
	lpBMPInfoHdr->biSizeImage     = 0;  // Because BI_RGB
	lpBMPInfoHdr->biCompression   = BI_RGB;
	lpBMPInfoHdr->biXPelsPerMeter = lpBMPInfoHdr->biYPelsPerMeter = 0;
	lpBMPInfoHdr->biClrUsed       = 16;
	lpBMPInfoHdr->biClrImportant  = 0;
	// Palette bereitstellen
	palette = CreateDefaultPalette();
	FillBMInfoFromPalette(palette);
	//************ compute bitmap size ****************
	switch(DataWnd->eOutputType) {
		case ReciprokeLatticeBitmap:
		Screen.dy = ::RLdy = max((WORD)0,min((WORD)700,::RLdy));
		Screen.dx = ((::RLdx + 3) / 4) * 4;
		lpBMPInfoHdr->biWidth	= Screen.dx;
		lpBMPInfoHdr->biHeight= Screen.dy;
		break;

		case MatrixBitmap:
		Screen.dx = nPointNumber;
		nAddedPoints  = (Screen.dx / 520) + 1;
		bStretch      = ((Screen.dx / 260) + 1) % 2;
		Screen.dx = Screen.dx / nAddedPoints * (bStretch?2:1);
		Screen.dy = nScanNumber;
		nEnlargedLines = min((WORD)6,max((WORD)1,(WORD)(440/nScanNumber)));
		lpBMPInfoHdr->biWidth 	= ((Screen.dx + 3) / 4) * 4;
		lpBMPInfoHdr->biHeight 	= Screen.dy * nEnlargedLines;
		Screen.dx = (int)lpBMPInfoHdr->biWidth;
		Screen.dy = (int)lpBMPInfoHdr->biHeight;
		nBits = ((lpBMPInfoHdr->biWidth*lpBMPInfoHdr->biBitCount + 31) / 32) * 4 ;
		break;

		default:
		MessageBox(GetFocus(),"Unknown OutputType","Message",MBINFO);
		}
	// allocate memory for bitmap bits
	if(hDIBData)
		GlobalFree(hDIBData);
	hDIBData = GlobalAlloc(GHND,GetImageSize());
	SetInfo("Datensatz in einen Bitmap wandeln");
	switch(DataWnd->eOutputType) {
		case ReciprokeLatticeBitmap:
		GenerateRLBitmap();
		break;

		case MatrixBitmap:
		GenerateAngleSpaceBitmap(bStretch,nAddedPoints,nEnlargedLines,nBits);
		break;
		}
	};

HGLOBAL TBitmapSource::RenderDIB(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TBitmapSource::RenderDIB(void)\n",time(zidx));
//pph***************************************************************************
	HGLOBAL       hMem;
	long          szInfo;
	HPBYTE 				hpNewData;
	HPBYTE 				hpData;
	LPBITMAPINFO  lpBMPInfo;


	lpBMPInfo  = (LPBITMAPINFO) GlobalLock(hDIBInfo);
	if(hDIBData && lpBMPInfo)
		{
		szInfo = sizeof(BITMAPINFO)
					 +(lpBMPInfo->bmiHeader.biClrUsed-1) * sizeof(RGBQUAD);
		hMem = GlobalAlloc(GMEM_MOVEABLE,szInfo+GlobalSize(hDIBData));
		if(hMem)
			{
			hpNewData = (HPBYTE)GlobalLock(hMem);
			memcpy(hpNewData,lpBMPInfo,(int)szInfo);
			hpData  = (HPBYTE) GlobalLock(hDIBData);
			// move bitmap bits
#ifdef __WIN32__
			memcpy(hpNewData+szInfo,hpData,GlobalSize(hDIBData));
#else
			hmemcpy(hpNewData+szInfo,hpData,GlobalSize(hDIBData));
#endif
			GlobalUnlock(hDIBData);
			GlobalUnlock(hMem);
			GlobalUnlock(hDIBInfo);
			}
		return hMem;
		}
		else
		return NULL;
	};

void TBitmapSource::UpdateBitmapSource(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TBitmapSource::UpdateBitmapSource(void)\n",time(zidx));
//pph***************************************************************************
	};

//******************************************************************************
//**********        Klasse PlotData              *****************************
//******************************************************************************
TPlotData::TPlotData() : TMDIWindow()
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TMDIWindow()\n",time(zidx));
//pph***************************************************************************
	LOGFONT     lf;

	set_new_handler(0);
	CoorSys.xST     = Linear;
	CoorSys.yST     = Logarithmic;
	CoorSys.zST 		= Linear;
	eOutputType    	= Curve;
	bXY_Scaling     = FALSE;
	bButtonDown    	= FALSE;
	LowerBound     	= 1e1;
	UpperBound     	= 1e5;
	bSecondaryCoor	= FALSE;
	bAltCoorSystem	= FALSE;
  Screen.x0       = 1;
  Screen.x1       = 200;
  Screen.dx       = 200;
  Screen.y0       = 1;
  Screen.y1       = 100;
  Screen.dy       = 100;
	SecondCurve    	= (TCurve *) new TCurve(200);
	BSource					= NULL;
	memset(&lf,0,sizeof(LOGFONT));
	lf.lfHeight      = -13;
	lf.lfWidth       = 0; // wird automatisch entsprechend der Hhe gesetzt
	lf.lfWeight      = 400;
	lf.lfUnderline   = FALSE;
	lstrcpy(lf.lfFaceName,"Times New Roman");
	hFont = CreateFontIndirect(&lf);
	if(eOutputType <= MatrixBitmap)  // notify type TOutputType
		{
		new TBitmapSource(this);
		BSource->FormatDBaseToBitmapSource();
		}
		else
		SetRanges();
	AltCoorSys = CoorSys;
	EnablePaint();
	};

TPlotData::~TPlotData()
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TPlotData::~TPlotData()\n",time(zidx));
//pph***************************************************************************
	delete SecondCurve;
	if(eOutputType <= MatrixBitmap)
		delete BSource;
	retval = DeleteObject(hFont);
	};

BOOL TPlotData::New(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TPlotData::New(void)\n",time(zidx));
//pph***************************************************************************
	if(eOutputType <= MatrixBitmap)
		BSource->New();
	return TMDIWindow::New();
	}

void TPlotData::Size(HWND hWnd,WPARAM,LPARAM)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TPlotData::Size(HWND hWnd,WPARAM,LPARAM)\n",time(zidx));
//pph***************************************************************************
	GetClientRect(hWnd,&WndRect);
	if(!::hBitmap && (eOutputType <= MatrixBitmap))
		{
		Screen.dx = (WndRect.right - WndRect.left) - xBorder;
		Screen.x0 = 0;
		Screen.x1 = Screen.dx;
		Screen.dx *= 0.8;
		Screen.dy = (WndRect.bottom - WndRect.top) - yBorder;
		Screen.y0 = 0;
		Screen.y1 = Screen.dy;
		Screen.dy *= 0.9;
		}
	};

void TPlotData::SetRanges(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TPlotData::SetRanges(void)\n",time(zidx));
//pph***************************************************************************
	CoorSys.xMin = 0.01;
	CoorSys.xMax = 100.0;
	if(eOutputType <= MatrixBitmap)
		{
		CoorSys.yMin = 0.01;
		CoorSys.yMax = 100.0;
		CoorSys.zMax = UpperBound;
		CoorSys.zMin = LowerBound;
		}
		else
		{
		CoorSys.xMin = 0.01;
		CoorSys.xMax = 100.0;
		CoorSys.yMax = UpperBound;
		CoorSys.yMin = LowerBound;
		}
	};

void TPlotData::lButtonDown(WPARAM,LPARAM lParam)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TPlotData::lButtonDown(WPARAM,LPARAM lParam)\n",time(zidx));
//pph***************************************************************************
	float					y;
	char      		buf[MaxString];
	int       		xi,yi;
	TCoorSystem*	pCoorSys;

	DragDC = GetDC(hWndChild);
	bButtonDown = TRUE;
	SetCapture(hWndChild);
	switch(eOutputType) {
		case ReciprokeLatticeBitmap:
		case MatrixBitmap:
		xi = LOWORD(lParam) - xBorder;
		yi = Screen.y1 - HIWORD(lParam) - yBorder;
		pCoorSys = &AltCoorSys;
		break;

		default:
		xi = LOWORD(lParam) - xBorder;
		yi = Screen.y1 - HIWORD(lParam);
		pCoorSys = &CoorSys;
		}
	switch(pCoorSys->xST) {
			case Logarithmic:
			break;
			case Linear:
			xo = ((float)xi * pCoorSys->xSF) + pCoorSys->xMin;
			break;
			}
	switch(pCoorSys->yST) {
		case Logarithmic:
		y = yi * pCoorSys->ySF;
		if(y > 7.0)
			y = yi * log10(pCoorSys->yMax / pCoorSys->yMin) / Screen.dx;
		yo = pow(10,y) * pCoorSys->yMin;
		break;
		case Linear:
		yo = (yi * pCoorSys->ySF) + pCoorSys->yMin;
		break;
		}
	switch(nMouseAction) {
		case 100:
		PointX[0] = xo;
		PointY[0] = yo;
		break;
		default:
		sprintf(buf,"X = %.2E  Y = %.2E",xo,yo);
		SetInfo(buf);
		}
	};

void TPlotData::MouseMove(WPARAM,LPARAM lParam)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TPlotData::MouseMove(WPARAM,LPARAM lParam)\n",time(zidx));
//pph***************************************************************************
	char      		buf[MaxString];
	int       		xi,yi;
	float     		x,y;
	TCoorSystem*	pCoorSys;


	if(!bButtonDown) return;
	xi = LOWORD(lParam) - xBorder;
	yi = Screen.y1 - HIWORD(lParam);
	switch(eOutputType) {
		case ReciprokeLatticeBitmap:
		case MatrixBitmap:
		pCoorSys = &AltCoorSys;
		break;

		default:
		pCoorSys = &CoorSys;
		}
	switch(pCoorSys->xST) {
		case Logarithmic:
		break;
		case Linear:
		x = ((float)xi * pCoorSys->xSF) + pCoorSys->xMin;
		break;
		}
	switch(pCoorSys->yST) {
		case Logarithmic:
		y = yi * pCoorSys->ySF;
		if(y > 7.0)
			y = yi * log10(pCoorSys->yMax / pCoorSys->yMin) / Screen.dx;
		y = pow(10,y) * pCoorSys->yMin;
		break;
		case Linear:
		y = (yi * pCoorSys->ySF) + pCoorSys->yMin;
		break;
		}
	switch(nMouseAction) {
		case 100:
		PointX[1] = x;
		PointY[1] = y;
		sprintf(buf,"Linie von (%.3E,%.3E) bis (%.3E,%.3E)",PointX[0],PointY[0],PointX[1],PointY[1]);
		break;
		default:
		sprintf(buf,"dX = %.2E  dY = %.2E",x - xo,y - yo);
		}
	SetInfo(buf);
	};

void TPlotData::lButtonUp(WPARAM,LPARAM)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TPlotData::lButtonUp(WPARAM,LPARAM)\n",time(zidx));
//pph***************************************************************************
	bButtonDown = FALSE;
	ReleaseDC(hWndChild,DragDC);
	ReleaseCapture();
	};

BOOL TPlotData::SetMeasurementArea(TKSystem &ks)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TPlotData::SetMeasurementArea(TKSystem &ks)\n",time(zidx));
//pph***************************************************************************
	ks[0].x 	= 1.0;
	ks[0].y 	= 1.0;
	ks[0].Ord = 0;
	ks[1].x 	= 10.0;
	ks[1].y 	= 1.0;
	ks[1].Ord = 1;
	ks[2].x 	= 10.0;
	ks[2].y 	= 10.0;
	ks[2].Ord = 2;
	ks[3].x 	= 1.0;
	ks[3].y 	= 10.0;
	ks[3].Ord = 3;
	return TRUE;
	};

void TPlotData::RenderFormat(WPARAM wParam)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TPlotData::RenderFormat(WPARAM wParam)\n",time(zidx));
//pph***************************************************************************
	HANDLE hClip;

	if(eOutputType > MatrixBitmap) return;
	switch(wParam) {
		case CF_BITMAP:
		hClip = (HANDLE)BSource->CreateGDIObject(GetDC(hWndChild));
		SetClipboardData(CF_BITMAP,hClip);
		break;

		case CF_PALETTE:
		hClip = (HANDLE)CreatePalette(BSource->GetPalette());
		SetClipboardData(CF_PALETTE,hClip);
		break;

		case CF_DIB:
		hClip = BSource->RenderDIB();
		SetClipboardData(CF_DIB,hClip);
		break;
		}
	};

void TPlotData::RenderAllFormats(WPARAM)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TPlotData::RenderAllFormats(WPARAM)\n",time(zidx));
//pph***************************************************************************
	UINT uFormat=0;

	OpenClipboard(hWndChild);
	// hier stand ein =, was soll das?
	while(NULL != (uFormat = EnumClipboardFormats(uFormat)))
		SendMessage(hWndChild,WM_RENDERFORMAT,uFormat,0L);
	CloseClipboard();
	};

void TPlotData::DoCopy(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TPlotData::DoCopy(void)\n",time(zidx));
//pph***************************************************************************
	if((eOutputType > MatrixBitmap) || !OpenClipboard(hWndChild)) return;
	EmptyClipboard();
	SetClipboardData(CF_DIB,NULL);
	SetClipboardData(CF_PALETTE,NULL);
	CloseClipboard();
	};

void TPlotData::DrawCoordinateSystem(HDC hdc)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TPlotData::DrawCoordinateSystem(HDC hdc)\n",time(zidx));
//pph***************************************************************************
	HFONT        	hOldFont;
	HPEN         	hOldPen,hPenDot,hPenBlack;
	TCoorSystem*	pCoorSys;
	SIZE         	tagS;
	POINT        	egde[5];
	char					fmt[20],buf[40];
	float        	fval,manti,tiles;
	int						i,expn,sign;

	hPenBlack = CreatePen(PS_SOLID,2,RGB(0,0,0));
	hPenDot   = CreatePen(PS_DOT,1,RGB(0,0,0));
	hOldFont = (HFONT)SelectObject(hdc,hFont);
	hOldPen = (HPEN)SelectObject(hdc,hPenBlack);
	// Rahmen zeichnen
	egde[0].x = egde[3].x = Screen.x0;
	egde[1].x = egde[2].x = Screen.x0 + Screen.dx;
	egde[0].y = egde[1].y = Screen.y0;
	egde[2].y = egde[3].y = Screen.y0 + Screen.dy;
	egde[4] = egde[0];
	Polyline(hdc,egde,5);
	//************  Absizze  (x) *************************************************
	switch(eOutputType) {
		case Curve:
		pCoorSys = &CoorSys;
		strcpy(fmt,"%.3f");
		fval = fabs(pCoorSys->xMax - pCoorSys->xMin);
		if(fval < 1.1)
			fmt[2] = '3';
			else
			if(fval < 11)
				fmt[2] = '2';
				else
				fmt[2] = '1';
		tiles = 10.0;
		break;

		case ReciprokeLatticeBitmap:
		pCoorSys = &AltCoorSys;
		strcpy(fmt,"%.2E");
		tiles = 5.0;
		break;
		default:
		pCoorSys = &AltCoorSys;
		tiles = 5.0;
		strcpy(fmt,"%.2E");
		}
	for(i = 0;i < tiles;i++)
		{
		fval = i / tiles * Screen.dx;
		egde[0].x = egde[1].x = Screen.x0 + fval;
		egde[0].y = Screen.y0 + Screen.dy;
		egde[1].y = Screen.y0 + Screen.dy - 5;
		Polyline(hdc,egde,2);
		egde[0].y = Screen.y0 + 5;
		egde[1].y = Screen.y0;
		Polyline(hdc,egde,2);
		sprintf(buf,fmt,pCoorSys->xMin + fval * pCoorSys->xSF);
		GetTextExtentPoint(hdc,buf,strlen(buf),&tagS);
		tagS.cx /= 2;
		tagS.cy /= 2;
		TextOut(hdc,egde[0].x - tagS.cx,tagS.cy - yBorder / 2,buf,strlen(buf));
		}
	//************ Ordinate (y) **************************************************
	switch(eOutputType) {
		case Curve:
		gdiobj = SelectObject(hdc,hPenDot);
		tiles = 5.0;
		for(i = 1;i < tiles;i++)
			{
			egde[0].y = egde[1].y = 1 + i / tiles * Screen.dy + Screen.y0;
			egde[0].x = Screen.x0;
			egde[1].x = Screen.x0 + Screen.dx;
			Polyline(hdc,egde,2);
			}
		strcpy(fmt,"%.2E");
		break;

		case ReciprokeLatticeBitmap:
		tiles = 5.0;
		break;

		case MatrixBitmap:
		tiles = 5.0;
		break;
		}
	gdiobj = SelectObject(hdc,hPenBlack);
	for(i = 1;i < tiles;i++)
		{
		fval = i / tiles * Screen.dy;
		egde[0].y = egde[1].y = Screen.x0 + fval;
		egde[0].x = Screen.x0 + Screen.dx;
		egde[1].x = Screen.x0 + Screen.dx - 5;
		Polyline(hdc,egde,2);
		egde[0].x = Screen.x0 + 5;
		egde[1].x = Screen.x0;
		Polyline(hdc,egde,2);
		switch(pCoorSys->yST) {
			case Linear:
			fval = pCoorSys->yMin + fval * pCoorSys->ySF;
			break;
			default:
			fval = pCoorSys->yMin * pow(10,fval * pCoorSys->ySF);
			}
		if(fval > 0.0)
			sign = 1;
			else
			if(fval < 0.0)
				sign = -1;
				else
				sign = 0;
		switch(sign) {
			case -1:
			expn = ceil(log10(-fval));
			manti = -fval / pow(10,expn);
			sprintf(buf,"-%.1fE%d",manti,expn);
			break;
			case 0:
			sprintf(buf,"0.00");
			break;
			default:
			expn = ceil(log10(fval));
			manti = fval / pow(10,expn);
			sprintf(buf,"%.1fE%d",manti,expn);
			}
		GetTextExtentPoint(hdc,buf,strlen(buf),&tagS);
		tagS.cx /= 2;
		tagS.cy /= 2;
		egde[0].y += tagS.cy;
		egde[0].x  = -(tagS.cx + xBorder * 0.5);
		TextOut(hdc,egde[0].x,egde[0].y,(LPSTR)buf,strlen(buf));
		}
	//****************************************************************************
	gdiobj = SelectObject(hdc,hOldPen);
	retval = DeleteObject(hPenBlack);
	retval = DeleteObject(hPenDot);
	gdiobj = SelectObject(hdc,hOldFont);
	};

void TPlotData::Paint(HDC hdc,PAINTSTRUCT *)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TPlotData::Paint(HDC hdc,PAINTSTRUCT *)\n",time(zidx));
//pph***************************************************************************
	int           cnt = 0;
	HPEN          hOldPen,hPen;
	LPPOINT       lpPoints;
	SIZE         	tagS;
	POINT					tagP;
	RECT					rect;

	if(!bEnablePaint) return;
	switch(eOutputType) {
		case Curve:
		if(bAltCoorSystem)
			{
			CoorSys = AltCoorSys;
			bAltCoorSystem = FALSE;
			}
			else
			SetRanges();
		// Bestimmen der Ausdehnung in Pixeln des Zeichen-Fensters
		GetClientRect(hWndChild,(LPRECT)&rect);
		// Daten-Bereich festlegen
		Screen.dx = (rect.right - rect.left) - xBorder;
		Screen.x0 = 0;
		Screen.x1 = Screen.dx;
		Screen.dy = (rect.bottom - rect.top) - yBorder;
		Screen.y0 = 0;
		Screen.y1 = Screen.dy;
		SetMapMode(hdc,MM_ANISOTROPIC);
		SetWindowExtEx(hdc,Screen.dx + xBorder,Screen.dy + yBorder,&tagS);
		SetViewportExtEx(hdc,Screen.dx + xBorder,-(Screen.dy + yBorder),&tagS);
		SetWindowOrgEx(hdc,0,0,&tagP);
		SetViewportOrgEx(hdc,xBorder,Screen.dy,&tagP);
		// inquire scaling parameters
		CoorSys.xSF  = (CoorSys.xMax - CoorSys.xMin) / Screen.dx;
		switch(CoorSys.yST) {
			case Linear:
			CoorSys.ySF = (CoorSys.yMax-CoorSys.yMin) / Screen.dy;
			break;
			default:
			CoorSys.ySF = log10(CoorSys.yMax/CoorSys.yMin) / Screen.dy;
			}
		if(WholeWnd())
			DrawCoordinateSystem(hdc); // don't redraw coordinate system
		if(1 < SecondCurve->GetPNumber())
			{
			lpPoints = (LPPOINT)new POINT [SecondCurve->GetPNumber()];
			SecondCurve->SetPP(0);
			FormatCurveToPLine(SecondCurve,lpPoints,cnt);
			hPen = CreatePen(PS_SOLID,1,RGB(0,0,255));
			hOldPen = (HPEN)SelectObject(hdc,hPen);
			Polyline(hdc,lpPoints,cnt);
			gdiobj = SelectObject(hdc,hOldPen);
			retval = DeleteObject(hPen);
			delete[] lpPoints;
			}
		if(1 < MainCurve->GetPNumber())
			{
			MainCurve->FastOpen();
			if(WholeWnd())
				{
				lpPoints = (LPPOINT)new POINT [MainCurve->GetPNumber()];
				MainCurve->SetPP(0);
				}
				else
				{
				lpPoints = (LPPOINT)new POINT [2];
				MainCurve->SetPP(30000);
				MainCurve->BackStep();
				}
			FormatCurveToPLine(MainCurve,lpPoints,cnt);
			MainCurve->FastClose();
			hPen = CreatePen(PS_SOLID,1,RGB(255,0,0));
			hOldPen = (HPEN)SelectObject(hdc,hPen);
			Polyline(hdc,lpPoints,cnt);
			gdiobj = SelectObject(hdc,hOldPen);
			retval = DeleteObject(hPen);
			delete[] lpPoints;
			}
		break;

		case ReciprokeLatticeBitmap: case MatrixBitmap:
		// if(!WholeWnd()) BSource->UpdateBitmapSource();
		GetClientRect(hWndChild,(LPRECT)&rect);
		BSource->SetScreen(hdc,Screen);
		SetMapMode(hdc,MM_TEXT);
		BSource->DrawBitmap(hdc,0,-Screen.dy);
		BSource->SetScreen(hdc,Screen);
		BSource->DrawBitmapFrame(hdc); // do this first
		DrawCoordinateSystem(hdc);     // then execute this line
		break;
		} // switch
	return;
	};

void TPlotData::FormatCurveToPLine(TCurve*crv,LPPOINT lpPoints,int &pcnt)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TPlotData::FormatCurveToPLine(TCurve*crv,LPPOINT lpPoints,int &pcnt)\n",time(zidx));
//pph***************************************************************************
	float   x1,x,y,z,xt,offset = GetThetaOffset(0);
	int     idx = 0;

	// read first point
	if(bSecondaryCoor)
		crv->FastPGet(z,y,x);
		else
		{
		crv->FastPGet(x,y,z);
		x += offset;
		}
	lpPoints[idx].x = (x - CoorSys.xMin) / CoorSys.xSF;
	switch(CoorSys.yST) {
		case Linear:
		lpPoints[idx].y = (y - CoorSys.yMin) / CoorSys.ySF;
		break;
		default:
		if(y > CoorSys.yMin)
			lpPoints[idx].y = log10(y / CoorSys.yMin) / CoorSys.ySF;
			else
			lpPoints[idx].y = 0;
		}
	// read further points
	for(idx = 1;crv->FastPGet(x1,y,xt);idx++)
		{
		if(!bSecondaryCoor)
			{
			xt = x1;
			xt += offset;
			}
		if(fabs(xt-x) == 0.0) continue;
		lpPoints[idx].x = (xt - CoorSys.xMin) / CoorSys.xSF;
		if(lpPoints[idx-1].x == lpPoints[idx].x)
			{
			idx--;
			continue;
			}
		switch(CoorSys.yST) {
			case Linear:
			lpPoints[idx].y = (y - CoorSys.yMin) / CoorSys.ySF;
			break;
			default:
			if(y > CoorSys.yMin)
				lpPoints[idx].y = log10(y / CoorSys.yMin) / CoorSys.ySF;
				else
				lpPoints[idx].y = 0;
			}
		}
	pcnt = idx;
	};

void TPlotData::SetKSProperties(TKSProperties* ksp)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TPlotData::SetKSProperties(TKSProperties* ksp)\n",time(zidx));
//pph***************************************************************************
	if(!ksp) return;
	AltCoorSys.yMin = ksp->fMinY;
	AltCoorSys.yMax = ksp->fMaxY;
	AltCoorSys.xMin = ksp->fMinX;
	AltCoorSys.xMax = ksp->fMaxX;
	if(ksp->bLogarithmicY)
		AltCoorSys.yST = Logarithmic;
		else
		AltCoorSys.yST = Linear;
	AltCoorSys.xST = Logarithmic;
	bAltCoorSystem = TRUE;
	UpdateWnd(0);
	};

void TPlotData::PickUpData(LPARAM data)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TPlotData::PickUpData(LPARAM data)\n",time(zidx));
//pph***************************************************************************
	*SecondCurve = *((TCurve *)data);
	};

void TPlotData::KillSecondCurve(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TPlotData::KillSecondCurve(void)\n",time(zidx));
//pph***************************************************************************
	SecondCurve->New();
	UpdateWnd(0);
	};

void TPlotData::FreezeCurve(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TPlotData::FreezeCurve(void)\n",time(zidx));
//pph***************************************************************************
	*SecondCurve = *MainCurve;
	};

void TPlotData::SaveSecondCurve(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TPlotData::SaveSecondCurve(void)\n",time(zidx));
//pph***************************************************************************
	char        nfn[MAXPATH];
	char				Filter[MaxString];
	OFSTRUCT    of;
	char        msg[MaxString+1];
	int         hFile;
	float      	x;
	float      	y,z;
	char       	buf[MaxString];

	strcpy(nfn,"*.bk");
	strcpy(Filter,"Vergleichs-Scan (*.bk)|*.bk||");
	strcpy(msg,"Vergleichs-Scan speichern...");
	FileSave(msg,Filter,nfn,"");
	if(nfn[0] == '*') return;
	if(0 != strcmp(strupr(&(nfn[strlen(nfn)-2])),"BK")) return;
	hFile = OpenFile(nfn,&of,OF_CREATE);
	if(-1 == hFile)
		{
		LoadString(Main.hInstance,sth_CannotCreateFile,msg,MaxString);
		MessageBox(GetFocus(),msg,"Fehler",MB_OK | MB_ICONHAND);
		return;
		}
	::hOldCursor = SetCursor(LoadCursor(NULL,IDC_WAIT));
	strcpy(buf,"[Header]\nVergleichs-Scan \n");
	strcat(buf,"X >> Intensity >> Z\n[Data]\n");
	_lwrite(hFile,(LPSTR)buf,strlen(buf));
	SecondCurve->SetPP(0);
	SecondCurve->FastOpen();
	while(SecondCurve->FastPGet(x,y,z))
		{
		sprintf(buf,"%.3f %.3f %.3f\n",x,y,z);
		_lwrite(hFile,(LPSTR)buf,strlen(buf));
		}
	_lclose(hFile);
	SecondCurve->FastClose();
	SetCursor(::hOldCursor);
	return;
	};

//****** Dialog zum setzen der PlotFenster-Eigenschaften ***********************
TCurveShowParam::TCurveShowParam(TMDIWindow *pwnd) : TModalDlg("DataShowParam")
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TModalDlg(DataShowParam)\n",time(zidx));
//pph***************************************************************************
	PlotWindow = (TPlotData *)pwnd;
	CoorSys = &PlotWindow->CoorSys;
	};

BOOL  TCurveShowParam::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TCurveShowParam::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)\n",time(zidx));
//pph***************************************************************************
	char  buf[MaxString];

	TModalDlg::Dlg_OnInit(hwnd,hwndCtl,lParam);
	SetFocus(GetDlgItem(hwnd,IDOK));
	bBitmapIsCreated = (PlotWindow->eOutputType <= MatrixBitmap);
	hWndOutputT = GetDlgItem(hwnd,id_ShowDataType);
	hWndScaleT = GetDlgItem(hwnd,id_ScaleTypeY);

	ComboBox_AddString(hWndOutputT,aOutputType[0]);
	ComboBox_AddString(hWndOutputT,aOutputType[1]);
	ComboBox_AddString(hWndOutputT,aOutputType[2]);
	ComboBox_SelectString(hWndOutputT,0,aOutputType[PlotWindow->eOutputType-1]);

	ComboBox_AddString(hWndScaleT,aScaleType[0]);
	ComboBox_AddString(hWndScaleT,aScaleType[1]);
	ComboBox_AddString(hWndScaleT,aScaleType[2]);
	ComboBox_SelectString(hWndScaleT,0,aScaleType[CoorSys->yST-1]);

	CheckDlgButton(hwnd,id_X_Scala,!PlotWindow->bSecondaryCoor);
	CheckDlgButton(hwnd,id_Z_Scala,PlotWindow->bSecondaryCoor);
	CheckDlgButton(hwnd,id_Dilatation,::bIncreasePP);
	CheckDlgButton(hwnd,id_XY_Scaling,PlotWindow->bXY_Scaling);
	SetDlgItemInt(hwnd,id_dy,::RLdy,FALSE);
	if(PlotWindow->eOutputType > MatrixBitmap)
		{
		EnableWindow(GetDlgItem(hwnd,id_XY_Scaling),FALSE);
		EnableWindow(GetDlgItem(hwnd,id_Dilatation),FALSE);
		EnableWindow(GetDlgItem(hwnd,id_dy),FALSE);
		}
		else
		{
		EnableWindow(GetDlgItem(hwnd,id_XY_Scaling),TRUE);
		EnableWindow(GetDlgItem(hwnd,id_Dilatation),TRUE);
		EnableWindow(GetDlgItem(hwnd,id_dy),TRUE);
		}
	sprintf(buf,"%.2E",PlotWindow->UpperBound);
	SetDlgItemText(hwnd,id_MaxIntensity,(LPSTR)buf);
	sprintf(buf,"%.2E",PlotWindow->LowerBound);
	SetDlgItemText(hwnd,id_MinIntensity,(LPSTR)buf);
	return TRUE;
	};

#pragma argsused
void TCurveShowParam::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TCurveShowParam::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)\n",time(zidx));
//pph***************************************************************************
	int 	retval;

	switch(id)
		{
		case cm_SetupParameters:
		CanClose();
		PlotWindow->UpdateWnd(0);
		break;

		case id_ScaleTypeY:
		switch(codeNotify)
			{
			case CBN_SELCHANGE:
			retval = ComboBox_GetCurSel(hWndScaleT);
			if(retval != CB_ERR)
				{
				switch(retval+1)
					{
					case Linear: 	CoorSys->yST = Linear; 			break;
					case User:   	CoorSys->yST = User; 				break;
					default: 			CoorSys->yST = Logarithmic;
					}
		  PlotWindow->UpdateWnd(0);
				break;
				}
				else
				break;
			}
		break;

		case id_ShowDataType:
		switch(codeNotify)
			{
			case CBN_SELCHANGE:
			retval = ComboBox_GetCurSel(hWndOutputT);
			if(retval != CB_ERR)
				{
				switch(retval+1)
					{
					case MatrixBitmap:
					if(Main.AreaScanWindow != PlotWindow) break;
					PlotWindow->eOutputType = MatrixBitmap;
					break;
					case ReciprokeLatticeBitmap:
					if(Main.AreaScanWindow != PlotWindow) break;
					PlotWindow->eOutputType = ReciprokeLatticeBitmap;
					break;
					case Curve: default:
					PlotWindow->eOutputType = Curve;
					break;
					}
				PlotWindow->DisablePaint();
				}
				else
				break;
			}
		if(PlotWindow->eOutputType > MatrixBitmap)
			{
			EnableWindow(GetDlgItem(hwnd,id_Dilatation),FALSE);
			EnableWindow(GetDlgItem(hwnd,id_XY_Scaling),FALSE);
			EnableWindow(GetDlgItem(hwnd,id_dy),FALSE);
			}
			else
			{
			EnableWindow(GetDlgItem(hwnd,id_Dilatation),TRUE);
			EnableWindow(GetDlgItem(hwnd,id_XY_Scaling),TRUE);
			EnableWindow(GetDlgItem(hwnd,id_dy),TRUE);
			}
		break;

		default:
		TModalDlg::Dlg_OnCommand(hwnd,id,hwndCtl,codeNotify);
		}
	};

BOOL TCurveShowParam::CanClose(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TCurveShowParam::CanClose(void)\n",time(zidx));
//pph***************************************************************************
	char      buf[MaxString];
	float     valueF;

	PlotWindow->DisablePaint();
	::bIncreasePP =	IsDlgButtonChecked(GetHandle(),id_Dilatation);
	GetDlgItemText(GetHandle(),id_dy,buf,MaxString);
	::RLdy = (WORD)atoi(buf);
	PlotWindow->bXY_Scaling = IsDlgButtonChecked(GetHandle(),id_XY_Scaling);
	PlotWindow->bSecondaryCoor = IsDlgButtonChecked(GetHandle(),id_Z_Scala);
	GetDlgItemText(GetHandle(),id_MaxIntensity,(LPSTR)buf,10);
	valueF = atof(buf);
	if(valueF < 1e10)
		PlotWindow->UpperBound = valueF;
		else
		return FALSE;
	GetDlgItemText(GetHandle(),id_MinIntensity,(LPSTR)buf,10);
	valueF = atof(buf);
	if(valueF >= 1e-4)
		PlotWindow->LowerBound = valueF;
		else
		return FALSE;
	if(PlotWindow->LowerBound >= PlotWindow->UpperBound)
		return FALSE;

	if(PlotWindow->eOutputType <= MatrixBitmap)
		{
		CoorSys->zST = CoorSys->yST;
		if(!bBitmapIsCreated)
			new TBitmapSource((TPlotData *)PlotWindow);
		bBitmapIsCreated = TRUE;
		PlotWindow->BSource->FormatDBaseToBitmapSource();
		}
		else
		{
		if(bBitmapIsCreated)
			{
			delete PlotWindow->BSource;
			bBitmapIsCreated = FALSE;
			}
		}
	PlotWindow->EnablePaint();
	return TRUE;
	};

BOOL TCurveShowParam::LeaveDialog(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_data.cpp		TCurveShowParam::LeaveDialog(void)\n",time(zidx));
//pph***************************************************************************
	if(PlotWindow->eOutputType <= MatrixBitmap)
		{
		CoorSys = &PlotWindow->AltCoorSys;
		CoorSys->yST = CoorSys->xST = Linear;
		}
	PlotWindow->EnablePaint();
	return TRUE;
	};
// __LastLine__
