#include    "rc_def.h"
#include    "comhead.h"
#pragma hdrstop

//hpp***************************************************************************
#include <time.h>
//pph***************************************************************************

//hpp***************************************************************************
extern FILE *trace;
extern time_t *zidx;
//pph***************************************************************************

// m_steerg.cpp
// (C) 1994 by Heiko Damerow MPG AG "Roentgenbeugung"
// Ablauf-Steuerung

extern "C" {
TIMECALLBACK RecallSteering;
}

#include    "m_devcom.h"
#include    "m_steerg.h"
#include    "m_xscan.h"
#include    "l_layer.h"
#include    "c_layer.h"
#include    "m_dlg.h"
#include    "m_layer.h"
//*****************************************************************************
//**********  Data Area  ******************************************************
//*****************************************************************************
//*****************************************************************************

extern  TMain        Main;
extern  LPDList       lpDList;
extern  UINT        wm_WakeUpSteering;
static  UINT        nEvent = 0;
static   HGDIOBJ     testobc;
static   TAdjustmentWindow*      AdjWnd;
        TAdjustmentParameter    AdjustmentParameter;
        TDevice*     Monitor;
        BOOL        bMonitorUsed  = FALSE;
// Weiterfhrung der Bewegung nach ca. 6 Sekunden
static  const int    nAskTicks      = 30;
static  const int     nMaxAskNumber = 200;
static  int          nAskIdx;
static  DWORD        dwStartTimeTicks;
static  HWND        hHostWindow;

// for interrupt and restart any macro
static  float        fExposureTime;
static  DWORD        dwExposureCounts;
static  float        fFailure;

// Modul-Instance
TSteering    Steering = TSteering();

//*****************************************************************************
//**********  Code Area  ******************************************************
//*****************************************************************************
//*****************************************************************************
TCmd::TCmd(TCmdTag ct)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TCmd::TCmd(TCmdTag ct)\n",time(zidx));
//pph***************************************************************************
  bMoveOk = new BOOL [mlGetAxisNumber()];
  memset(bMoveOk,FALSE,mlGetAxisNumber()*sizeof(BOOL));
  eCmdId = ct.Id;
  bPositionValid = TRUE;
  bNoMeasure = FALSE;
  nFailureId = 0;
};

TCmd::~TCmd(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TCmd::~TCmd(void)\n",time(zidx));
//pph***************************************************************************
  Steering.StopTimer();
  delete[] bMoveOk;
};

BOOL TCmd::DeviceRequest(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TCmd::DeviceRequest(void)\n",time(zidx));
//pph***************************************************************************
  return TRUE;
};

LPSTR TCmd::GetFailure(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TCmd::GetFailure(void)\n",time(zidx));
//pph***************************************************************************
  return (LPSTR)"Fehler";
};

TCCode TCmd::WakeUp(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TCmd::WakeUp(void)\n",time(zidx));
//pph***************************************************************************
  //*** does no change the actual motor
  int     mid;
  double  dd;
  BOOL     bAllReady = TRUE;

  for(mid = 0;mid < mlGetAxisNumber();mid++)
    if(!bMoveOk[mid])
    {
      if(mlIsMoveFinish(mid))
      {
        DelayTime(5);
        if(mlGetDistance(mid,dd))
          bMoveOk[mid] = TRUE;
        else
          bAllReady = FALSE;
      }
      else
        bAllReady = FALSE;
    }
  if(bAllReady)
  {
    bPositionValid = TRUE;
    if(bNoMeasure)
    {
      bNoMeasure = FALSE;
      return DoAction();
    }
      else
      return CMeasure;
  }
  return CRecall;
  /*
  if(nAskIdx > 0)
    return CRecall;
    else
    return DoAction();
  */
};

BOOL TCmd::StartMove(const int mid,double dDistance)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TCmd::StartMove(const int mid,double dDistance)\n",time(zidx));
//pph***************************************************************************
  //*** does no change the actual motor
  if(mlMoveToDistance(mid,dDistance))
  {
    bMoveOk[mid] = FALSE;
    bPositionValid = FALSE;
    nAskIdx = nMaxAskNumber;
    DelayTime(20);
    return TRUE;
  }
  return FALSE;
};

TCCode TCmd::DoAction(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TCmd::DoAction(void)\n",time(zidx));
//pph***************************************************************************
  switch(eStep) {
    case CFirstStep    : return FirstStep();
    case CControlStep  : return ControlStep();
    case CReadyStep    :  return ReadyStep();
    case CReady        :  return Ready();
  }
  MessageBox(GetFocus(),"Unbekannter Schritt","Meldung",MBINFO);
  return CStop;
}

//*****************************************************************************
//*****  Command Frame  *******************************************************
//*****************************************************************************
/*
TxCmd::TxCmd(TCmdTag ct) : TCmd(ct)
  {
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TCmd(ct)\n",time(zidx));
//pph***************************************************************************
  };

TCCode TCmd::FirstStep(void)
  {
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TCmd::FirstStep(void)\n",time(zidx));
//pph***************************************************************************
  eStep  = CControlStep;
  return CMeasureAgain;
  };

TCCode TCmd::ControlStep(void)
  {
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TCmd::ControlStep(void)\n",time(zidx));
//pph***************************************************************************
  eStep = CReadyStep;
  return CReadyStep;
  };

TCCode TCmd::ReadyStep(void)
  {
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TCmd::ReadyStep(void)\n",time(zidx));
//pph***************************************************************************
  eStep = CReady;
  return CReady;
  };
*/
//*****************************************************************************
//*****  Command Inquire ******************************************************
//*****************************************************************************
TInquireCmd::TInquireCmd(TCmdTag ct) : TCmd(ct)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TCmd(ct)\n",time(zidx));
//pph***************************************************************************
  eStep = CReady;
  bNoMeasure = TRUE;
};

BOOL TInquireCmd::GetShowData(LPSTR buffer)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TInquireCmd::GetShowData(LPSTR buffer)\n",time(zidx));
//pph***************************************************************************
  buffer[0] = 0;
  switch(eStep) {
    case CReady:
    ;
    break;
  }
  return TRUE;
};
//*****************************************************************************
//*****  Command ShowValue ****************************************************
//*****************************************************************************
TShowValueCmd::TShowValueCmd(TCmdTag ct) : TCmd(ct)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TCmd(ct)\n",time(zidx));
//pph***************************************************************************
  char  buf[MaxString];

  eStep = CReady;
  bNoMeasure = TRUE;
  switch(ct.P1) {
    case Hwb:
    sprintf(buf,"Halbwertsbreite : %.2f arcsec",Steering.fHWB);
    MessageBox(GetFocus(),buf,"Information",MBINFO);
    break;
    case Peak:
    sprintf(buf,"Peak (D,I) : (%.2lf,%.2f)",Steering.dPeakPoint,Steering.fPeakIntensity);
    MessageBox(GetFocus(),buf,"Information",MBINFO);
    break;
    case Start:
    sprintf(buf,"Startposition : %.2lf",Steering.dStartPoint);
    MessageBox(GetFocus(),buf,"Information",MBINFO);
    break;
  }
};

BOOL TShowValueCmd::GetShowData(LPSTR buffer)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TShowValueCmd::GetShowData(LPSTR buffer)\n",time(zidx));
//pph***************************************************************************
  buffer[0] = 0;
  switch(eStep) {
    case CReady:;
    break;
  }
  return TRUE;
};
//*****************************************************************************
//*****  Command SaveData  ****************************************************
//*****************************************************************************
TSaveDataCmd::TSaveDataCmd(TCmdTag ct) : TCmd(ct)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TCmd(ct)\n",time(zidx));
//pph***************************************************************************
  ScanW     = (TScan*)Main.ScanWindow;
  AreaScanW = (TAreaScan*)Main.ScanWindow;
  eStep = CReady;
  switch(ct.P1) {
    case ForScan:
    if(ScanW)
      if(!ScanW->SaveFile(NoAskForSave))
        nFailureId = 1;
    break;

    case ForAreaScan:
    if(AreaScanW)
      if(!AreaScanW->SaveFile(NoAskForSave))
        nFailureId = 1;
    break;
  }
  bNoMeasure = TRUE;
};

BOOL TSaveDataCmd::GetShowData(LPSTR buffer)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSaveDataCmd::GetShowData(LPSTR buffer)\n",time(zidx));
//pph***************************************************************************
  buffer[0] = 0;
  switch(eStep) {
    case CReady:
    switch(nFailureId) {
      case 1:
      sprintf(buffer,"SaveData failed.");
      break;

      default:
      if(ScanW)
        sprintf(buffer,"Save Data on %s",ScanW->FileName);
      if(AreaScanW)
        sprintf(buffer,"Save Data on %s",AreaScanW->FileName);
      break;
    }
    break;
  }
  return TRUE;
};
//*****************************************************************************
//*****  Command SetFileName **************************************************
//*****************************************************************************
TSetFileNameCmd::TSetFileNameCmd(TCmdTag ct) : TCmd(ct)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TCmd(ct)\n",time(zidx));
//pph***************************************************************************
  eStep = CReady;
  switch(ct.P1) {
    case ForScan:
    ScanW = (TScan*)Main.ScanWindow;
    if(ScanW)
      ScanW->SetFileName(ct.P3);
    break;

    case ForAreaScan:
    AreaScanW = (TAreaScan*)Main.ScanWindow;
    if(AreaScanW)
      AreaScanW->SetFileName(ct.P3);
    break;
  }
  bNoMeasure = TRUE;
};

BOOL TSetFileNameCmd::GetShowData(LPSTR buffer)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSetFileNameCmd::GetShowData(LPSTR buffer)\n",time(zidx));
//pph***************************************************************************
  buffer[0] = 0;
  switch(eStep) {
    case CReady:
    switch(nFailureId) {
      case 1:
      sprintf(buffer,"SetFileName failed.");
      break;

      default:
      sprintf(buffer,"FileName gesetzt");
      break;
    }
    break;
  }
  return TRUE;
};
//*****************************************************************************
//*****  Command ChooseDevice  ************************************************
//*****************************************************************************
TChooseDeviceCmd::TChooseDeviceCmd(TCmdTag ct) : TCmd(ct)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TCmd(ct)\n",time(zidx));
//pph***************************************************************************
  float     time,otime,ofl,fl;
  DWORD      ocounts,counts;

  bNoMeasure = TRUE;
  if(!dlSetDevice(dlGetIdByName((TDeviceType)ct.P1)))
    nFailureId = 1;
  dGetExposureValues(otime,ocounts,ofl);
  sscanf(ct.P3,"%f %ld %f",&time,&counts,&fl);
  if(!time)
    time = otime;
  if(!counts)
    counts = ocounts;
  if(fl)
    fl = ofl;
  dMeasureStop();
  dSetExposureValues(time,counts,fl);
  dMeasureStart();
  eStep = CReady;
};

BOOL TChooseDeviceCmd::GetShowData(LPSTR buffer)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TChooseDeviceCmd::GetShowData(LPSTR buffer)\n",time(zidx));
//pph***************************************************************************
  buffer[0] = 0;
  switch(eStep) {
    case CReady:
    if(nFailureId)
      strcpy(buffer,"ChooseDevice Fail");
    else
      strcpy(buffer,"ChooseDevice Ready");
    break;
  }
  return TRUE;
};
//*****************************************************************************
//*****  Command MoveToPoint **************************************************
//*****************************************************************************
TMoveToPointCmd::TMoveToPointCmd(TCmdTag ct) : TCmd(ct)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TCmd(ct)\n",time(zidx));
//pph***************************************************************************
  double  distance;

  bNoMeasure = TRUE;
  switch(ct.P1) {
    case Result:
    StartMove(mlGetAxis(),Steering.dCalcResult);
    break;
    case Peak:
    StartMove(mlGetAxis(),Steering.dPeakPoint);
    break;
    case Start:
    StartMove(mlGetAxis(),Steering.dStartPoint);
    break;
    case LastGoal:
    StartMove(mlGetAxis(),Steering.dGoalDistance);
    break;
    case Relative:
    mlGetDistance(mlGetAxis(),distance);
    StartMove(mlGetAxis(),distance + atof(ct.P3));
    break;
    default:
    StartMove(mlGetAxis(),atof(ct.P3));
    break;
  }
  eStep = CReadyStep;
};

BOOL TMoveToPointCmd::GetShowData(LPSTR buffer)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TMoveToPointCmd::GetShowData(LPSTR buffer)\n",time(zidx));
//pph***************************************************************************
  buffer[0] = 0;
  switch(eStep) {
    case CReady:
    strcpy(buffer,"MoveToPoint Ready");
    break;
  }
  return TRUE;
};

TCCode TMoveToPointCmd::ReadyStep(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TMoveToPointCmd::ReadyStep(void)\n",time(zidx));
//pph***************************************************************************
  eStep = CReady;
  return CReady;
};
//*****************************************************************************
//*****  Command SavePoint  ***************************************************
//*****************************************************************************
TLoadPointCmd::TLoadPointCmd(TCmdTag ct) : TCmd(ct)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TCmd(ct)\n",time(zidx));
//pph***************************************************************************
  bNoMeasure = TRUE;
  switch((TCParam)ct.P1) {
    case Argument:
    Steering.dCalcArg[ct.P2] = Steering.dGoalDistance;
    break;
    case Start: // start
    Steering.dStartPoint = Steering.dGoalDistance;
    break;
    case Peak: // peak
    Steering.dPeakPoint = Steering.dGoalDistance;
    break;
  }
  eStep = CReady;
};

BOOL TLoadPointCmd::GetShowData(LPSTR buffer)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TLoadPointCmd::GetShowData(LPSTR buffer)\n",time(zidx));
//pph***************************************************************************
  buffer[0] = 0;
  switch(eStep) {
    case CReady:
    strcpy(buffer,"LoadPoint Ready");
    break;
  }
  return TRUE;
};
//*****************************************************************************
//*****  Command Calculate*****************************************************
//*****************************************************************************
TCalculateCmd::TCalculateCmd(TCmdTag ct) : TCmd(ct)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TCmd(ct)\n",time(zidx));
//pph***************************************************************************
  //!  int      mid;

  //!mid = mlGetAxis();
  bNoMeasure = TRUE;
  switch((TCParam)ct.P1) {
    case Difference:
    Steering.dCalcResult =  Steering.dCalcArg[2] - Steering.dCalcArg[1];
    break;

    case Opposite:
    Steering.dCalcResult = 2.0 * Steering.dPeakPoint - Steering.dCalcArg[1];
    break;

    case Hwb:
    Steering.fHWB = Steering.dCalcArg[2] - Steering.dCalcArg[1];
    switch(mGetUnitType()) {
      case Grad:
      Steering.fHWB *= 60.0;
      case Minuten:
      Steering.fHWB *= 60.0;
    }
    break;

    case Middle:
    Steering.dCalcResult = (Steering.dCalcArg[1] + Steering.dCalcArg[2]) / 2.0;
    break;
  }
  eStep = CReady;
};

BOOL TCalculateCmd::GetShowData(LPSTR buffer)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TCalculateCmd::GetShowData(LPSTR buffer)\n",time(zidx));
//pph***************************************************************************
  switch(eStep) {
    case CReady:
    strcpy(buffer,"Calculate Ready");
    break;
    default:
    buffer[0] = 0;
  }
  return TRUE;
};
//*****************************************************************************
//*****  Command SetWidth  ****************************************************
//*****************************************************************************
TSetWidthCmd::TSetWidthCmd(TCmdTag ct) : TCmd(ct)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TCmd(ct)\n",time(zidx));
//pph***************************************************************************
  bNoMeasure = TRUE;
  mSetValue(Width,atof(ct.P3));
  eStep = CReady;
};

BOOL TSetWidthCmd::GetShowData(LPSTR buffer)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSetWidthCmd::GetShowData(LPSTR buffer)\n",time(zidx));
//pph***************************************************************************
  switch(eStep) {
    case CReady:
    strcpy(buffer,"SetWidth Ready");
    break;
    default:
    buffer[0] = 0;
  }
  return TRUE;
};
//*****************************************************************************
//*****  Command ChooseAxis ***************************************************
//*****************************************************************************
TChooseAxisCmd::TChooseAxisCmd(TCmdTag ct) : TCmd(ct)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TCmd(ct)\n",time(zidx));
//pph***************************************************************************
  bNoMeasure = TRUE;
  if(!mlSetAxis(mlGetIdByName((TAxisType)ct.P1)))
    nFailureId = 1;
  eStep  = CReady;
};

BOOL TChooseAxisCmd::GetShowData(LPSTR buffer)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TChooseAxisCmd::GetShowData(LPSTR buffer)\n",time(zidx));
//pph***************************************************************************
  switch(eStep) {
    case CReady:
    if(nFailureId)
      strcpy(buffer,"ChooseAxis Failed");
      else
      strcpy(buffer,"ChooseAxis Ready");
    break;
    default:
    buffer[0] = 0;
  }
  return TRUE;
};
//*****************************************************************************
//*****  Command SetupScan  ***************************************************
//*****************************************************************************
TSetupScanCmd::TSetupScanCmd(TCmdTag ct) : TCmd(ct)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TCmd(ct)\n",time(zidx));
//pph***************************************************************************
  ScanW = (TScan*)Main.ScanWindow;
  if(!ScanW)
  {
    MessageBox(GetFocus(),"Kein Scan-Fenster offen","Fehler",MBSTOP);
    return;
  }
  ScanW->nMotor = mlGetAxis();
  ScanW->Device = lpDList->DP(dlGetDevice());
  ScanW->eScanType = (TxScanType)ct.P1;
  // Startup Steerng
  Steering.StartUp(ScanW->GetWndHandle(),mlGetAxis(),dlGetDevice());
  switch(ScanW->eScanType){
    case Omega2ThetaScan:
    sscanf(ct.P3,"%lf %lf %lf",  &ScanW->dArgumentMin,
            &ScanW->dArgumentWidth,&ScanW->dArgumentMax);
    break;

    case StandardScan:
    sscanf(ct.P3,"%lf %lf %lf",  &ScanW->dArgumentMin, \
            &ScanW->dArgumentWidth,  &ScanW->dArgumentMax);
    break;
  }
  eStep = CReady;
  bNoMeasure = TRUE;
};

BOOL TSetupScanCmd::GetShowData(LPSTR buffer)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSetupScanCmd::GetShowData(LPSTR buffer)\n",time(zidx));
//pph***************************************************************************
  buffer[0] = 0;
  switch(eStep) {
    case CReady:
    switch(nFailureId) {
      case 1:
      sprintf(buffer,"Setup Scan failed.");
      break;
      default:
      sprintf(buffer,"Setup Scan ready.");
    }
    break;
  }
  return TRUE;
};
//*****************************************************************************
//***********  Command Scan  **************************************************
//*****************************************************************************
TScanCmd::TScanCmd(TCmdTag ct) : TCmd(ct)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TCmd(ct)\n",time(zidx));
//pph***************************************************************************
  double dDistance;

  bDynamicStepWidth = FALSE;
  nStepScaleLevels = 0;
  Scaler = NULL;
  eCaller   = ct.P1;
  switch(ct.P1) {
    case ForAreaScan:
    AreaScanW = (TAreaScan*)Main.AreaScanWindow;
    if(!AreaScanW)
    {
      MessageBox(GetFocus(),"Kein AreaScan-Fenster offen","Fehler",MBSTOP);
      return;
    }
    bAbsorberUsed = AreaScanW->bAbsorberUsed;
    // bMonitorUsed = AreaScanW->;
    eScanType = AreaScanW->eScanType;
    AreaScanW->New();
    AreaScanW->bMeasurementActive = TRUE;
    AreaScanW->UpdateWnd(0);
    AreaScanW->UpdateMenu();
    switch(eScanType){
      case Omega2ThetaScan:
      bOmega2Theta = TRUE;
      dArgumentMin     = AreaScanW->dOmegaMin;
      dArgumentWidth   = AreaScanW->dOmegaWidth;
      dArgumentMax     = AreaScanW->dOmegaMax;
      dMoveRelation   = AreaScanW->dMoveRelation;
      bMonitorUsed     = (AreaScanW->eNotifyValue == MonitorIntensity);
      if(bMonitorUsed)
        Monitor = AreaScanW->Monitor;
      break;

      case StandardScan:
      bOmega2Theta = FALSE;
      dArgumentMin = AreaScanW->dOmegaMin;
      dArgumentWidth = AreaScanW->dOmegaWidth;
      dArgumentMax = AreaScanW->dOmegaMax;
      break;

      default:
      MessageBox(GetFocus(),"Start Scan failed.","Steering",MBSTOP);
    }
    break;

    case ForScan:
    ScanW = (TScan*)Main.ScanWindow;
    if(!ScanW)
    {
      MessageBox(GetFocus(),"Kein Scan-Fenster offen","Fehler",MBSTOP);
      return;
    }
    bAbsorberUsed = FALSE;
    bDynamicStepWidth = ScanW->bDynamicStepWidth;
    nStepScaleLevels = ScanW->nStepScaleLevels;
    Scaler = ScanW->Scaler;
    eScanType = ScanW->eScanType;
    ScanW->New();
    ScanW->bInterrupted = FALSE;
    ScanW->bMeasurementActive = TRUE;
    ScanW->UpdateWnd(0);
    ScanW->UpdateMenu();
    switch(eScanType)
    {
      case Omega2ThetaScan:
      bOmega2Theta = TRUE;
      dArgumentMin     = ScanW->dArgumentMin;
      dArgumentWidth   = ScanW->dArgumentWidth;
      dArgumentMax     = ScanW->dArgumentMax;
      dMoveRelation   = 2.0;
      break;

      case StandardScan:
      bOmega2Theta = FALSE;
      dArgumentMin     = ScanW->dArgumentMin;
      dArgumentWidth   = ScanW->dArgumentWidth;
      dArgumentMax     = ScanW->dArgumentMax;
      break;

      default:
      MessageBox(GetFocus(),"Start Scan failed.","Steering",MBSTOP);
    }
    break;

    default:
    MessageBox(GetFocus(),"Start Scan","Fehler",MBSTOP);
    eStep = CReady;
    bNoMeasure = TRUE;
    return;
  }
  nMotor = mlGetAxis(); // Startup
  mlGetDistance(nMotor,Steering.dStartPoint);
  StartMove(nMotor,dArgumentMin);
  dArgument = dArgumentMin;
  if(bOmega2Theta)
  {
    nTheta = mlGetIdByName(Theta);
    mlGetDistance(nTheta,dStartPointTheta);
    dDistance = dArgumentMin * dMoveRelation;
    StartMove(nTheta,dDistance);
  }
  if(bAbsorberUsed)
  {
    nAbsorber = mlGetIdByName(Absorber);
    bAbsorberMovedIn = FALSE;
    bAbsorberActivated = FALSE;
    mlGetDistance(nAbsorber,dStartPointAbsorber);
    StartMove(nAbsorber,0.0);
  }
  SetInfo("Anfahren der Startposition ...");
  eStep = CFirstStep;
  nPointNumber = (dArgumentMax - dArgumentMin) / dArgumentWidth;
  bNoMeasure = TRUE;
};

BOOL TScanCmd::GetShowData(LPSTR buffer)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TScanCmd::GetShowData(LPSTR buffer)\n",time(zidx));
//pph***************************************************************************
  float    fTimeRemaining;
  char    fmt[MaxString];
  DWORD    dwElapsedTicks;

  switch(eStep) {
    case CReady:
    strcpy(buffer,"Scan Ready");
    SetInfo(buffer);
    break;

    case CControlStep:
    // calculate the remaining time
    dwElapsedTicks = GetTickCount() - dwStartTimeTicks;
    if(nPointIdx)
    {
      fTimeRemaining = (dwElapsedTicks / 60000.0) / nPointIdx;
      fTimeRemaining *= (nPointNumber - nPointIdx);
    }
    else
      fTimeRemaining = 0.0;
#ifdef GermanVersion
    sprintf(fmt,"Scan ...  Winkel = ");
    strcat(fmt,mGetDF());
    strcat(fmt," Intensitt = %.3f");
    strcat(fmt," verbl. Zeit = %.1f Min.");
#else
    sprintf(fmt,"Scan ...  Angle = ");
    strcat(fmt,mGetDF());
    strcat(fmt," Intensity = %.3f");
    strcat(fmt," Time rem. = %.1f min.");
#endif
    sprintf(buffer,fmt,mGetValue(Distance),Steering.GetIntensity(),fTimeRemaining);
    SetInfo(buffer);
    buffer[0] = 0;
    break;

    default:
    buffer[0] = 0;
  }
  return TRUE;
};

TCCode TScanCmd::FirstStep(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TScanCmd::FirstStep(void)\n",time(zidx));
//pph***************************************************************************
  eStep  = CControlStep;
  nPointIdx = 0;
  dwStartTimeTicks = GetTickCount();
  return CMeasure;
};

TCCode TScanCmd::ControlStep(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TScanCmd::ControlStep(void)\n",time(zidx));
//pph***************************************************************************
  float   fStepScaler = 1.0, fIntensity;
  int      nScaleLevel = 0;

  if(bDynamicStepWidth)
  {
    fIntensity = Steering.GetIntensity();
    while(nScaleLevel < nStepScaleLevels)
    {
      if(fIntensity > Scaler[nScaleLevel])
      {
        nScaleLevel++;
        continue;
      }
      fStepScaler = Scaler[nScaleLevel+nMaxScaleIdx];
      break;
    }
  }
  if(Steering.GetDistance() <= dArgumentMax)
  {
    nPointIdx++;
    dArgument += dArgumentWidth * fStepScaler;
    StartMove(nMotor,dArgument);
    if(bOmega2Theta)
      StartMove(nTheta,dArgument * dMoveRelation);
    if(bAbsorberUsed)
      return CRecall;
    return CRecall;
  }
  eStep = CReadyStep;
  bNoMeasure = TRUE;
  StartMove(nMotor,Steering.dStartPoint);
  if(bOmega2Theta)
    StartMove(nTheta,dStartPointTheta);
  if(bAbsorberUsed)
    return CRecall;
  return CRecall;
};

TCCode TScanCmd::ReadyStep(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TScanCmd::ReadyStep(void)\n",time(zidx));
//pph***************************************************************************
  eStep = CReady;
  switch(eCaller) {
    case ForAreaScan:
    break;
    case ForScan:
    ScanW->bMeasurementActive = FALSE;
    break;
  }
  return CRecall;
};
//*****************************************************************************
//*****  Command ControlFlank  ************************************************
//*****************************************************************************
TControlFlankCmd::TControlFlankCmd(TCmdTag ct) : TCmd(ct)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TCmd(ct)\n",time(zidx));
//pph***************************************************************************
  nMotor = mlGetAxis();
  bSmallAngleSide = (ct.P1 == SmallSide);
  fControlRange = atof(ct.P3);
  nLifo = 4;
  dDistance   = new double [nLifo];
  fIntensity   = new float  [nLifo];
  eStep = CFirstStep;
};

TControlFlankCmd::~TControlFlankCmd()
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TControlFlankCmd::~TControlFlankCmd()\n",time(zidx));
//pph***************************************************************************
  delete[] dDistance;
  delete[] fIntensity;
};

BOOL TControlFlankCmd::GetShowData(LPSTR buffer)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TControlFlankCmd::GetShowData(LPSTR buffer)\n",time(zidx));
//pph***************************************************************************
  switch(eStep) {
    case CReady:
    strcpy(buffer,"ControlFlank Ready");
    break;
    case CControlStep:
    sprintf(buffer,"D:%.3lf  I:%.2f",dDistance[0],fIntensity[0]);
    break;
    default:
    buffer[0] = 0;
  }
  return TRUE;
};

TCCode TControlFlankCmd::FirstStep(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TControlFlankCmd::FirstStep(void)\n",time(zidx));
//pph***************************************************************************
  // Feststellen, ob die gewhlten Parameter konsistent sind
  eStep  = CControlStep;
  fIntensity[0] = Steering.GetIntensity();
  dDistance[0]   = Steering.GetDistance();
  fSearchIntensity = fIntensity[0];
  Steering.dStartPoint = dDistance[0];
  // Mess-Zeit, Start-Intensitaet und Regel-Bereich
  fMinIntensity = fSearchIntensity * (1.0 - fControlRange / 2.0);
  fMaxIntensity = fSearchIntensity * (1.0 + fControlRange / 2.0);
  fIntensityRange = (fMaxIntensity - fMinIntensity) / 2.0;
  return CMeasure;
};

TCCode TControlFlankCmd::ControlStep(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TControlFlankCmd::ControlStep(void)\n",time(zidx));
//pph***************************************************************************
  float  steprel,idif0,idif1;

  memmove((LPSTR)(fIntensity + 1),(LPSTR)fIntensity,(nLifo - 1) * sizeof(float));
  memmove((LPSTR)(dDistance + 1),(LPSTR)dDistance,(nLifo - 1) * sizeof(double));
  fIntensity[0] = Steering.GetIntensity();
  dDistance[0]   = Steering.GetDistance();

  idif0 = fSearchIntensity - fIntensity[0];
  idif1 = fSearchIntensity - fIntensity[1];
  while(1)
  {
    // Fall 1: Intensitaet liegt im Bereich
    if(fabs(idif0) < fIntensityRange)
    {
      if(((idif1*idif0) < 0) && (fabs(idif1) > fIntensityRange))
      {
        // Schrittweite vermindern
        mSetValue(Width,0.75 * mGetValue(Width));
      }
      return CRecall;
    }
    // Fall 2: Nur mit der letzten Messung wurde der Bereich verlassen
    if(fabs(idif1) < fIntensityRange)
      break;
    // Fall 3: Weiter in falsche Richtung bewegt
    if(((idif1 * idif0) > 0) && (fabs(idif0) > fabs(idif1)))
    {
      // Ist die Flanke bestimmbar ?
      steprel = (dDistance[0] - dDistance[1]);
      steprel = fabs(steprel / mGetValue(Width));
      if(steprel > 0.7)
      {
        // FlankenFlag ndern
        // bSmallAngleSide = !bSmallAngleSide;
      }
      break;  // try it again
    }
    // Fall 4: Bewegung durch Arbeitspunkt und zu weit
    if((idif1 * idif0) < 0)
    {
      // Schrittweite vermindern
      mSetValue(Width,0.75 * mGetValue(Width));
    }
    break;
  }
  if(!bSmallAngleSide)
  {
    if(idif1 > 0.0)
      StartMove(nMotor,dDistance[0] - mGetValue(Width));
    else
      StartMove(nMotor,dDistance[0] + mGetValue(Width));
  } 
  else
  {
    if(idif1 < 0.0)
      StartMove(nMotor,dDistance[0] - mGetValue(Width));
    else
      StartMove(nMotor,dDistance[0] + mGetValue(Width));
  }
  return CRecall;
};

TCCode TControlFlankCmd::ReadyStep(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TControlFlankCmd::ReadyStep(void)\n",time(zidx));
//pph***************************************************************************
  eStep = CReady;
  return CReady;
};
//*****************************************************************************
//**********  Command GotoIntensity  ******************************************
//*****************************************************************************
TGotoIntensityCmd::TGotoIntensityCmd(TCmdTag ct) : TCmd(ct)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TCmd(ct)\n",time(zidx));
//pph***************************************************************************
  nMotor = mlGetAxis();
  bSmallAngleSide = (ct.P1 == SmallSide);
  nReadyAction = (TCParam)ct.P2;
  // Bezug auf Vorgeschichte
  fSearchIntensity = Steering.fPeakIntensity * atof(ct.P3);
  if(!fSearchIntensity)
  {
    nFailureId = 11;
    eStep = CReady;
    return;
  }
  nLifo = 3;
  dDistance   = new double [nLifo];
  fIntensity   = new float  [nLifo];
  if(bSmallAngleSide)
    StartMove(nMotor,mGetValue(Distance) - 2.0 * mGetValue(Width));
  else
    StartMove(nMotor,mGetValue(Distance) + 2.0 * mGetValue(Width));
  eStep = CFirstStep;
};

TGotoIntensityCmd::~TGotoIntensityCmd()
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TGotoIntensityCmd::~TGotoIntensityCmd()\n",time(zidx));
//pph***************************************************************************
  delete[] dDistance;
  delete[] fIntensity;
};

BOOL TGotoIntensityCmd::GetShowData(LPSTR buffer)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TGotoIntensityCmd::GetShowData(LPSTR buffer)\n",time(zidx));
//pph***************************************************************************
  switch(eStep) {
    case CReady:
    strcpy(buffer,"GotoIntensity Ready");
    break;
    case CFirstStep:
    sprintf(buffer,"Ziel-Intensitt %.2f",fSearchIntensity);
    break;
    case CControlStep:
    sprintf(buffer,"D:%.3lf  I:%.2f",dDistance[0],fIntensity[0]);
    break;
    default:
    buffer[0] = 0;
  }
  return TRUE;
};

TCCode TGotoIntensityCmd::FirstStep(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TGotoIntensityCmd::FirstStep(void)\n",time(zidx));
//pph***************************************************************************
  eStep  = CControlStep;
  fIntensity[0] = Steering.GetIntensity();
  dDistance[0]   = Steering.GetDistance();
  if(bSmallAngleSide)
    StartMove(nMotor,dDistance[0] - mGetValue(Width));
  else
    StartMove(nMotor,dDistance[0] + mGetValue(Width));
  return CRecall;
};

TCCode TGotoIntensityCmd::ControlStep(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TGotoIntensityCmd::ControlStep(void)\n",time(zidx));
//pph***************************************************************************
  double  dDist;
  float    idif0,idif1;

  memmove((LPSTR)(fIntensity+1),(LPSTR)fIntensity,(nLifo-1) * sizeof(float));
  memmove((LPSTR)(dDistance+1),(LPSTR)dDistance,(nLifo-1) * sizeof(double));
  fIntensity[0] = Steering.GetIntensity();
  dDistance[0]   = Steering.GetDistance();
  idif0 = fSearchIntensity - fIntensity[0];
  idif1 = fSearchIntensity - fIntensity[1];
  //*** Feststellen, ob Level durchschritten wurde
  if((idif0 * idif1) < 0.0)
  {
    eStep = CReadyStep;
    switch(nReadyAction) {
      case Interpolation:
      dDist  = (fSearchIntensity - fIntensity[1]) * dDistance[0];
      dDist += (fIntensity[0] - fSearchIntensity) * dDistance[1];
      dDist /= (fIntensity[0] - fIntensity[1]);
      StartMove(nMotor,dDist);
      break;
      case BackMove:
      StartMove(nMotor,dDistance[1]);
      break;
    }
    return CRecall;
  }
  if(bSmallAngleSide)
  {
    if(idif0 > 0.0)
      StartMove(nMotor,dDistance[0] + mGetValue(Width));
    else
      StartMove(nMotor,dDistance[0] - mGetValue(Width));
  }
  else
  {
    if(idif1 > 0)
      StartMove(nMotor,dDistance[0] - mGetValue(Width));
      else
      StartMove(nMotor,dDistance[0] + mGetValue(Width));
  }
  return CRecall;
};

TCCode TGotoIntensityCmd::ReadyStep(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TGotoIntensityCmd::ReadyStep(void)\n",time(zidx));
//pph***************************************************************************
  double mm;
  switch(nReadyAction) {
    case Interpolation:
    mm = (fIntensity[1] - fIntensity[0]);
    if(!mm)
    {
      Steering.dGoalDistance = dDistance[0];
      Steering.fGoalIntensity = fIntensity[0];
      eStep = CReady;
      return CReady;
    }
    mm = (dDistance[1] - dDistance[0])*(fSearchIntensity - fIntensity[0]) / mm;
    Steering.dGoalDistance = dDistance[0] + mm;
    Steering.fGoalIntensity = fSearchIntensity;
    eStep = CReady;
    return CReady;

    default:
    Steering.dGoalDistance = dDistance[0];
    Steering.fGoalIntensity = fIntensity[0];
    eStep = CReady;
    return CReady;
  }
};
//*****************************************************************************
//**********  Command GotoPeak ************************************************
//*****************************************************************************
TGotoPeakCmd::TGotoPeakCmd(TCmdTag ct) : TCmd(ct)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TCmd(ct)\n",time(zidx));
//pph***************************************************************************
  bDirectionChanged = FALSE;
  bFlankDetected = FALSE;
  bDynamicStepWidth = FALSE;
  bSmallAngleSide = (ToSmallerAngle == ct.P1);
  nReadyAction = (TCParam)ct.P2;
  nMotor = mlGetAxis();
  mlGetDistance(nMotor,Steering.dStartPoint);
  nLifo = 3;
  dDistance   = new double [nLifo];
  fIntensity   = new float  [nLifo];
  eStep = CFirstStep;
};

TGotoPeakCmd::~TGotoPeakCmd()
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TGotoPeakCmd::~TGotoPeakCmd()\n",time(zidx));
//pph***************************************************************************
  bMonitorUsed = FALSE;
  delete[] dDistance;
  delete[] fIntensity;
};

BOOL TGotoPeakCmd::GetShowData(LPSTR buffer)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TGotoPeakCmd::GetShowData(LPSTR buffer)\n",time(zidx));
//pph***************************************************************************
  switch(eStep) {
    case CReady:
    strcpy(buffer,"GotoPeak Ready");
    break;
    case CControlStep:
    sprintf(buffer,"D:%.3lf  I:%.2f",dDistance[0],fIntensity[0]);
    break;
    default:
    buffer[0] = 0;
  }
  return TRUE;
};

TCCode TGotoPeakCmd::FirstStep(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TGotoPeakCmd::FirstStep(void)\n",time(zidx));
//pph***************************************************************************
  eStep = CControlStep;
  fIntensity[0] = Steering.GetIntensity();
  dDistance[0]   = Steering.GetDistance();
  Steering.dStartPoint = dDistance[0];
  if(bSmallAngleSide)
    StartMove(nMotor,mGetValue(Distance) + mGetValue(Width));
  else
    StartMove(nMotor,mGetValue(Distance) - mGetValue(Width));
  return CRecall;
};

TCCode TGotoPeakCmd::ControlStep(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TGotoPeakCmd::ControlStep(void)\n",time(zidx));
//pph***************************************************************************
  float  idif0,idif1;

  memmove((LPSTR)(fIntensity+1),(LPSTR)fIntensity,(nLifo-1) * sizeof(float));
  memmove((LPSTR)(dDistance+1),(LPSTR)dDistance,(nLifo-1) * sizeof(double));
  fIntensity[0] = Steering.GetIntensity();
  dDistance[0]   = Steering.GetDistance();
  //*** Keine Reaktion unterhalb des Rausch-Level
  if(fIntensity[0] < Steering.GetNoiseLevel())
  {
    if(mIsRangeHit())
    {
      bSmallAngleSide = !bSmallAngleSide;
      StartMove(nMotor,Steering.dStartPoint);
      return CRecall;
    }
    goto Exit;
  }
  // Variablen belegen
  idif0 = fIntensity[0] - fIntensity[1];
  //*** Abbruch-Bedingung
  if(bFlankDetected && (idif0 < 0.0))
  {
    eStep = CReadyStep;
    return CRecall;
  }
  if(fabs(idif0) > (3.0 * Steering.GetSigma() * fIntensity[1]))
  {
    bFlankDetected = TRUE;
    if(idif0 < 0.0)
      bSmallAngleSide = !bSmallAngleSide;
      goto Exit;
  }
  idif1 = fIntensity[1] - fIntensity[2];
  if((idif0 < 0.0) && (idif1 < 0.0))
  {
    bFlankDetected = TRUE;
    bSmallAngleSide = !bSmallAngleSide;
    goto Exit;
  }
Exit:
  if(bSmallAngleSide)
    StartMove(nMotor,dDistance[0] + mGetValue(Width));
  else
    StartMove(nMotor,dDistance[0] - mGetValue(Width));
  return CRecall;
};

TCCode TGotoPeakCmd::ReadyStep(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TGotoPeakCmd::ReadyStep(void)\n",time(zidx));
//pph***************************************************************************
  if(bBackMoveActive)
  {
    Steering.dPeakPoint = Steering.dGoalDistance   = dDistance[0];
    Steering.fPeakIntensity = Steering.fGoalIntensity = fIntensity[0];
    eStep = CReady;
    return CReady;
  }
  switch(nReadyAction) {
    case Interpolation:
    Steering.dGoalDistance  = (fSearchIntensity - fIntensity[1]) * dDistance[0];
    Steering.dGoalDistance += (fIntensity[0] - fSearchIntensity) * dDistance[1];
    Steering.dGoalDistance /= (fIntensity[0] - fIntensity[1]);
    Steering.dPeakPoint = Steering.dGoalDistance;
    Steering.fPeakIntensity = Steering.fGoalIntensity = fIntensity[1];
    eStep = CReady;
    return CReady;

    case BackMove: default:
    StartMove(nMotor,dDistance[1]);
    bBackMoveActive = TRUE;
    return CRecall;
  }
};
//*****************************************************************************
//**********  Command AreaScan ************************************************
//*****************************************************************************
TAreaScanCmd::TAreaScanCmd(TCmdTag ct) : TCmd(ct)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TCmd(ct)\n",time(zidx));
//pph***************************************************************************
  AreaScanW = (TAreaScan*)Main.AreaScanWindow;
  if(!AreaScanW)
  {
    MessageBox(GetFocus(),"Kein AreaScan-Fenster offen","Fehler",MBSTOP);
    return;
  }
  nOmega = AreaScanW->nOmega;
  nTheta = AreaScanW->nTheta;
  AreaScanW->bMeasurementActive = TRUE;
  dOmegaMin = AreaScanW->dOmegaMin;
  dOmegaMax = AreaScanW->dOmegaMax;
  dOmegaWidth = AreaScanW->dOmegaWidth;
  dThetaWindow = AreaScanW->dThetaWindow;
  dThetaWidth = AreaScanW->dThetaWidth;
  dMoveRelation = AreaScanW->dMoveRelation;

  nMaxOmegaPoint = (dOmegaMax - dOmegaMin) / dOmegaWidth;
  nMaxThetaPoint = dThetaWindow / dThetaWidth;
  nOmegaPoint = nThetaPoint = 0;
  mlGetDistance(nOmega,Steering.dStartPoint);
  dOmega = dOmegaMin;
  StartMove(nOmega,dOmegaMin);

  mlGetDistance(nTheta,dStartPointTheta);
  dTheta = dOmega * dMoveRelation - dThetaWindow / 2.0;
  StartMove(nTheta,dTheta);
  AreaScanW->New();
  AreaScanW->UpdateWnd(0);

  SetInfo("Anfahren der Startposition ...");
  eStep = CFirstStep;
  bNoMeasure = TRUE;
};

BOOL TAreaScanCmd::GetShowData(LPSTR buffer)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TAreaScanCmd::GetShowData(LPSTR buffer)\n",time(zidx));
//pph***************************************************************************
  switch(eStep) {
    case CReady:
    strcpy(buffer,"Scan Ready");
    break;
    case CControlStep:
  {
	 char  fmt[MaxString];
	 sprintf(fmt,"Scan luft ...  Winkel = ");
	 strcat(fmt,mGetDF()); strcat(fmt," Intensitt = %.3f");
	 sprintf(buffer,fmt,mGetValue(Distance),Steering.GetIntensity());
	 SetInfo(buffer);
  }
	 buffer[0] = 0;
	 break;

	 default:
	 buffer[0] = 0;
  }
  return TRUE;
};

TCCode TAreaScanCmd::FirstStep(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TAreaScanCmd::FirstStep(void)\n",time(zidx));
//pph***************************************************************************
  eStep  = CControlStep;
  bNoMeasure = FALSE;
  return CMeasure;
};

TCCode TAreaScanCmd::ControlStep(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TAreaScanCmd::ControlStep(void)\n",time(zidx));
//pph***************************************************************************
  if(nOmegaPoint > nMaxOmegaPoint)
  {
	 eStep = CReadyStep;
	 bNoMeasure = TRUE;
	 StartMove(nOmega,Steering.dStartPoint);
	 StartMove(nTheta,dStartPointTheta);
  }
  if(nThetaPoint > nMaxThetaPoint)
  {
	 AreaScanW->bThetaScanCompleted = TRUE;
	 dOmega += dOmegaWidth;
	 nOmegaPoint++;
	 StartMove(nOmega,dOmega);
	 nThetaPoint = 0;
	 dTheta = dOmega * dMoveRelation - dThetaWindow / 2.0;
	 StartMove(nTheta,dTheta);
  }
  else
  {
	 nThetaPoint++;
	 dTheta += dThetaWidth;
	 StartMove(nTheta,dTheta);
  }
  return CRecall;
};

TCCode TAreaScanCmd::ReadyStep(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TAreaScanCmd::ReadyStep(void)\n",time(zidx));
//pph***************************************************************************
  eStep = CReady;
  return CRecall;
};

//*****************************************************************************
//*****************************************************************************
//*****************************************************************************
//*****************************************************************************
//*****************************************************************************
TSteering::TSteering(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::TSteering(void)\n",time(zidx));
//pph***************************************************************************
  // Fuer Liste der aufrufenden Macros
  nCmdIdx          = -1;
  nMacroNumber    = 0;
  TheMacro        = NULL;
  TheCmd          = NULL;
  bSendReport     = FALSE;
  hReportList      = NULL;
  fNoiseLevel     = 300;
  bTimerActive     = FALSE;
  bSteeringActive = FALSE;
};

TSteering::Initialize(const HWND hwnd,const int mid,const int sensid)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::Initialize(const HWND hwnd,const int mid,const int sensid)\n",time(zidx));
//pph***************************************************************************
  Visualising(0,0,0,0,0,0);
  StartUp(hwnd,mid,sensid);
	if (!LoadMacro( "InquireHwb", "standard.mak" ))
	  return FALSE;
  if (!LoadMacro("SearchReflection","standard.mak" ))
	  return FALSE;
  if (!LoadMacro("SetupTopography","standard.mak"))
	  return FALSE;
  if (!LoadMacro("Test","standard.mak"))
	  return FALSE;
  if (!LoadMacro("AzimutalJustify","standard.mak"))
	  return FALSE;
  // AddMacro(MiddleOfValley,"MiddleOfValley","special.mak"};
  return TRUE;
};

BOOL TSteering::Reset(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::Reset(void)\n",time(zidx));
//pph***************************************************************************
  //*** clear old state
  StopTimer();
  if(TheCmd)
  {
	 delete TheCmd;
	 TheCmd = NULL;
  }
  TheMacro = NULL;
  nCmdIdx   = -1;
  bSteeringActive = FALSE;
  return TRUE;
};

BOOL TSteering::StartUp(const HWND hwnd,const int mid,const int sensid)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::StartUp(const HWND hwnd,const int mid,const int sensid)\n",time(zidx));
//pph***************************************************************************
  hControlWnd = hwnd;
  mlSetAxis(mid);
  Device = lpDList->DP(sensid);
  return TRUE;
};

void TSteering::Visualising(int a,int b,int c,int d,int e,int f)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::Visualising(int a,int b,int c,int d,int e,int f)\n",time(zidx));
//pph***************************************************************************
  bSendReport         = a;
  b_id_Angle          = b;
  b_id_PeakIntensity  = c;
  b_id_Intensity      = d;
  b_id_HalfWidth      = e;
  b_id_Report         = f;
  hReportList = (b_id_Report)?GetDlgItem(hControlWnd,id_Report):NULL;
};

int TSteering::StartCmdExecution(TCmdId cmdid,int p1,int p2,LPSTR p3,HWND host)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::StartCmdExecution(TCmdId cmdid,int p1,int p2,LPSTR p3,HWND host)\n",time(zidx));
//pph***************************************************************************
  TCmdTag ct;

  hHostWindow = host;
  ct.Id = cmdid;
  ct.P1 = (TCParam)p1;
  ct.P2 = (TCParam)p2;
  strcpy(ct.P3,p3);
  return StartCmdExecution(ct);
}

int TSteering::StartCmdExecution(TCmdTag Cmd)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::StartCmdExecution(TCmdTag Cmd)\n",time(zidx));
//pph***************************************************************************
  // Function tested; Last changes 950814
  if(TheCmd)
  {
	 delete TheCmd;
	 TheCmd = NULL;
  }
  Device->MeasureStop();
  Device->SetHost(hControlWnd);
  fIntensityNorm  = 0.0;
  nFailureId      = 0;
  bInterrupted    = FALSE;
  switch(Cmd.Id) {
	 case GotoPeak:
	 TheCmd = (TGotoPeakCmd*)new TGotoPeakCmd(Cmd);
	 break;
	 case GotoIntensity:
	 TheCmd = (TGotoIntensityCmd*)new TGotoIntensityCmd(Cmd);
	 break;
	 case ChooseAxis:
	 TheCmd = (TChooseAxisCmd*)new TChooseAxisCmd(Cmd);
	 break;
	 case ChooseDevice:
	 TheCmd = (TChooseDeviceCmd*)new TChooseDeviceCmd(Cmd);
	 break;
	 case SetupScan:
	 TheCmd = (TSetupScanCmd*)new TSetupScanCmd(Cmd);
	 break;
	 case SetWidth:
	 TheCmd = (TSetWidthCmd*)new TSetWidthCmd(Cmd);
	 break;
	 case Scan:
	 TheCmd = (TScanCmd*)new TScanCmd(Cmd);
	 break;
	 case ControlFlank:
	 TheCmd = (TControlFlankCmd*)new TControlFlankCmd(Cmd);
	 break;
	 case ShowValue:
	 TheCmd = (TShowValueCmd*)new TShowValueCmd(Cmd);
	 break;
	 case SetFileName:
	 TheCmd = (TSetFileNameCmd*)new TSetFileNameCmd(Cmd);
	 break;
	 case SaveData:
	 TheCmd = (TSaveDataCmd*)new TSaveDataCmd(Cmd);
	 break;
	 case Calculate:
	 TheCmd = (TCalculateCmd*)new TCalculateCmd(Cmd);
	 break;
	 case LoadPoint:
	 TheCmd = (TLoadPointCmd*)new TLoadPointCmd(Cmd);
	 break;
	 case MoveToPoint:
	 TheCmd = (TMoveToPointCmd*)new TMoveToPointCmd(Cmd);
	 break;
	 case AreaScan:
	 TheCmd = (TAreaScanCmd*)new TAreaScanCmd(Cmd);
	 break;
	 default: return FALSE;
  }
  if(!TheCmd->nFailureId)
  {
	 bSteeringActive = TRUE;
	 StartTimer(0);
	 return TRUE;
  }
  return FALSE;
};

BOOL TSteering::ToggleInterrupt(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::ToggleInterrupt(void)\n",time(zidx));
//pph***************************************************************************
  // Function tested; Last changes 950814
  if(bInterrupted)
  {
	 // restart the action
	 bInterrupted = FALSE;
	 Device->MeasureStop();
	 Device->SetHost(GetControlWnd());
	 // Meeinstellungen erneut laden
	 Device->SetExposureValues(fExposureTime,dwExposureCounts,fFailure);
	 Device->MeasureStart();
	 bSteeringActive = TRUE;
  }
  else
  {
	 // interrupt the action
	 Device->MeasureStop();
	 StopTimer();
	 Device->SetHost(NULL);
	 bSteeringActive = FALSE;
	 Device->GetExposureValues(fExposureTime,dwExposureCounts,fFailure);
	 Device->PopSettings();
	 Device->MeasureStart();
	 bInterrupted = TRUE;
  }
  return bInterrupted;
};

BOOL TSteering::IsPositionValid(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::IsPositionValid(void)\n",time(zidx));
//pph***************************************************************************
  if(TheCmd)
	 return TheCmd->IsPositionValid();
  else
	 return FALSE;
};

void TSteering::WakeUp(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::WakeUp(void)\n",time(zidx));
//pph***************************************************************************
  // Function tested; Last changes 950814
  if(TheCmd->IsReady())
  {
	 ReadyReaction();
	 return;
  }
  switch(TheCmd->WakeUp()) {
	 case CMeasure:
	 if(bSendReport)
		if(TheCmd->GetShowData(MessageBuffer))
		  SendReport();
	 /*
	 if(bSendReport)
		SetStatus("Measure");
	 */
	 Device->MeasureStart();
	 if(bMonitorUsed)
		Monitor->MeasureStart();
	 break;

	 case CRecall:
	 /*
	 if(bSendReport)
		SetStatus("Recall");
	 */
	 StartTimer(1);
	 break;

	 case CReady:
	 ReadyReaction();
  }
  return;
};

BOOL TSteering::DeviceRequest(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::DeviceRequest(void)\n",time(zidx));
//pph***************************************************************************
  // Function tested; Last changes 950814
  Device->GetData(fIncomingIntensity);
  if(fIntensityNorm != 0.0)
	 fIncomingIntensity /= fIntensityNorm;
  switch(TheCmd->DoAction()) {
	 case CMeasure:
	 /*
	 if(bSendReport)
		SetStatus("Measure");
	 */
	 Device->MeasureStart();
	 if(bMonitorUsed)
		Monitor->MeasureStart();
	 break;
	 case CRecall:
	 /*
	 if(bSendReport)
		SetStatus("Recall");
	 */
	 StartTimer(1);
	 break;
	 case CReady:
	 ReadyReaction();
  }
  return TRUE;
};

BOOL TSteering::ReadyReaction(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::ReadyReaction(void)\n",time(zidx));
//pph***************************************************************************
  // Function tested; Last changes 950814
  if(bSendReport)
	 if(TheCmd->GetShowData(MessageBuffer))
		SendReport();
  if(TheMacro)
	 ExecuteNextCmd();
  else
	 NotifyCmdReady();
  return TRUE;
};

BOOL TSteering::StartMacroExecution(TMacroTag* Macro,HWND host)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::StartMacroExecution(TMacroTag* Macro,HWND host)\n",time(zidx));
//pph***************************************************************************
  // Function tested; Last changes 950814
  //! Absturzursache beseitigt
  if (!Macro)
	 return FALSE;
  if(!Macro->bIsReady && !bInterrupted)
  {
	 MessageBox(GetFocus(),"Das laufende Macro erst unterbrechen !","Meldung",MBINFO);
	 return FALSE;
  }
  nCmdIdx = 0;
  Device->MeasureStop();
  Device->SetHost(hControlWnd);
  hHostWindow = host;
  TheMacro = Macro;
  TheCmdList = Macro->CmdList;
  StartCmdExecution(TheCmdList[nCmdIdx]);
  return TRUE;
};

BOOL  TSteering::ExecuteNextCmd(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::ExecuteNextCmd(void)\n",time(zidx));
//pph***************************************************************************
  if(TheCmd->nFailureId)
  {
	 MessageBox(GetFocus(),"Makroausfhrung ist fehlgeschlagen !","Steuerung",MBSTOP);
	 if(TheCmd)
	 {
		delete TheCmd;
		TheCmd = NULL;
	 }
	 return FALSE;
  }
  if(TheCmd)
  {
	 delete TheCmd;
	 TheCmd = NULL;
  }
  // Function tested; Last changes 950814
  if(TheCmdList[nCmdIdx].Id == Inquire)
	 nCmdIdx += (bInquireResult)?2:1;
  else
	 nCmdIdx++;
  switch(TheCmdList[nCmdIdx].Id) {
	 case Stop:
	 // Kontrolle an Steuerfenster bergeben
	 NotifyMacroReady();
	 return FALSE;

	 case GotoLine:
	 nCmdIdx = TheCmdList[nCmdIdx].P1;
	 if((TheCmdList[nCmdIdx].Id == Stop) || (nCmdIdx > TheMacro->Length-1))
	 {
		NotifyMacroReady();
		return FALSE;
	 }
	 return TRUE;

	 default:
	 StartCmdExecution(TheCmdList[nCmdIdx]);
	 return TRUE;
  }
};

void TSteering::NotifyCmdReady(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::NotifyCmdReady(void)\n",time(zidx));
//pph***************************************************************************
  // Laeuft ein Macro, dann naechsten Befehl laden
  bSteeringActive = FALSE;
  Device->MeasureStop();
  Device->SetHost(NULL);
  Device->PopSettings();
  Device->MeasureStart();
  PostMessage(hHostWindow,WM_COMMAND,cm_SteeringReady,0l);
  hHostWindow = NULL;
};

void  TSteering::NotifyMacroReady(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::NotifyMacroReady(void)\n",time(zidx));
//pph***************************************************************************
  bSteeringActive = FALSE;
  Device->MeasureStop();
  Device->SetHost(NULL);
  Device->PopSettings();
  Device->MeasureStart();
  PostMessage(hHostWindow,WM_COMMAND,cm_SteeringReady,0l);
  hHostWindow = NULL;
};

float  TSteering::GetIntensity(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::GetIntensity(void)\n",time(zidx));
//pph***************************************************************************
  return fIncomingIntensity;
};

double TSteering::GetDistance(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::GetDistance(void)\n",time(zidx));
//pph***************************************************************************
  return mGetValue(Distance);
};

// #pragma codseg wecker
void CALLBACK _export RecallSteering(UINT,UINT,DWORD,DWORD,DWORD)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		RecallSteering(UINT,UINT,DWORD,DWORD,DWORD)\n",time(zidx));
//pph***************************************************************************
  // Function tested;  Last changes 950814
  Steering.bTimerActive = FALSE;
  ::nEvent = 0;
  PostMessage(GetFrameHandle(),wm_WakeUpSteering,0,0l);
  // Steering.WakeUp();
};

BOOL TSteering::StartTimer(int restart)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::StartTimer(int restart)\n",time(zidx));
//pph***************************************************************************
  // Function tested; Last changes 960322
  if(!bTimerActive)
  {
	 bTimerActive = TRUE;
	 if(restart)
		nAskIdx--;
	 else
		nAskIdx = nMaxAskNumber;
	 nEvent = timeSetEvent(nAskTicks,3,(LPTIMECALLBACK)RecallSteering,0,TIME_ONESHOT);
	 if(!nEvent)
		return FALSE;
  }
  else
	 return FALSE;
  return TRUE;
};

BOOL TSteering::StopTimer(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::StopTimer(void)\n",time(zidx));
//pph***************************************************************************
  // Function tested ; Last changes 960322
  if(!bTimerActive)
	 return TRUE;
  timeKillEvent(nEvent);
  bTimerActive = FALSE;
  nEvent = 0;
  return TRUE;
};

TMacroTag* TSteering::GetMacroById(TMacroId MacId)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::GetMacroById(TMacroId MacId)\n",time(zidx));
//pph***************************************************************************
  // Function tested ; Last changes 950811
  for(int idx = 0;idx < nMacroNumber;idx++)
	 if(MacId == aMacroList[idx].Id)
		if(aMacroList[idx].bIsReady)
		  return &aMacroList[idx];
		else
		  return NULL;
  return NULL;
};

TMacroTag* TSteering::GetMacroByNumber(int num)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::GetMacroByNumber(int num)\n",time(zidx));
//pph***************************************************************************
  // Function tested; Last changes 950813
  if(num < 0) return NULL;
  if(num > 19) return NULL;
  if(!nMacroNumber) return NULL;
  if(!aMacroList[num].bIsReady) return NULL;
  return &aMacroList[num];
}

TMacroTag* TSteering::GetMacroByName(LPSTR name)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::GetMacroByName(LPSTR name)\n",time(zidx));
//pph***************************************************************************
  // Function tested;  Last changes 950811
  for(int idx = 0;idx < nMacroNumber;idx++)
	 if(!strcmp(name,aMacroList[idx].Name))
		if(aMacroList[idx].bIsReady)
		  return &aMacroList[idx];
			else
		  return NULL;
  return NULL;
};

BOOL TSteering::GetFileLine(FILE* hFile,LPSTR dst,int dstsize)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::GetFileLine(FILE* hFile,LPSTR dst,int dstsize)\n",time(zidx));
//pph***************************************************************************
  // Function tested; Last changes 950811
  char   data[3];
  BOOL  EoL = FALSE;
  int   cnt = 0;
  //!  int   rdl;

  dst[cnt] = '\0';
  do
  {
	 if(!fread(data,1,1,hFile)) return FALSE;
	 switch(data[0]) {
		case '\n': case '\r':
		if(!EoL)
		  EoL = TRUE;
		continue;

		default:
		if(!EoL)
		{
		  dst[cnt++] = data[0];
		  break;
		}
		//!rdl = fseek(hFile,-1,SEEK_CUR);
			fseek(hFile,-1,SEEK_CUR);
		goto Ready;
	 }
  } while(cnt < dstsize);
Ready:
  dst[cnt] = '\0';
  if(cnt == dstsize)
	 return FALSE;
  return TRUE;
};

TCParam TSteering::ParsingCmdParam(LPSTR param)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::ParsingCmdParam(LPSTR param)\n",time(zidx));
//pph***************************************************************************
  // Function tested; Last changes 950811
  if(NULL == param) return (TCParam)0;
  if(param[0] > 'M')
  {
	 if(!strcmp(param,"Opposite"))           return Opposite;
	 if(!strcmp(param,"Peak"))               return Peak;
	 if(!strcmp(param,"Reflection"))         return Reflection;
	 if(!strcmp(param,"Relative"))           return Relative;
	 if(!strcmp(param,"Result"))             return Result;
	 if(!strcmp(param,"ScanResult"))         return ScanResult;
	 if(!strcmp(param,"SmallSide"))           return SmallSide;
	 if(!strcmp(param,"Standard"))           return Standard;
	 if(!strcmp(param,"Start"))               return Start;
	 if(!strcmp(param,"ToSmallerAngle"))      return ToSmallerAngle;
	 if(!strcmp(param,"ToSmallerAngle"))      return ToSmallerAngle;
	 return (TCParam)0;
  }
  if(param[0] > 'E')
  {
	 if(!strcmp(param,"ForAreaScan"))         return ForAreaScan;
	 if(!strcmp(param,"ForScan"))             return ForScan;
	 if(!strcmp(param,"Hwb"))                 return Hwb;
	 if(!strcmp(param,"IncreasePeak"))       return IncreasePeak;
	 if(!strcmp(param,"Interpolation"))       return Interpolation;
	 if(!strcmp(param,"LargeSide"))           return LargeSide;
	 if(!strcmp(param,"LastGoal"))           return LastGoal;
	 if(!strcmp(param,"List"))               return List;
	 if(!strcmp(param,"Max"))                 return Max;
	 if(!strcmp(param,"MaximizeCollimator"))  return MaximizeCollimator;
	 if(!strcmp(param,"MaximizeGradient"))   return MaximizeGradient;
	 if(!strcmp(param,"MaximizeTilt"))       return MaximizeTilt;
	 if(!strcmp(param,"Middle"))             return Middle;
	 if(!strcmp(param,"Min"))                 return Min;
	 return (TCParam)0;
  }
  if(!strcmp(param,"AbsorberUsed"))       return AbsorberUsed;
  if(!strcmp(param,"AreaScanResult"))     return AreaScanResult;
  if(!strcmp(param,"Argument"))           return Argument;
  if(!strcmp(param,"Array"))               return Array;
  if(!strcmp(param,"BackMove"))           return BackMove;
  if(!strcmp(param,"DecreaseWidth"))       return DecreaseWidth;
  if(!strcmp(param,"DynamicWidth"))       return DynamicWidth;
  if(!strcmp(param,"Difference"))         return Difference;
  if(!strcmp(param,"Equidistant"))         return Equidistant;
  return (TCParam)0;
}

BOOL TSteering::ParsingCmd(TCmdTag& cmd,LPSTR pcmd,LPSTR p1,LPSTR p2,LPSTR p3)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::ParsingCmd(TCmdTag& cmd,LPSTR pcmd,LPSTR p1,LPSTR p2,LPSTR p3)\n",time(zidx));
//pph***************************************************************************
  // Function tested; Last changes 950811
  int         nFailure = 0;
  char        buf[MaxString];

  while(1)
  {
	 if(!strcmp(pcmd,"GotoPeak"))
	 {
		cmd.Id = GotoPeak;
		cmd.P1 = ParsingCmdParam(p1);
		break;
	 }
	 if(!strcmp(pcmd,"SaveData"))
	 {
		cmd.Id = SaveData;
		cmd.P1 = ParsingCmdParam(p1);
		switch(cmd.P1) {
		  case 0: nFailure = 5; break;
		  case ForScan: case ForAreaScan:
		  break;
		  default: nFailure = 2; break;
		}
		break;
	 }
	 if(!strcmp(pcmd,"SetFileName"))
	 {
		cmd.Id = SetFileName;
		cmd.P1 = ParsingCmdParam(p1);
		switch(cmd.P1) {
		  case 0: nFailure = 5; break;
		  case ForScan: case ForAreaScan:
		  strcpy(cmd.P3,strtok(p2," "));
		  break;
		  default: nFailure = 2; break;
		}
		break;
	 }
	 if(!strcmp(pcmd,"SetupAreaScan"))
	 {
		cmd.Id = SetupAreaScan;
		cmd.P1 = (TCParam)ParsingXScanType(p1);
		switch(cmd.P1) {
		  case 0: nFailure = 5; break;
		  case StandardScan: case Omega2ThetaScan:
		  sprintf(cmd.P3,"%s ",p2);
		  strcat(cmd.P3,p3);
		  break;
		  default: nFailure = 2; break;
		}
		break;
	 }
	 if(!strcmp(pcmd,"SetupScan"))
	 {
		cmd.Id = SetupScan;
		cmd.P1 = (TCParam)ParsingXScanType(p1);
		switch(cmd.P1) {
		  case 0: nFailure = 5; break;
		  case StandardScan: case Omega2ThetaScan:
		  if(!p2 && !p3)
		  {
			 nFailure = 5;
			 break;
		  }
		  sprintf(cmd.P3,"%s ",p2);
		  strcat(cmd.P3,p3);
		  break;
		  default: nFailure = 2; break;
		}
		break;
	 }
	 if(!strcmp(pcmd,"Scan"))
	 {
		cmd.Id = Scan;
		cmd.P1 = ParsingCmdParam(p1);
		switch(cmd.P1) {
		  case 0: nFailure = 5; break;
		  case ForScan: case ForAreaScan:
		  cmd.P2 = (TCParam)ParsingXScanType(p2);
		  switch(cmd.P2) {
			 case 0: nFailure = 5; break;
			 case Omega2ThetaScan: case StandardScan:
			 break;
			 default: nFailure = 2; break;
		  }
		  break;
		  default: nFailure = 2; break;
		}
		break;
	 }
	 if(!strcmp(pcmd,"AreaScan"))
	 {
		cmd.Id = AreaScan;
		cmd.P1 = ParsingCmdParam(p1);
		switch(cmd.P1) {
		  case 0: nFailure = 5; break;
		  case ForAreaScan:
		  cmd.P2 = (TCParam)ParsingXScanType(p2);
		  switch(cmd.P2) {
			 case 0: nFailure = 5; break;
			 case Omega2ThetaScan: case StandardScan:
			 break;
			 default: nFailure = 2; break;
		  }
		  break;
		  default: nFailure = 2; break;
		}
		break;
	 }
	 if(!strcmp(pcmd,"ShowValue"))
	 {
		cmd.Id = ShowValue;
		cmd.P1 = ParsingCmdParam(p1);
		switch(cmd.P1) {
		  case 0: nFailure = 5; break;
		  case Reflection: case Hwb: break;
		  default: nFailure = 2; break;
		}
		break;
	 }
	 if(!strcmp(pcmd,"LoadPoint"))
	 {
		cmd.Id = LoadPoint;
		cmd.P1 = ParsingCmdParam(p1);
		switch(cmd.P1) {
		  case 0: nFailure = 5; break;
		  case Argument:
		  cmd.P2 = (TCParam)atoi(p2);
		  if((cmd.P2 > nMaxArg) || (cmd.P2 < 0))
			 nFailure = 3;
		  break;
		  case Start: case Peak: break;
		  default: nFailure = 2; break;
		}
		break;
	 }
	 if(!strcmp(pcmd,"SetWidth"))
	 {
		cmd.Id = SetWidth;
		if(0.0 != atof(p1))
		  strcpy(cmd.P3,p1);
		else
		  nFailure = 2;
		break;
	 }
	 if(!strcmp(pcmd,"MoveToPoint"))
	 {
		cmd.Id = MoveToPoint;
		cmd.P1 = ParsingCmdParam(p1);
		switch(cmd.P1) {
		  case Start: case Peak: case Result: case LastGoal:
		  break;

		  case Relative:
		  if(0.0 == atof(p2))
			 nFailure = 5;
		  else
			 strcpy(cmd.P3,p2);
		  break;

		  case 0:
		  if(0.0 == atof(p1))
			 nFailure = 5;
		  else
			 strcpy(cmd.P3,p1);
		  break;

		  default: nFailure = 2; break;
		}
		break;
	 }
	 if(!strcmp(pcmd,"Calculate"))
	 {
		cmd.Id = Calculate;
		cmd.P1 = ParsingCmdParam(p1);
		switch(cmd.P1) {
		  case Middle: case Hwb: case Difference: case Opposite: break;
		  default: nFailure = 2; break;
		}
		break;
	 }
	 if(!strcmp(pcmd,"Stop"))
	 {
		cmd.Id = Stop;
		break;
	 }
	 if(!strcmp(pcmd,"GotoLine"))
	 {
		cmd.Id = GotoLine;
		cmd.P1 = (TCParam)atof(p1);
		if((cmd.P1 <= 0) || (cmd.P1 > aMacroList[nMacroNumber].Length))
		  nFailure = 2;
		break;
	 }
	 if(!strcmp(pcmd,"GotoIntensity"))
	 {
		cmd.Id = GotoIntensity;
		cmd.P1 = ParsingCmdParam(p1);
		switch(cmd.P1) {
		  case SmallSide: case LargeSide:
		  if(0.0 != atof(p2))
		  {
			 strcpy(cmd.P3,p2);
			 break;
		  }
		  cmd.P2 = ParsingCmdParam(p2);
		  switch(cmd.P2) {
			 case Interpolation: case BackMove:
			 if(0.0 != atof(p3))
				strcpy(cmd.P3,strtok(p3," "));
			 else
			 {
				nFailure = 5;
				break;
			 }
			 break;

			 case 0: nFailure = 2; break;
			 default: nFailure = 4; break;
		  }
		  break;

		  case 0: nFailure = 2; break;
		  default: nFailure = 5; break;
		}
		break;
	 }
	 if(!strcmp(pcmd,"ControlFlank"))
	 {
		cmd.Id = ControlFlank;
		break;
	 }
	 if(!strcmp(pcmd,"ChooseAxis"))
	 {
		cmd.Id = ChooseAxis;
		cmd.P1 = (TCParam)mlParsingAxis(p1);
		if(!cmd.P1)
		  nFailure = 2;
		break;
	 }
	 if(!strcmp(pcmd,"ChooseDevice"))
	 {
		cmd.Id = ChooseDevice;
		cmd.P1 = (TCParam)dlParsingDevice(p1);
		if(!cmd.P1)
		  nFailure = 2;
		else
		{
		  if(p2)
		  {
			 sprintf(cmd.P3,"%s ",p2);
			 if(p3)
				strcat(cmd.P3,p3);
		  }
		}
		break;
	 }
	 cmd.Id = Stop;
	 nFailure = 1;
	 break;
  }
  if(nFailure)
  {
	 switch(nFailure) {
		case 1:
		sprintf(buf,"Makrobefehl >%s< wird nicht untersttzt !",pcmd);
		break;
		case 2:
		sprintf(buf,"Paramter %s fr >%s< wird nicht untersttzt !",p1,pcmd);
		break;
		case 3:
		sprintf(buf,"Paramter %s fr >%s< wird nicht untersttzt !",p2,pcmd);
		break;
		case 4:
		sprintf(buf,"Paramter %s fr >%s< wird nicht untersttzt !",p3,pcmd);
		break;
		case 5:
		sprintf(buf,"Paramter fr >%s< sind unvollstndig !",pcmd);
		break;
	 }
	 MessageBox(GetFocus(),buf,"Macro einlesen",MBINFO);
	 return FALSE;
  }
  return TRUE;
};

BOOL TSteering::ParsingMacroId(TMacroTag& macro,LPSTR name)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::ParsingMacroId(TMacroTag& macro,LPSTR name)\n",time(zidx));
//pph***************************************************************************
  // Function tested
  // Last changes 950811
  while(1)
  {
	 if(!strcmp(name,"SearchReflection"))
		{
		macro.Id = SearchReflection;
		strcpy(macro.Name,name);
		break;
	 }
	 if(!strcmp(name,"InquireHwb"))
	 {
		macro.Id = InquireHwb;
		strcpy(macro.Name,name);
		break;
	 }
	 if(!strcmp(name,"BatchMacro"))
	 {
		macro.Id = BatchMacro;
		strcpy(macro.Name,name);
		break;
	 }
	 if(!strcmp(name,"ScanJob"))
	 {
		macro.Id = ScanJob;
		strcpy(macro.Name,name);
		break;
	 }
	 if(!strcmp(name,"AreaScanJob"))
	 {
		macro.Id = AreaScanJob;
		strcpy(macro.Name,name);
		break;
	 }
	 if(!strcmp(name,"MiddleOfValley"))
	 {
		macro.Id = MiddleOfValley;
		strcpy(macro.Name,name);
		break;
	 }
	 if(!strcmp(name,"AzimutalJustify"))
	 {
		macro.Id = AzimutalJustify;
		strcpy(macro.Name,name);
		break;
	 }
	 if(!strcmp(name,"SetupTopography"))
	 {
		macro.Id = SetupTopography;
		strcpy(macro.Name,name);
		break;
	 }
	 if(!strcmp(name,"Test"))
	 {
		macro.Id = Test;
		strcpy(macro.Name,name);
		break;
	 }
	 macro.Id = (TMacroId)nMacroNumber;
	 sprintf(macro.Name,"Macro%d",nMacroNumber);
	 SetInfo("No Match for this Macro-Name.");
	 return FALSE;
  }
  for(int idx = 0;idx < nMacroNumber;idx++)
	 if(macro.Id == aMacroList[idx].Id)
	 {
		SetInfo("Macro is already loaded.");
		return FALSE;
	 }
  return TRUE;
};

BOOL TSteering::LoadMacro(LPSTR makname,LPSTR fn)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::LoadMacro(LPSTR makname,LPSTR fn)\n",time(zidx));
//pph***************************************************************************
  // Function tested
  // Last changes 950811
  FILE* hFile;
  int idx = nMacroNumber;
  char* token;
  char buf[MaxString+1];
  int cnt;
  LPSTR cmd, p1, p2, p3;

  hFile = fopen( fn, "r" );
  //! Makrodatei nicht im aktuellen Verzeichnis
  if(!hFile)
  {
	 MessageBox( GetFocus(), "Makrodatei fehlt!", fn, MBSTOP );
	 return FALSE;
  }
#ifndef __WIN32__
  // search for macro in file
  while(GetFileLine( hFile, buf, MaxString ))
  {
	 if(!strstr(buf,"[Common]"))
		continue;
	 while(GetFileLine(hFile,buf,MaxString))
	 {
		if(buf[0] == '#')
		  continue;
		token = strtok(buf," =\r\n\t");
		if(!strcmp(token,"Name"))
		{
		  token = strtok(NULL," =\r\n\t");
		  if(strcmp(makname,token))
			 break;
		  ParsingMacroId(aMacroList[idx],token);
		  strcpy(aMacroList[idx].FileName,fn);
		}
		if(!strcmp(token,"Length"))
		{
		  token = strtok(NULL," =\r\n\t");
		  aMacroList[idx].Length = atoi(token);
		}
		if(!strcmp(token,"[Commands]"))
		{
		  aMacroList[idx].CmdList =
				new TCmdTag[aMacroList[idx].Length];
		  cnt = 0;
		  while(GetFileLine(hFile,buf,MaxString))
		  {
			 if(buf[0] == '#')
				continue;
			 if((strstr(buf,"[End]")) || (cnt > aMacroList[idx].Length))
			 break;
			 //! Fehlerstabilisierung wenn [End] fehlt
			 if (strstr( buf, "[Common]" ))
			 {
				MessageBox( GetFocus(), "Kommandoliste unvollstaendig!", makname,
					 MBSTOP );
				return FALSE;
			 }
			 cmd = strtok(buf," \r\n\t");
			 p1 = strtok(NULL," \r\n\t");
			 p2 = strtok(NULL," \r\n\t");
			 p3 = strtok(NULL,"\r\n\t");
			 //! Fehlerhafte Befehle nicht mitzaehlen
			 if (ParsingCmd(aMacroList[idx].CmdList[cnt],cmd,p1,p2,p3))
				cnt++;
			 if(cnt == aMacroList[idx].Length)
				break;
		  }
		  aMacroList[idx].Length = cnt;
		  //! Zwischen [Commands] und [End] findet sich kein Kommando
		  if (!cnt)
		  {
			 MessageBox( GetFocus(), "Makro ohne Kommandos!", makname, MBSTOP );
			 return FALSE;
		  }
		  // the last command has to be Stop
		  aMacroList[idx].CmdList[cnt-1].Id = Stop;
		  aMacroList[nMacroNumber].bIsReady = TRUE;
		  nMacroNumber++;
		  // Falls das Makro schon existiert, wird das alte ersetzt
		  // siehe DeleteMacro();
		  idx = nMacroNumber - 1;
		  while(idx)
		  {
			 idx--;
			 if(!strcmp(aMacroList[nMacroNumber - 1].Name,aMacroList[idx].Name))
			 {
				delete aMacroList[idx].CmdList;
				idx++;
				while(idx < nMacroNumber)
				{
				  aMacroList[idx-1] = aMacroList[idx];
				  idx++;
				}
				nMacroNumber--;
				memset(&(aMacroList[nMacroNumber]),0,sizeof(TMacroTag));
				fclose(hFile);
				return TRUE;
			 }
		  }
		  fclose(hFile);
		  return TRUE;
		}
	 }
  }
#endif
  fclose(hFile);
  //! kein Makro bzw. Makro ohne "[Commands]"
  MessageBox( GetFocus(), "Makro fehlt!", makname, MBSTOP );
  return FALSE;
};

BOOL TSteering::DeleteMacro(TMacroTag* macro)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::DeleteMacro(TMacroTag* macro)\n",time(zidx));
//pph***************************************************************************
  int  idx = 0;

  if(!macro)
	 return FALSE;
  while(strcmp(aMacroList[idx].Name,macro->Name))
	 idx++;
  delete aMacroList[idx].CmdList;
  idx++;
  while(idx < nMacroNumber)
  {
	 aMacroList[idx-1] = aMacroList[idx];
	 idx++;
  }
  nMacroNumber--;
  memset(&(aMacroList[nMacroNumber]),0,sizeof(TMacroTag));
  return TRUE;
};

BOOL TSteering::LoadMacroByUser(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::LoadMacroByUser(void)\n",time(zidx));
//pph***************************************************************************
  char      fn[MAXPATH];

  sprintf( fn, "%s%s.%s", Main.szDirectory, "scan", "mak" );
	//! Fehlerfaelle beachten
  if (!LoadMacro( "ScanJob", fn ))
	  return FALSE;
  if (!LoadMacro( "AreaScanJob", fn ))
	  return FALSE;
  return TRUE;
};

int TSteering::CallMacro(TMacroTag*)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::CallMacro(TMacroTag*)\n",time(zidx));
//pph***************************************************************************
  /*
  if(pMacro == NewMacroPtr)
	 {
	 // Macro sollte sich nicht selbst aufrufen
//    nFailureId = 12;
	 CmdExecuted();
    return FALSE;
    }
  // Sichern von Einstellungen, die Befehlsbergreifend sind
  PushParam();
  return StartMacroExecution(NewMacroPtr);
  */
  return TRUE;
};

BOOL TSteering::IsMacroCalled(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::IsMacroCalled(void)\n",time(zidx));
//pph***************************************************************************
  if(nCmdIdx < 0)
    return FALSE;
  return TRUE;
};

int  TSteering::ReturnMacroCall(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::ReturnMacroCall(void)\n",time(zidx));
//pph***************************************************************************
  /*
  PopParam();
  nMacroStep++;
  StartCmdExecution(pMacro[nMacroStep]);
  */
  return TRUE;
};

void TSteering::SendReport(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSteering::SendReport(void)\n",time(zidx));
//pph***************************************************************************
  if(!bSendReport) return;
  if(!strlen(MessageBuffer)) return;
  if(hReportList)
    ListBox_AddString(hReportList,MessageBuffer);
  else
    SetInfo(MessageBuffer);
};

//******************************************************************************
//***************** Macro Execute **********************************************
//******************************************************************************
#ifdef GermanVersion
TMacroExecute::TMacroExecute():TModelessDlg("ExecuteMacro")
#else
TMacroExecute::TMacroExecute():TModelessDlg("ExecuteMacroEng")
#endif
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		#endif\n",time(zidx));
//pph***************************************************************************
  bInterrupted = FALSE;
  bActionCaused = FALSE;
};

BOOL TMacroExecute::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TMacroExecute::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM)\n",time(zidx));
//pph***************************************************************************
  int     idx;

  // Initialisieren der Ablaufsteuerung
  CheckDlgButton(hwnd,id_DetailedReport,Steering.IsResponding());
  CheckDlgButton(hwnd,id_SaveReport,TRUE);
  EnableWindow(GetDlgItem(hwnd,cm_Interrupt),bActionCaused);
  hMacroList = GetDlgItem(hwnd,id_ChooseMacro);
  idx = 0;
  while(1)
  {
    TheMacro = Steering.GetMacroByNumber(idx++);
    if(!TheMacro)
      break;
    ComboBox_AddString(hMacroList,TheMacro->Name);
  }
  TheMacro = Steering.GetMacroByNumber(0);
  ComboBox_SelectString(hMacroList,0,TheMacro->Name);
  FORWARD_WM_COMMAND(hwnd,cm_ParamSet,hwndCtl,0,SendMessage);
  return TRUE;
};

void TMacroExecute::Dlg_OnCommand(HWND hwnd,int cmd,HWND hwndCtl,UINT codeNotify)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TMacroExecute::Dlg_OnCommand(HWND hwnd,int cmd,HWND hwndCtl,UINT codeNotify)\n",time(zidx));
//pph***************************************************************************
  //!  static HWND   hDlgItem;
  int           id;
  TMacroId      OldId;

  switch(cmd)
  {
    case cm_CounterSet: //***********************************
    //** Ausgabe der aktuellen Position
    lpDList->DP()->UpdateDisplay();
    Steering.DeviceRequest();
    break;

    case cm_SteeringReady:
    EnableWindow(GetDlgItem(GetHandle(),cm_Start),TRUE);
    EnableWindow(GetDlgItem(GetHandle(),cm_Interrupt),FALSE);
    if(lpDList->DP()->bDeviceOpen)
      lpDList->DP()->MeasureStart();
    break;

    case cm_Start: //****************************************
    if(bInterrupted)
    {
      bInterrupted = Steering.ToggleInterrupt();
      PostMessage(GetHandle(),WM_COMMAND,(WPARAM)cm_ParamSet,0);
      PostMessage(GetHandle(),WM_COMMAND,(WPARAM)cm_ParamSet,0);
      break;
    }
    Steering.StartUp(GetHandle(),mlGetAxis(),lpDList->DP()->GetId());
    Steering.Visualising(1,0,0,0,1,1);
    if(Steering.StartMacroExecution(TheMacro,GetHandle()))
    {
      bActionCaused = TRUE;
      ListBox_ResetContent(GetDlgItem(GetHandle(),id_Report));
    }
    else
      MessageBox(GetHandle(),"Fehler beim Starten","Meldung",MBINFO);
    PostMessage(GetHandle(),WM_COMMAND,(WPARAM)cm_ParamSet,0);
    break;

    case cm_Interrupt:
    if(!bActionCaused)
      break;
    if(bInterrupted)  
    {
      // Macro beenden
      Steering.Reset();
      bActionCaused = FALSE;
      bInterrupted = FALSE;  
    }  
    else
      bInterrupted = Steering.ToggleInterrupt();
    PostMessage(GetHandle(),WM_COMMAND,(WPARAM)cm_ParamSet,0);
    break;

    case cm_ParamSet:
    #ifdef GermanVersion
    if(bActionCaused && bInterrupted)
    {
      SetWindowText(GetDlgItem(GetHandle(),cm_Start),"Weiter");
      SetWindowText(GetDlgItem(GetHandle(),cm_Interrupt),"Beenden");
    }
    else
    {
      SetWindowText(GetDlgItem(GetHandle(),cm_Start),"Start");
      SetWindowText(GetDlgItem(GetHandle(),cm_Interrupt),"Anhalten");
    }
    #else
    if(bActionCaused && bInterrupted)
    {
      SetWindowText(GetDlgItem(GetHandle(),cm_Start),"Continue");
      SetWindowText(GetDlgItem(GetHandle(),cm_Interrupt),"Stop");
    }
    else
    {
      SetWindowText(GetDlgItem(GetHandle(),cm_Start),"Start");
      SetWindowText(GetDlgItem(GetHandle(),cm_Interrupt),"Interrupt");
    }
    #endif
    EnableWindow(GetDlgItem(GetHandle(),cm_Start),bInterrupted == bActionCaused);
    EnableWindow(GetDlgItem(GetHandle(),cm_Interrupt),!(!bInterrupted && !bActionCaused));
    EnableWindow(GetDlgItem(GetHandle(),cm_DeleteMacro),!bActionCaused);
    EnableWindow(GetDlgItem(GetHandle(),cm_LoadMacro),!bActionCaused);
    break;

    case id_DetailedReport:
    Steering.SetResponse(!Steering.IsResponding());
    CheckDlgButton(GetHandle(),id_DetailedReport,Steering.IsResponding());
    break;

    case cm_LoadMacro:
    id = ComboBox_GetCount(hMacroList);
    while(id--)
      ComboBox_DeleteString(hMacroList,id);
    Steering.LoadMacroByUser();
    //! Diese (bisherige) Version fuegte am Ende der startbaren Makros eine
    //! Leerzeile ein, die bei Auswahl und anschl. Start zum Absturz fuehrte
    /*
    id = 0;
    for(;;)
      {
      TheMacro = Steering.GetMacroByNumber(id++);
      if(!TheMacro) break;
      ComboBox_AddString(hMacroList,TheMacro->Name);
      }
   */
      //! Workaround nutzt tatsaechliche Makro-Anzahl
    for(id = 0; id < Steering.GetMacroCount(); id++)
    {
      TheMacro = Steering.GetMacroByNumber(id);
      ComboBox_AddString(hMacroList,TheMacro->Name);
    }
    TheMacro = Steering.GetMacroByNumber(0);
    ComboBox_SelectString(hMacroList,0,TheMacro->Name);
    break;

    case cm_DeleteMacro:
    id = ComboBox_GetCount(hMacroList);
    while(id--)
      ComboBox_DeleteString(hMacroList,id);
    Steering.DeleteMacro(TheMacro);
    id = 0;
    while(1)
    {
      TheMacro = Steering.GetMacroByNumber(id++);
      if(!TheMacro)
        break;
      ComboBox_AddString(hMacroList,TheMacro->Name);
    }
    TheMacro = Steering.GetMacroByNumber(0);
    if(TheMacro)
      ComboBox_SelectString(hMacroList,0,TheMacro->Name);
    else
      ComboBox_SelectString(hMacroList,0,"");
    break;

    case id_ChooseMacro:
    switch(codeNotify)
    {
    case CBN_SELCHANGE:
      id = ComboBox_GetCurSel(hMacroList);
      if(CB_ERR == id)
        break;
      OldId = TheMacro->Id;
      TheMacro = Steering.GetMacroByNumber(id);
      if(!TheMacro)
        TheMacro = Steering.GetMacroByNumber(OldId);
      break;
    }
    break;

    default:
    TModelessDlg::Dlg_OnCommand(hwnd,cmd,hwndCtl,codeNotify);
  }
};

BOOL TMacroExecute::LeaveDialog(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TMacroExecute::LeaveDialog(void)\n",time(zidx));
//pph***************************************************************************
  int       count;
  int       hFile;
  HWND      hwndCtl;
  char      lpszBuffer[MaxString];
  OFSTRUCT  of;

  if(IsDlgButtonChecked(GetHandle(),id_SaveReport))
  {
    hwndCtl = GetDlgItem(GetHandle(),id_Report);
    hFile = OpenFile("macro.log",&of,OF_CREATE);
    MessageLine = ListBox_GetCount(hwndCtl);
    for(count = 0;count < MessageLine;count++)
    {
      ListBox_GetText(hwndCtl, count, lpszBuffer);
      _lwrite(hFile,(LPSTR)lpszBuffer,strlen(lpszBuffer));
      _lwrite(hFile,(LPSTR)"\n",strlen("\n"));
    }
    _lclose(hFile);
  }
  if(bActionCaused)
  {
    if(!bInterrupted)
      Steering.ToggleInterrupt();
    Steering.Reset();
  }
  return TRUE;
};

BOOL TMacroExecute::CanClose(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TMacroExecute::CanClose(void)\n",time(zidx));
//pph***************************************************************************
  return TRUE;
};
//*****************************************************************************
void TEditWindow::SetFocus()
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TEditWindow::SetFocus()\n",time(zidx));
//pph***************************************************************************
  SetFocus();
};

TEditWindow::TEditWindow(LPSTR aFileName) : TMDIWindow()
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TMDIWindow()\n",time(zidx));
//pph***************************************************************************
  bIsNewFile   = TRUE;
  bFileChanged = FALSE;
  if(aFileName)
    lstrcpy((LPSTR)FileName,aFileName);
  // Registrieren der Kindfenster-Klasse
  TMDIWindow::RegisterWnd();
  WindowType = W_EditWindow;
};

TEditWindow::~TEditWindow()
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TEditWindow::~TEditWindow()\n",time(zidx));
//pph***************************************************************************
};

void TEditWindow::Create(HWND hwnd)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TEditWindow::Create(HWND hwnd)\n",time(zidx));
//pph***************************************************************************
  hWndChild = hwnd;
  if(strcmp(FileName,"")) ReadFile();
  SetTitle();
};

void TEditWindow::Size(HWND hWnd,WPARAM,LPARAM)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TEditWindow::Size(HWND hWnd,WPARAM,LPARAM)\n",time(zidx));
//pph***************************************************************************
  GetWindowRect(hWnd,&WndRect);
};

BOOL TEditWindow::SetTitle()
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TEditWindow::SetTitle()\n",time(zidx));
//pph***************************************************************************
  char  aTitle[MaxString];

  strcpy(aTitle,"Text:");
  if(strcmp(FileName,""))
    strcat(aTitle,FileName);
  else
  {
    strcat(aTitle,"<untitled.txt>");
    bFileChanged = TRUE;
  }
  SetWindowText(hWndChild,(LPSTR)aTitle);
  return TRUE;
};

void TEditWindow::Paint(HDC hdc,PAINTSTRUCT *ps)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TEditWindow::Paint(HDC hdc,PAINTSTRUCT *ps)\n",time(zidx));
//pph***************************************************************************
  char          buf[MaxString];
  HFONT         hFont;

  SetMapMode(hdc,MM_TEXT);
  LOGFONT lf;
  memset(&lf,0,sizeof(LOGFONT));
  lf.lfHeight = 12;
  lf.lfWidth  = 4;
  lf.lfWeight  = 600;
  lf.lfUnderline  = FALSE;
  lstrcpy(lf.lfFaceName,"Courier New");
  hFont = CreateFontIndirect(&lf);
  testobc = SelectObject(hdc,hFont);
  // Zeichnen der Daten
  sprintf(buf,"%s","Text");
  DrawText(hdc,(LPSTR)buf,strlen(buf)-1,&(ps->rcPaint),DT_RIGHT|DT_SINGLELINE);
  DeleteObject(hFont);
};

BOOL TEditWindow::CanClear()
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TEditWindow::CanClear()\n",time(zidx));
//pph***************************************************************************
  char     buf[MaxString];
  int     rslt;

  if(IsModified())
  {
    if(!FileName)
      strcpy(buf,"Untitled file has changed. Save?");
    else
      sprintf(buf,"File \"%s\" has changed .  Save?", FileName);
    rslt = MessageBox(hWndChild,buf,"File Changed",MB_YESNO | MB_ICONQUESTION);
    return (rslt == IDYES ? SaveFile(0) : rslt != IDNO);
  }
  else
    return TRUE;
};

BOOL TEditWindow::ReadFile()
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TEditWindow::ReadFile()\n",time(zidx));
//pph***************************************************************************
  BOOL  ret = TRUE;
  return ret;
};

BOOL TEditWindow::NewFile()
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TEditWindow::NewFile()\n",time(zidx));
//pph***************************************************************************
  if(CanClear())
  {
    ClearWindow();
    ClearModify();
    bIsNewFile = TRUE;
    strcpy(FileName,"");
    SetTitle();
  }
  return TRUE;
};

BOOL TEditWindow::SaveFile(int)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TEditWindow::SaveFile(int)\n",time(zidx));
//pph***************************************************************************
  if(IsModified())
    if(FileName)
      // Inhalt des Fensters speichern
      ;  
    else
      return SaveFileAs();
  return TRUE;
};

void TEditWindow::rButtonDown(LONG lParam)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TEditWindow::rButtonDown(LONG lParam)\n",time(zidx));
//pph***************************************************************************
  HMENU hMenu = CreatePopupMenu();
  POINT  pp;

  AppendMenu(hMenu,MF_STRING,-1,"Item");
  pp.x = LOWORD(lParam);
  pp.y = HIWORD(lParam);
  ClientToScreen(hWndChild,&pp);
  TrackPopupMenu(hMenu,0,pp.x,pp.y,0,hWndChild,NULL);
  DestroyMenu(hMenu);
};

//************ Benutzer-Schnittstelle fuer die Justage ************************
TSetAdjustmentParam::TSetAdjustmentParam(void) : TModalDlg("AdjustmentParam")
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TModalDlg(AdjustmentParam)\n",time(zidx));
//pph***************************************************************************
};

#pragma argsused
BOOL TSetAdjustmentParam::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSetAdjustmentParam::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)\n",time(zidx));
//pph***************************************************************************
  SetFocus(GetDlgItem(TModalDlg::GetHandle(), id_Level));
  FORWARD_WM_COMMAND(hwnd,cm_ParamSet,hwndCtl,0,SendMessage);
  return TRUE;
};

void TSetAdjustmentParam::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify) 
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSetAdjustmentParam::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify\n",time(zidx));
//pph***************************************************************************
  switch(id)
  {
    case cm_ParamSet:
    GetParameter();
    break;

    default:
    TModalDlg::Dlg_OnCommand(hwnd,id,hwndCtl,codeNotify);
  }
};

void TSetAdjustmentParam::GetParameter(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSetAdjustmentParam::GetParameter(void)\n",time(zidx));
//pph***************************************************************************
  char    buf[MaxString];

  sprintf(buf,"%.2f",AdjustmentParameter.fFailure);
  SetDlgItemText(GetHandle(),id_Failure,(LPSTR)buf);
  sprintf(buf,"%.2f",AdjustmentParameter.fNoiseLevel);
  SetDlgItemText(GetHandle(),id_NoiseLevel,(LPSTR)buf);
};

void TSetAdjustmentParam::SetParameter(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSetAdjustmentParam::SetParameter(void)\n",time(zidx));
//pph***************************************************************************
  char    buf[MaxString];

  GetDlgItemText(GetHandle(),id_Failure,(LPSTR)buf,12);
  AdjustmentParameter.fFailure = atof(buf);
  GetDlgItemText(GetHandle(),id_NoiseLevel,(LPSTR)buf,12);
  AdjustmentParameter.fNoiseLevel = atof(buf);
};

BOOL TSetAdjustmentParam::CanClose(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSetAdjustmentParam::CanClose(void)\n",time(zidx));
//pph***************************************************************************
  SetParameter();
  return TRUE;
};

BOOL TSetAdjustmentParam::LeaveDialog(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TSetAdjustmentParam::LeaveDialog(void)\n",time(zidx));
//pph***************************************************************************
  return TRUE;
};

//******************************************************************************
//***************** Justage-Dialog  ********************************************
//******************************************************************************
TAdjustmentParameter::TAdjustmentParameter(void)
{
//hpp***************************************************************************
trace = fopen("trace.dev","w");
setbuf(trace,(char*)NULL);
//pph**********************************************************
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TAdjustmentParameter::TAdjustmentParameter(void)\n",time(zidx));
//pph***************************************************************************
  fNoiseLevel         = 800;
  dAngleRange         = 3;
  fFailure            = 0.05;
};

TAdjustmentExecute::TAdjustmentExecute(int):TModalDlg("Adjustment")
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TAdjustmentExecute::TAdjustmentExecute(int):TModalDlg(Adjustment)\n",time(zidx));
//pph***************************************************************************
  bInterrupt = FALSE;
  //** Initialisierung des Detektor
  Device = lpDList->DP();
};

#pragma argsused
BOOL TAdjustmentExecute::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TAdjustmentExecute::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)\n",time(zidx));
//pph***************************************************************************
  char    buf[MaxString];
  int     i;
  // Initialisieren der Ablaufsteuerung
  nMotor = mlGetAxis();
  Steering.StartUp(GetHandle(),nMotor,Device->GetId());
  Steering.Visualising(1,0,0,0,1,1);
  CheckDlgButton(GetHandle(),id_DetailedReport,Steering.IsResponding());
  CheckDlgButton(GetHandle(),id_SaveReport,TRUE);
  SetDlgItemText(GetHandle(),cm_RotateMotor,mGetAxisName());
  sprintf(buf,mGetSF(),mGetValue(Width));
  SetDlgItemText(GetHandle(),id_AngleWidth,(LPSTR)buf);
  SetDlgItemText(GetHandle(),id_StepUnit,(LPSTR)mGetAxisUnit());
  EnableWindow(GetDlgItem(GetHandle(),cm_Interrupt),bActionCaused);
  GetParameter(); // aendern
  hMotorList = GetDlgItem(GetHandle(),id_ChooseMotor);
  i = 0;
  while(i < mlGetAxisNumber())
  {
    mlSetAxis(i++);
    ComboBox_AddString(hMotorList,mGetAxisName());
  }
  mlSetAxis(nMotor);
  FORWARD_WM_COMMAND(hwnd,cm_ParamSet,hwndCtl,0,PostMessage);
  return TRUE;
};

void TAdjustmentExecute::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TAdjustmentExecute::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)\n",time(zidx));
//pph***************************************************************************
  static HWND   hDlgItem = NULL;
  int           idx;
  char          buf[MaxString];

  switch(id)
  {
    case cm_CounterSet: //***********************************
    //** Ausgabe der aktuellen Position
    Device->UpdateDisplay();
    sprintf(buf,mGetDF(),mGetValue(Distance));
    SetDlgItemText(GetHandle(),id_Angle,(LPSTR)buf);
    Steering.DeviceRequest();
    break;

    case cm_SteeringReady:
    if(!Steering.StartMacroExecution(GetNextTask(),GetHandle()))
    {
      EnableWindow(GetDlgItem(GetHandle(),cm_Start),TRUE);
      EnableWindow(GetDlgItem(GetHandle(),cm_Interrupt),FALSE);  
    }
    break;

    case cm_Start: //****************************************
    // Nutzer-Einstellungen ermitteln
    bReflectionSearch     = IsDlgButtonChecked(GetHandle(),id_ReflectionSearch);
    bAzimutalAdjustment   = IsDlgButtonChecked(GetHandle(),id_AzimutalAdjustment);
    bFinalAdjustment      = IsDlgButtonChecked(GetHandle(),id_FinalAdjustment);
    bSearchStartPosition  = IsDlgButtonChecked(GetHandle(),id_SearchStartPosition);
    bGetPeakProperties    = IsDlgButtonChecked(GetHandle(),id_GetPeakProperties);
    bCheckMacro           = IsDlgButtonChecked(GetHandle(),id_Test);
    if(Steering.StartMacroExecution(GetNextTask(),GetHandle()))
    {
      bActionCaused = TRUE;
      EnableWindow(GetDlgItem(GetHandle(),cm_Start),!bActionCaused);
      EnableWindow(GetDlgItem(GetHandle(),cm_Interrupt),bActionCaused);
      ListBox_ResetContent(GetDlgItem(GetHandle(),id_Report));  
    } 
    else
    {
      sprintf(buf,"Kein Makro ausgewhlt !");
      MessageBox(GetHandle(),(LPSTR)buf,"Meldung",MB_OK | MB_ICONHAND);
    }
    break;

    case cm_ParamSet:
    ComboBox_SelectString(hMotorList,0,mGetAxisName());
    sprintf(buf,mGetSF(),mGetValue(Width));
    SetDlgItemText(GetHandle(),id_AngleWidth,(LPSTR)buf);
    SetDlgItemText(GetHandle(),id_StepUnit,mGetAxisUnit());
    break;

    case id_DetailedReport:
    Steering.SetResponse(!Steering.IsResponding());
    CheckDlgButton(GetHandle(),id_DetailedReport,Steering.IsResponding());
    break;

    case cm_RotateMotor:
    mlSetAxis(nMotor++);
    nMotor = mlGetAxis();
    FORWARD_WM_COMMAND(GetHandle(),cm_ParamSet,0,0,PostMessage);
    break;

    case id_ChooseMotor:
    switch(codeNotify)
    {
      case CBN_SELCHANGE:
      idx = ComboBox_GetCurSel(hMotorList);
      if((nMotor != idx) && (idx != CB_ERR))
      {
        mlSetAxis(idx);
        nMotor = mlGetAxis();
        FORWARD_WM_COMMAND(GetHandle(),cm_ParamSet,0,0,PostMessage);
      }
    }
    break;

    case id_AngleWidth:
    hDlgItem = GetDlgItem(GetHandle(),id_AngleWidth);
    break;

    case IDOK:
    if(!hDlgItem)
    {
      TModalDlg::Dlg_OnCommand(hwnd,id,hwndCtl,codeNotify);
      break;
    }
    // Der Nutzer hat mit Return eine neue Schrittweite eingegeben
    if(hDlgItem == GetDlgItem(GetHandle(),id_AngleWidth))
    {
      GetDlgItemText(GetHandle(),id_AngleWidth,(LPSTR)buf,10);
      mSetValue(Width,atof(buf));
      sprintf(buf,mGetSF(),mGetValue(Width));
      SetDlgItemText(GetHandle(),id_AngleWidth,(LPSTR)buf);
    }
    SetFocus(GetDlgItem(GetHandle(),cm_Start));
    hDlgItem = NULL;
    break;

    case cm_Interrupt:
    bInterrupt = Steering.ToggleInterrupt();
    EnableWindow(GetDlgItem(GetHandle(),cm_Start),bInterrupt);
    EnableWindow(GetDlgItem(GetHandle(),cm_Interrupt),!bInterrupt);
    break;

    default:
    TModalDlg::Dlg_OnCommand(hwnd,id,hwndCtl,codeNotify);
  }
};

TMacroTag* TAdjustmentExecute::GetNextTask(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TAdjustmentExecute::GetNextTask(void)\n",time(zidx));
//pph***************************************************************************
  // Es wird stets eine gewisse Reihenfolge beibehalten
  if(bReflectionSearch)
  {
    bReflectionSearch = FALSE;
    Device->SetExposureValues(0.7,3000,0.05);
    return Steering.GetMacroById(SearchReflection);
  }
  if(bAzimutalAdjustment)
  {
    bAzimutalAdjustment = FALSE;
    return Steering.GetMacroById(AzimutalJustify);
  }
  if(bSearchStartPosition)
  {
    bSearchStartPosition = FALSE;
    return Steering.GetMacroById(SearchReflection);
  }
  if(bFinalAdjustment)
  {
    bFinalAdjustment = FALSE;
    //return aMacroFinalAdjustment;
    return Steering.GetMacroById(SearchReflection);  
  }
  if(bGetPeakProperties)  
  {
    bGetPeakProperties = FALSE;
    return Steering.GetMacroById(InquireHwb);  
  }
  if(bCheckMacro)  
  {
    bCheckMacro = FALSE;
    return Steering.GetMacroById(Test);  
  }
  return NULL;  
};

void TAdjustmentExecute::GetParameter(void)  
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TAdjustmentExecute::GetParameter(void\n",time(zidx));
//pph***************************************************************************
  Steering.SetNoiseLevel(AdjustmentParameter.fNoiseLevel);
};

BOOL TAdjustmentExecute::LeaveDialog(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TAdjustmentExecute::LeaveDialog(void)\n",time(zidx));
//pph***************************************************************************
  int       count;
  int       hFile;
  HWND      hwndCtl;
  char      lpszBuffer[MaxString];
  OFSTRUCT  of;

  if(Device->bDeviceOpen)
    Device->MeasureStart();
  if(IsDlgButtonChecked(GetHandle(),id_SaveReport))  
  {
    hwndCtl = GetDlgItem(GetHandle(),id_Report);
    hFile = OpenFile("jplogl.txt",&of,OF_CREATE);
    MessageLine = ListBox_GetCount(hwndCtl);
    for(count=0;count<MessageLine;count++) 
    {
      ListBox_GetText(hwndCtl, count, lpszBuffer);
      _lwrite(hFile,(LPSTR)lpszBuffer,strlen(lpszBuffer));
      _lwrite(hFile,(LPSTR)"\n",strlen("\n"));
    }
    _lclose(hFile);
  }
  return TRUE;
};

BOOL TAdjustmentExecute::CanClose(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TAdjustmentExecute::CanClose(void)\n",time(zidx));
//pph***************************************************************************
  return TRUE;
};

//##############################################################################
TAdjustmentWindow::TAdjustmentWindow(void) : TPlotData()
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TPlotData()\n",time(zidx));
//pph***************************************************************************
   //!
  HMENU   /*hM1,*/hM2;

  bInterrupted    = FALSE;
  bMacroRunning   = FALSE;

  // Registrieren der Kindfenster-Klasse
  WindowType = W_AdjustmentWindow;
  TMDIWindow::RegisterWnd();
  bMeasurementActive = FALSE;
  strcpy(FileName,"");
  TheMenu = CreatePopupMenu();
  //!  hM1 = CreatePopupMenu();
  hM2 = CreatePopupMenu();
  AppendMenu(TheMenu,MF_STRING,cm_Adjustment,"&Automatische Justage");
  AppendMenu(TheMenu,MF_STRING,cm_ShowCurveParam,"&Darstellungs-Optionen...");
  AppendMenu(TheMenu,MF_STRING,cm_AdjustmentParam,"Justage &Parameter");
  AppendMenu(TheMenu,MF_SEPARATOR,0,NULL);
  AppendMenu(hM2,MF_STRING,cm_FreezeCurve,"&Einfangen");
  AppendMenu(hM2,MF_STRING,cm_KillSecondCurve,"&Lschen");
  AppendMenu(hM2,MF_STRING,cm_SaveSecondCurve,"&Speichern");
  AppendMenu(TheMenu,MF_POPUP,(WORD)hM2,"&Vergleichs-Scan");
  AdjData = (TCurve*) new TCurve(50);
  AdjData->SetOrder(Y_Sorted);
  MainCurve = (TCurve*) new TCurve(50);
  AdjWnd = this;
};

TAdjustmentWindow::~TAdjustmentWindow()
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TAdjustmentWindow::~TAdjustmentWindow()\n",time(zidx));
//pph***************************************************************************
  Main.hAdjustmentWindow = NULL;
  delete AdjData;
  delete MainCurve;
  DestroyMenu(TheMenu);
};

BOOL TAdjustmentWindow::CanClose(void)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TAdjustmentWindow::CanClose(void)\n",time(zidx));
//pph***************************************************************************
  if(!TMDIWindow::CanClose())
    return FALSE;
  return TRUE;
};

void TAdjustmentWindow::Create(HWND hwnd)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TAdjustmentWindow::Create(HWND hwnd)\n",time(zidx));
//pph***************************************************************************
  hWndChild = hwnd;
  Main.hAdjustmentWindow = hwnd;
  Main.AdjustmentWindow = this;
  SetTitle();
  Delay(1000);
  UpdateMenu();
};

BOOL TAdjustmentWindow::SetTitle()
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TAdjustmentWindow::SetTitle()\n",time(zidx));
//pph***************************************************************************
  char  aTitle[MaxString];

  strcpy(aTitle,"Justagen");
  SetWindowText(hWndChild,(LPSTR)aTitle);
  return TRUE;
};

void TAdjustmentWindow::InitializeTask(WPARAM,LPARAM)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TAdjustmentWindow::InitializeTask(WPARAM,LPARAM)\n",time(zidx));
//pph***************************************************************************
};

//********* Schnittstellen fr Ablaufsteuerung *********************************
void TAdjustmentWindow::CounterSetRequest(LPARAM lParam)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TAdjustmentWindow::CounterSetRequest(LPARAM lParam)\n",time(zidx));
//pph***************************************************************************
  if(bContinuousScanActive)
  {
    float  x,y,z = 0.0;

    x = mGetValue(Width) * (lParam);//lpMList->MP()->GetAngle(1);
    lpDList->DP()->GetData(y);
    MainCurve->PAdd(x,y,z);
    //if(lParam % 3)
      UpdateWnd(O_PaintPoint);
    return;
  }
  // Funktion behandelt Meldung cm_CounterSet
  Steering.DeviceRequest();
};

void TAdjustmentWindow::SteeringReady(LPARAM)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TAdjustmentWindow::SteeringReady(LPARAM)\n",time(zidx));
//pph***************************************************************************
  // Funktion behandelt Meldung cm_CmdExecuted
  // Scan wurde ausgefuehrt
  if(bContinuousScanActive)
  {
    mStopDrive(TRUE);
    bContinuousScanActive = FALSE;
    MessageBox(GetFocus(),"ContinuousScan wurde ausgefuehrt !","Justagen",MBINFO);
  }
};

//***************** Mausbedienung **********************************************
void TAdjustmentWindow::rButtonDown(LONG lParam)
{
//hpp***************************************************************************
fprintf(trace,"%u		m_steerg.cpp		TAdjustmentWindow::rButtonDown(LONG lParam)\n",time(zidx));
//pph***************************************************************************
  POINT    pp;

  pp.x = LOWORD(lParam);
  pp.y = HIWORD(lParam);
  ClientToScreen(hWndChild,&pp);
  TrackPopupMenu(TheMenu,0,pp.x,pp.y,0,hWndChild,NULL);
};
//******************************************************************************
//******************************************************************************
// __LastLine__



